2022-08-26  Keith Marshall  <keith@users.osdn.me>

	Do not expose private declarations in <search.h>

	* include/search.h [_SEARCH_PRIVATE]: Do not consider.
	(struct node, node_t, __MINGW_NONNULL): Relocate [re]definitions...
	* mingwex/tsearch.h: ...to this new (private) header file.

	* mingwex/tdelete.c mingwex/tfind.c mingwex/tsearch.c
	* mingwex/twalk.c: Include "tsearch.h" in each, in place of
	<search.h>; (the latter will be indirectly included by the former).
	(_SEARCH_PRIVATE): Remove definition; it is no longer required.

2022-08-15  Keith Marshall  <keith@users.osdn.me>

	Correct project name references in mingwrt manpages.

	* man/btowc.3.man man/dirname.3.man man/getline.3.man man/mbrlen.3.man
	* man/mbrtowc.3.man man/mbsinit.3.man man/mbsrtowcs.3.man
	* man/wcrtomb.3.man man/wcsrtombs.3.man man/wctob.3.man: Replace all
	references to defunct "MinGW.org" project name; refer to "MinGW.OSDN"
	instead.

2022-08-15  Keith Marshall  <keith@users.osdn.me>

	Correct project name references in mingwrt source files.

	* README CRT_fenv.c Makefile.in configure.ac cpu_features.sx crt1.c
	* setargv.c include/_mingw.h.in include/alloca.h include/conio.h
	* include/ctype.h include/dir.h include/direct.h include/dlfcn.h
	* include/dos.h include/errno.h include/excpt.h include/fenv.h
	* include/float.h include/getopt.h include/glob.h include/io.h
	* include/libgen.h include/limits.h include/locale.h include/malloc.h
	* include/math.h include/msvcrtver.h include/process.h
	* include/stdint.h include/stdio.h include/stdlib.h include/string.h
	* include/strings.h include/time.h include/unistd.h include/wchar.h
	* include/wctype.h include/sys/bsdtypes.h include/sys/stat.h
	* include/sys/time.h include/sys/timeb.h include/sys/types.h
	* include/sys/utime.h mingwex/basename.c mingwex/btowc.c
	* mingwex/clockapi.c mingwex/clockapi.h mingwex/clockres.c
	* mingwex/clockset.c mingwex/clocktime.c mingwex/codeset.c
	* mingwex/complex/cabs_generic.c mingwex/complex/casin_generic.c
	* mingwex/complex/catan_generic.c mingwex/complex/clog_generic.c
	* mingwex/complex/cpow_generic.c mingwex/complex/csqrt_generic.c
	* mingwex/cryptnam.c mingwex/dirent.c mingwex/dirname.c
	* mingwex/dlfcn.c mingwex/fesetenv.c mingwex/ftruncate.c
	* mingwex/glob.c mingwex/imaxdiv.c mingwex/insque.c mingwex/jmpstub.sx
	* mingwex/math/asinh_generic.c mingwex/math/errno.sx
	* mingwex/math/fmod_generic.sx.in mingwex/math/hypot_generic.c
	* mingwex/math/log10_generic.sx mingwex/math/log1p_generic.sx
	* mingwex/math/log2_generic.sx mingwex/math/log_generic.sx
	* mingwex/math/pow_generic.sx mingwex/math/random.c
	* mingwex/math/remquo_generic.sx mingwex/math/x87cvt_generic.sx
	* mingwex/mbrconv.c mingwex/mbrlen.c mingwex/mbrscan.c
	* mingwex/mbrtowc.c mingwex/mbsrtowcs.c mingwex/memalign.c
	* mingwex/memcrypt.c mingwex/mkdtemp.c mingwex/mkstemp.c
	* mingwex/nsleep.c mingwex/ofmt.c mingwex/ofmtctl.c mingwex/remque.c
	* mingwex/setenv.c mingwex/stdio/fseeki64.c mingwex/stdio/ftelli64.c
	* mingwex/stdio/fwrite.c mingwex/stdio/getdelim.c
	* mingwex/stdio/pformat.c mingwex/stdio/snprintf.c
	* mingwex/stdio/vsnprintf.c mingwex/strerror_r.c mingwex/strnlen.sx
	* mingwex/strtok_r.c mingwex/wcharmap.c mingwex/wcharmap.h
	* mingwex/wcrtomb.c mingwex/wcsrtombs.c mingwex/wcstofp.c
	* mingwex/wctob.c tests/Makefile.in tests/ansiprintf.at
	* tests/atlocal.in tests/clockapi.at tests/headers.at
	* tests/logarithms.at tests/memalign.at tests/powerfunc.at
	* tests/testsuite.at.in: Replace all references to defunct "MinGW.org"
	project name; refer to "MinGW.OSDN" instead.

2022-01-29  Keith Marshall  <keith@users.osdn.me>

	Stop creating redundant "include/parts" directory.

	* Makefile.in (mingwrt_include_subdirs): Remove reference to...
	(parts): ...this; the directory is no longer used by mingwrt, so it
	need not be created when performing "make install".

2021-06-25  Keith Marshall  <keith@users.osdn.me>

	Correct Microsoft's dup2() POSIX.1 non-conformity.

	* include/unistd.h [! defined dup2]: Define macro reference to...
	(__mingw_posix_dup2): ...this new in-line function, (as named by the
	macro); it overrides the Microsoft dup2() function, to ensure that it
	returns the correct file descriptor, as specified by POSIX.1, rather
	than zero, as returned by the Microsoft implementation, on success.

2021-06-13  Keith Marshall  <keith@users.osdn.me>

	Implement a POSIX.1 compliant pseudo-random number generator.

	* mingwex/math/random.c: New file; it implements...
	(__mingw_random, __mingw_srandom, __mingw_initstate)
	(__mingw_setstate): ...each of these API functions.
	* include/stdlib.h [_XOPEN_SOURCE >= 500]: Declare them; map...
	(random, srandom, initstate, setstate): ...these aliases.
	[_BSD_SOURCE]: Likewise.

	* Makefile.in (libmingwex.a): Require random.$OBJEXT

2021-05-29  Keith Marshall  <keith@users.osdn.me>

	Correct erroneous mkstemp() availability condition.

	* include/stdlib.h (mkstemp): POSIX requires...
	[_XOPEN_SOURCE >= 500]: ...this, which is equivalent to...
	[_POSIX_C_SOURCE >= 199506L]: ...this, and not (as we had it)...
	[_POSIX_C_SOURCE >= 200112L]: ...this; correct it.

2021-05-23  Keith Marshall  <keith@users.osdn.me>

	Add a makefile clarification comment.

	* Makefile.in (msvcrt_repl_funcs): Explain inclusion...
	(free, realloc): ...these.

2021-04-11  Keith Marshall  <keith@users.osdn.me>

	Prepare and publish MinGW.org WSL-5.4.2 release.

	* All files (wsl-5.4.2-release): Tag assigned.

2021-02-25  Keith Marshall  <keith@users.osdn.me>

	Consolidate fmod() and remainder() source code.

	* mingwex/math/fmod_generic.sx.in: New file; it replaces...
	* mingwex/math/remainder.s mingwex/math/remainderf.s: ...these...
	* mingwex/math/remainderl.s mingwex/math/fmodf.c: ...and these...
	* mingwex/math/fmodl.c: ...and also this; delete them.

	* Makefile.in (fmod_generic.sx, remainder_generic.sx): Add rule to
	generate them.

2021-02-24  Keith Marshall  <keith@users.osdn.me>

	Correct remquo() quotient computation; cf. MinGW-Bug #41597

	* mingwex/math/remquo_generic.sx: New file; it replaces...
	* mingwex/math/remquo.s mingwex/math/remquof.s: ...these, and also...
	* mingwex/math/remquol.s: ...this; delete them.

	* Makefile.in (libmingwex.a): Add "x87remquo.$OBJEXT" requirement.

2021-01-26  Keith Marshall  <keith@users.osdn.me>

	Avoid proliferation of static snprintf() implementations.

	* mingwex/dlfcn.c (dlfcn_store_error_message): Do NOT use...
	(vsnprintf): ...this static inline function; prefer to call...
	(__mingw_vsnprintf): ...this extern implementation, directly.

	* mingwex/dlfcn.c (dlfcn_strerror)
	* mingwex/setenv.c (__mingw_setenv)
	* mingwex/strerror_r.c (strerror_r): Do NOT use...
	(snprintf): ...this; it expands to create static clones of...
	(__mingw_snprintf): ...this extern implementation; prefer to call it
	directly, to avoid code redundancy.

2020-08-07  Keith Marshall  <keith@users.osdn.me>

	Initialize MSVCRT.DLL's _pgmptr reference.

	* setargv.c (_setargv) [__CRT_GLOB_USE_MINGW__]: Check for...
	[_pgmptr == NULL] (_pgmptr): ...uninitialized; initialize it from...
	(GetModuleFileName): ...this.

2020-07-23  Keith Marshall  <keith@users.osdn.me>

	Prepare and publish MinGW.org WSL-5.4.1 release.

	* All files (wsl-5.4.1-release): Tag assigned.

2020-07-20  Keith Marshall  <keith@users.osdn.me>

	Add support for emulation of Microsoft's rand_s() function.

	* mingwex/cryptnam.c (crypto_provider, crypto_randomize): Factor out
	this pair of static inline functions; relocate them to...
	* mingwex/memcrypt.c: ...this new file.
	(crypto_randomize): Change linkage to extern; rename it as...
	(__mingw_crypto_randomize): ...this; use it...
	* mingwex/cryptnam.c (crypto_random_filename_char): ...here, via...
	(crypto_randomize): ...this static inline reimplementation.

	* Makefile.in (libmingwex.a): Add dependency reference for...
	(memcrypt.$OBJEXT): ...this new object file.

	* VERSION.m4 (MINGW_AC_SET_DLLVERSION) [LIBMINGWEX]: Increment it
	to 5:0:1; __mingw_crypto_randomize adds a new interface, but it does
	not break ABI backward compatibility.

2020-07-08  Keith Marshall  <keith@users.osdn.me>

	Prepare and publish MinGW.org WSL-5.4 release.

	* All files (wsl-5.4-release): Tag assigned.

2020-07-07  Keith Marshall  <keith@users.osdn.me>

	Remove redundant MBCS/wide character converter aliases.

	* mingwex/btowc.c (__mingw_btowc, __msvcrt_btowc):
	* mingwex/mbrlen.c (__mingw_mbrlen, __msvcrt_mbrlen):
	* mingwex/mbrtowc.c (__mingw_mbrtowc, __msvcrt_mbrtowc):
	* mingwex/mbsrtowcs.c (__mingw_mbsrtowcs, __msvcrt_mbsrtowcs):
	* mingwex/wcsrtombs.c (__mingw_wcsrtombs, __msvcrt_wcsrtombs):
	* mingwex/wcrtomb.c (__mingw_wcrtomb, __msvcrt_wcrtomb):
	* mingwex/wctob.c (__mingw_wctob, __msvcrt_wctob): Delete aliases.

	* VERSION.m4 (MINGW_AC_SET_DLLVERSION) [LIBMINGWEX]: Increment it
	to 4:0:0; alias removal breaks ABI backward compatibility.

2020-07-06  Keith Marshall  <keith@users.osdn.me>

	Prepare and publish MinGW.org WSL-5.3.4 release.

	* All files (wsl-5.3.4-release): Tag assigned.

2020-07-05  Keith Marshall  <keith@users.osdn.me>

	Update MBCS to wide character conversion man pages.

	* man/btowc.3.man man/mbrlen.3.man man/mbrtowc.3.man
	* man/mbsinit.3.man man/mbsrtowcs.3.man man/wcrtomb.3.man
	* man/wcsrtombs.3.man man/wctob.3.man: Remove references to Microsoft
	implementations of documented functions; all means of access to such
	function implementations have been disabled for MinGW applications.

2020-07-04  Keith Marshall  <keith@users.osdn.me>

	Discontinue use of Microsoft's MBCS/wide character converters.

	* include/wchar.h (__mingw_redirect): Delete macro definition.
	(__mingw_mbrlen, __msvcrt_mbrlen, __mingw_mbrtowc, __msvcrt_mbrtowc)
	(__mingw_btowc, __msvcrt_btowc, __mingw_mbsrtowcs, __msvcrt_mbsrtowcs)
	(__mingw_wctob, __msvcrt_wctob, __mingw_wcrtomb, __msvcrt_wcrtomb)
	(__mingw_wcsrtombs, __msvcrt_wcsrtombs): Delete prototypes, and...
	(mbrlen, mbrtowc, btowc, mbsrtowcs, wctomb, wcrtomb, wcsrtombs):
	...their corresponding redirected inline implementations.

	* mingwex/btowc.c (__msvcrt_btowc): Delete implementation.
	(__mingw_btowc_fallback, __mingw_btowc): Fold together, into...
	(btowc): ...this publicly accessible function; add weak aliases...
	(__mingw_btowc, __msvcrt_btowc): ...named thus.

	* mingwex/mbrlen.c (__msvcrt_mbrlen): Delete implementation.
	(__mingw_mbrlen_fallback, __mingw_mbrlen): Fold together, into...
	(mbrlen): ...this publicly accessible function; factor out codeset
	and codeset property initializations; add weak aliases...
	(__mingw_mbrlen, __msvcrt_mbrlen): ...named thus.

	* mingwex/mbrtowc.c (__msvcrt_mbrtowc): Delete implementation.
	(__mingw_mbrtowc_fallback, __mingw_mbrtowc): Fold together, into...
	(mbrtowc): ...this publicly accessible function; factor out codeset
	and codeset property initializations; add weak aliases...
	(__mingw_mbrtowc, __msvcrt_mbrtowc): ...named thus.

	* mingwex/mbsrtowcs.c (__msvcrt_mbsrtowcs): Delete implementation.
	(__mingw_mbsrtowcs_fallback, __mingw_mbsrtowcs): Fold; rename as...
	(mbsrtowcs): ...this publicly accessible function; add weak aliases...
	(__mingw_mbsrtowcs, __msvcrt_mbsrtowcs): ...named thus.
	(__mbsrtowcs_fallback): Rename it as...
	(__mbsrtowcs_internal): ...this.

	* mingwex/mbrconv.c (__mingw_mbrtowc_handler): Initialize codeset.

	* mingwex/wcrtomb.c (__msvcrt_wcrtomb): Delete implementation.
	(__mingw_wcrtomb_fallback, __mingw_wcrtomb): Fold together, into...
	(wcrtomb): ...this publicly accessible function; add weak aliases...
	(__mingw_wcrtomb, __msvcrt_wcrtomb): ...named thus.
	(__wcrtomb_fallback): Rename it as...
	(__wcrtomb_internal): ...this.

	* mingwex/wcsrtombs.c (__mingw_wcsrtombs): Rename it as...
	(wcsrtombs): ...this ISO-C99 name; preserve delegation to...
	(__mingw_wcsrtombs_fallback): ...this, but rename it as...
	(__mingw_wcsrtombs_internal): ...this; inline it.
	(__msvcrt_wcsrtombs): Delete implementation.
	(__mingw_wcsrtombs, __msvcrt_wcsrtombs): Reinstate as weak aliases.

	* mingwex/wctob.c (__msvcrt_wctob): Delete implementation.
	(__mingw_wctob_fallback, __mingw_wctob): Fold together, into...
	(wctob): ...this publicly accessible function; add weak aliases...
	(__mingw_wctob, __msvcrt_wctob): ...named thus.

2020-06-03  Keith Marshall  <keith@users.osdn.me>

	Prepare and publish MinGW.org WSL-5.3.3 release.

	* All files (wsl-5.3.3-release): Tag assigned.

2020-06-03  Keith Marshall  <keith@users.osdn.me>

	Revert 2020-05-27 changes relating to issue #40438.

	* Makefile.in (libmingw32.a): Remove, and relocate...
	(codeset.$OBJEXT, mbrscan.$OBJEXT): ...each of these, back to...
	(libmingwex.a): ...here; the previous relocation created more problems
	than it solved, and indeed, I can no longer reproduce the issue which
	prompted the earlier relocation.

2020-05-28  Keith Marshall  <keith@users.osdn.me>

	Prepare and publish MinGW.org WSL-5.3.2 release.

	* All files (wsl-5.3.2-release): Tag assigned.

2020-05-28  Keith Marshall  <keith@users.osdn.me>

	Avoid recursive optional DLL import library linking.

	* Makefile.in (%.dll.a): Remove target before generation; if it
	pre-exists, the DLL may appear to recursively depend on itself.

2020-05-27  Keith Marshall  <keith@users.osdn.me>

	Fix libmingwex-n.dll dependencies; cf. Issue #40438.

	* Makefile.in (libmingwex.a): Remove...
	(mbrscan.$OBJEEXT, wcharmap.$OBJEXT): ...these; relocate them to...
	(libmingw32.a): ...here.

2020-04-30  Keith Marshall  <keith@users.osdn.me>

	Prepare and publish MinGW.org WSL-5.3.1 release.

	* All files (wsl-5.3.1-release): Tag assigned.

2020-04-19  Keith Marshall  <keith@users.osdn.me>

	Implement POSIX.1-2001 posix_memalign() function.

	* include/stdlib.h [_POSIX_C_SOURCE >= 200112L] (posix_memalign):
	Implement as inline alias, with libmemalign.a stub, in terms of...
	(__mingw_aligned_offset_malloc): ...this; duplicate declaration.

2020-04-18  Keith Marshall  <keith@users.osdn.me>

	Implement ISO-C11/C++17 aligned_alloc() function.

	* include/stdlib.h (free, realloc): Define as inline aliases for...
	(__mingw_free, __mingw_realloc): ...these replacements, respectively.
	[__STDC_VERSION__>=201112L || __cplusplus >=201703L] (aligned_alloc):
	Implement as inline alias, with libmemalign.a stub, in terms of...
	(__mingw_aligned_offset_malloc): ...this; duplicate declaration.
	(_GLIBCXX_HAVE_ALIGNED_ALLOC): Define it.

2020-04-11  Keith Marshall  <keith@users.osdn.me>

	Manpage stylistic consistency updates.

	* man/dirname.3.man man/getline.3.man: Miscellaneous stylistic
	formatting changes.

2020-04-08  Keith Marshall  <keith@users.osdn.me>

	Ensure PDF manpages are generated from local sources.

	* Makefile.in (%.$man3ext.pdf): Specify explicit path to $<.$man3ext
	file, when invoking the 'man -t' command; without it, the command may
	refer to the build host's native copy, instead of our local version.

2020-04-08  Keith Marshall  <keith@users.osdn.me>

	Automatically enumerate manpages for publication.

	* Makefile.in (manpages): New macro; define, and use it...
	(mingwrt-man3): ...for this, to enumerate associated manpage sources.
	(manpage_copy, mancopy, manpage_ref): New macros; define them, and...
	(basename.3, getdelim.3): ...use them.

2020-04-07  Keith Marshall  <keith@users.osdn.me>

	Document MinGW MBCS/wide character conversion functions.

	* man/btowc.3.man man/mbrlen.3.man man/mbrtowc.3.man
	* man/mbsinit.3.man man/mbsrtowcs.3.man man/wcrtomb.3.man
	* man/wcsrtombs.3.man man/wctob.3.man: New files.

2020-04-02  Keith Marshall  <keith@users.osdn.me>

	Handle wcsrtombs() initial surrogate completion.

	* mingwex/wcsrtombs.c (__mingw_wcsrtombs_fallback)
	[*ps -> high surrogate && **wcs -> low surrogate]: Complete surrogate
	pair, and evaluate conversion; compute its length, and account for its
	effect on alloted conversion buffer size.  Reset *ps to initial state.

2020-04-02  Keith Marshall  <keith@users.osdn.me>

	Correct wchar_t to MBCS unpaired surrogate handling.

	* mingwex/wcharmap.c (__mingw_wctomb_convert) [codeset >= CP_UTF7]:
	Scan source wchar_t sequence, prior to conversion, checking it for...
	[high surrogate]: Abort unless immediately followed by low surrogate.
	[low surrogate]: Likewise, if not preceded by high surrogate.

2020-03-19  Keith Marshall  <keith@users.osdn.me>

	Correct a potential mbsrtowcs() surrogate pair overrun.

	* mingwex/mbrscan.c (__mingw_mbtowc_copy) [(count + 1) == len)]: Stop,
	without storing current multibyte conversion, if surrogate pair.

2020-03-12  Keith Marshall  <keith@users.osdn.me>

	Rationalize implementations of fwide() and mbsinit() functions.

	* include/wchar.h (mbsinit): Mark as __LIBIMPL__; reimplement its
	inline definition, to evaluate its mbstate_t reference argument.
	(fwide): Mark as __LIBIMPL__.

	* Makefile.in (libmingwex.a): Remove explicit dependencies on...
	(fwide, mbsinit): ...these; they are implied by __LIBIMPL__ marks.

	* mingwex/fwide.c mingwex/mbsinit.c: Redundant files; delete them.

2020-03-11  Keith Marshall  <keith@users.osdn.me>

	Correct a defect in detection of failed btowc() conversions.

	* mingwex/btowc.c (__mingw_btowc_fallback): Use...
	(__mingw_mbtowc_convert): ...this; verify successful conversion of
	exactly one byte, to equivalent wchar, otherwise return WEOF.
	(__mingw_btowc, __msvcrt_btowc): Delegate codeset initialization to...
	(__mingw_mbrtowc_codeset_init): ...this, so delegating its management
	externally; remove local provision.

2020-03-10  Keith Marshall  <keith@users.osdn.me>

	Correct defects in mbrtowc() invalid conversion state handling.

	* mingwex/mbrconv.c (__mingw_mbrtowc_handler): Abort if restarting a
	conversion when a low surrogate is pending, but has not been correctly
	retrieved; additionally, reject any mbstate_t object content which is
	already representative of a complete multibyte character sequence.

2020-03-10  Keith Marshall  <keith@users.osdn.me>

	Base MBCS converter function call redirection on _ISOC99_SOURCE.

	* include/wchar.h (__mingw_redirect): New temporary macro; use it...
	(btowc, mbrlen, mbrtowc, mbsrtowcs, wctob, wcrtomb, wcsrtombs): ...in
	each of these inline function definitions, to select between use of...
	[defined _ISOC99_SOURCE]: ...direct call to MinGW function, or...
	[! defined _ISOC99_SOURCE]: ...attempt to call MSVCRT.DLL function,
	with fall back to MinGW, when no MSVCRT.DLL function available.

2020-03-05  Keith Marshall  <keith@users.osdn.me>

	Prepare and publish MinGW.org WSL-5.3 release.

	* All files (wsl-5.3-release): Tag assigned.

2020-03-05  Keith Marshall  <keith@users.osdn.me>

	Let _ISOC11_SOURCE imply _ISOC99_SOURCE.

	* include/_mingw.h.in [! defined _ISOC99_SOURCE]
	[defined _ISOC11_SOURCE] (_ISOC99_SOURCE): Define as 0x0F.

2020-03-05  Keith Marshall  <keith@users.osdn.me>

	Avoid deprecated specification of esp in asm clobber list.

	* crt1.c (__mingw_CRTStartup): In inline assembly, forced modulo-16
	alignment of esp is safe, but clobbered esp cannot be restored; GCC-9
	deprecates its inclusion in clobber list; remove it.
	[-masm=intel]: Support inline assembler syntax.

2020-03-04  Keith Marshall  <keith@users.osdn.me>

	Disallow surrogates as printf() radix and grouping characters.

	* mingwex/stdio/pformat.c (__pformat_emit_digit)
	[(c == '.') && ((rpchr & 0xF800) == 0xD800)]: Radix point requires a
	surrogate pair, for representation as UTF-16LE; decline to use it.
	(__pformat_enable_thousands_grouping) [(tc & 0xF800) == 0xD800]:
	Likewise, for thousands group separator.

2020-03-04  Keith Marshall  <keith@users.osdn.me>

	Reimplement wcstof(), and wcstold() functions.

	* mingwex/wcstofp.c: New file; it implements...
	(wcstof, wcstold): ...these functions; each is an alias for...
	(__mingw_wcstof, __mingw_wcstold): ...these, respectively; also...
	(__mingw_wcstod): ...this; all are implemented in terms of...
	(__mingw_wcstofp_prescan, __mingw_wcstofp_prepare)
	(__mingw_wcstofp_bufsize): ...these; implement them.

	* Makefile.in (libmingwex.a): Add dependency references...
	(wcstofp.$OBJEXT, wcstod.$OBJEXT): ...for these; also include with...
	(wcstof.$OBJEXT, wcstold.$OBJEXT): ...these, in new build rule.

	* include/stdlib.h (__mingw_wcstod, __mingw_wcstof)
	(__mingw_wcstold): Declare them.

	* mingwex/mb_wc_common.h mingwex/wcstof.c mingwex/wcstold.c: Files
	are obsolete, and no longer required; delete them.

2020-03-03  Keith Marshall  <keith@users.osdn.me>

	Reimplement btowc(), and wctob() functions.

	* include/wchar.h [__MSVCRT_VERSION__ < __MSVCR80_DLL]
	(btowc, wctob): Implement them as static inline redirects...
	(__msvcrt_btowc, __msvcrt_wctob): ...to these; declare them, with
	additional MinGW specific alternatives declared...
	(__mingw_btowc, __mingw_wctob): ...thus.

	* mingwex/btowc.c: Rewrite as new; it now implements...
	(__mingw_btowc, __msvcrt_btowc): ...these public API functions, either
	of which serves as a suitable replacement entry point for...
	(btowc): ...this, with ultimate fallback served by...
	(__mingw_btowc_fallback): ...this private function.

	* mingwex/wctob.c: Rewrite as new; it now implements...
	(__mingw_wctob, __msvcrt_wctob): ...these public API functions, either
	of which serves as a suitable replacement entry point for...
	(wctob): ...this, with ultimate fallback served by...
	(__mingw_wctob_fallback): ...this private function.

2020-03-02  Keith Marshall  <keith@users.osdn.me>

	Reimplement mbrlen(), mbrtowc(), and mbsrtowcs() functions.

	* include/wchar.h [__MSVCRT_VERSION__ < __MSVCR80_DLL]
	(mbrlen, mbrtowc, mbsrtowcs): Implement as static inline redirects...
	(__msvcrt_mbrlen, __msvcrt_mbrtowc, __msvcrt_mbsrtowcs): ...to these;
	declare them, with additional MinGW specific alternatives declared...
	(__mingw_mbrlen, __mingw_mbrtowc, __mingw_mbsrtowcs): ...thus.

	* mingwex/mbsrtowcs.c: New file; it implements...
	(__mingw_mbsrtowcs, __msvcrt_mbsrtowcs): ...this pair of new
	functions, either of which serves as a replacement for...
	(mbsrtowcs): ...this; it was originally implemented...
	* mingwex/mbrtowc.c: ...here; rewritten as new, it now implements...
	(__mingw_mbrtowc, __msvcrt_mbrtowc): ...these new functions,
	either of which serves as a public API replacement for...
	(mbrtowc): ...this; with ultimate fallback served by...
	(__mingw_mbrtowc_fallback): ...this private function.

	* mingwex/mbrlen.c: New file; it implements...
	(__mingw_mbrlen, __msvcrt_mbrlen): ...these public API entries, and...
	(__mingw_mbrlen_fallback): ...this supporting private function.

	* mingwex/mbrconv.c: New file; it implements...
	(__mingw_mbrtowc_handler): ...this backend interpreter, shared by...
	(__mingw_mbrlen_fallback, __mingw_mbrtowc_fallback): ...these.

	* mingwex/mbrscan.c: New file; it implements...
	(__mingw_mbtowc_codeset_init, __mingw_mbtowc_cur_max_init)
	(__mingw_mbtowc_cur_max): ...these TLS accessor functions, and...
	(__mingw_mbrscan_begin, __mingw_mbtowc_convert, __mingw_mbtowc_copy):
	...these MBCS to wide character conversion helper functions.

	* mingwex/wcharmap.h (boolean): Define new private use data type...
	(false, true): ...with these effective symbolic values; define them.
	(__mingw_mbtowc_codeset_init, __mingw_mbtowc_cur_max_init)
	(__mingw_mbtowc_cur_max, __mingw_mbrscan_begin, __mingw_mbtowc_copy)
	(__mingw_mbtowc_convert): Declare them.

	* Makefile.in (libmingwex.a): Add dependency references for...
	(mbrconv.$OBJEXT, mbrscan.$OBJEXT, mbrlen.$OBJEXT, mbsrtowcs.$OBJEXT):
	...these.

2020-02-25  Keith Marshall  <keith@users.osdn.me>

	Reimplement wcrtomb() and wcsrtombs(); cf. MinGW-Issue #39687.

	* include/wchar.h [__MSVCRT_VERSION__ < __MSVCR80_DLL]
	(wcrtomb, wcsrtombs): Implement them as static inline redirects to...
	(__msvcrt_wcrtomb, __msvcrt_wcsrtombs): ...these; declare them.
	(__mingw_wcrtomb, __mingw_wcsrtombs): Also declare these.

	* include/limits.h (MB_LEN_MAX): Update value; was 2, but should be 5.

	* mingwex/wcsrtombs.c: New file; it implements...
	(__mingw_wcsrtombs, __msvcrt_wcsrtombs): ...this pair of new
	functions, either of which serves as a replacement for...
	(wcsrtombs): ...this; it was originally implemented...
	* mingwex/wcrtomb.c: ...here; rewritten as new, it now implements...
	(__mingw_wcrtomb, __msvcrt_wcrtomb): ...these new functions,
	either of which serves as a replacement for...
	(wcrtomb): ...this.

	* mingwex/wcharmap.h: New private header; it declares the API for...
	* mingwex/wcharmap.c: ...this new file, which implements...
	(__mingw_wctomb_convert): ...this new function, required by...
	(__mingw_wcrtomb, __msvcrt_wcrtomb, __mingw_wcsrtombs)
	(__msvcrt_wcsrtombs): ...these; also provides...
	(__mingw_wctomb_codeset_init, __mingw_wctomb_cur_max_init)
	(__mingw_wctomb_cur_max): ...these supporting thread local storage
	accessor functions.

	* mingwex/codeset.c: New file; it implements...
	(__mb_codeset_for_locale, __mb_len_max_for_codeset): ...this pair of
	new helper functions; they identify the codeset, and respectively, its
	MB_CUR_MAX for the effective process locale, which are required by...
	(__mingw_wctomb_convert): ...this.

	* Makefile.in (libmingwex.a): Add dependency references for...
	(codeset.$OBJEXT, wcharmap.$OBJEXT, wcsrtombs.$OBJEXT): ...these.

2020-01-21  Keith Marshall  <keith@users.osdn.me>

	Address MinGW-Issue #39658; declare rand_s() function.

	* include/stdlib.h: When the user has defined...
	[_CRT_RAND_S]: ...this optional feature test macro, and then...
	[__MSVCRT_VERSION__ >= __MSVCR80_DLL]: ...either this non-free, or...
	[_WIN32_WINNT >=_ WIN32_WINNT_VISTA]: ...this system-standard runtime
	library version constraint is satisfied, then...
	(rand_s): ...declare function prototype.

2020-01-17  Keith Marshall  <keith@users.osdn.me>

	Support GCC-9.x gratuitous dependency on ftruncate64() function.

	* include/unistd.h (ftruncate64): Declare prototype; implement it...
	* mingwex/ftruncate.c: ...in this new file; it will delegate to...
	(_chsize_s): ...this MSVCRT.DLL function, if available.

	* Makefile.in (libmingwex.a): Add dependency on...
	(ftruncate.$OBJEXT): ...this.

	* msvcrt-xref/msvcrt.def.in (_chsize_s): Require dlsym look-up.

2020-01-17  Keith Marshall  <keith@users.osdn.me>

	Preserve order of tests for integrity of header files.

	* tests/Makefile.in: Explicitly sort $wildcard output, within...
	(list_headers): ...this new function-style macro.
	(enum_headers): Use it.

	* tests/headers.at: Adjust to recent GNU make $sort order.

2020-01-17  Keith Marshall  <keith@users.osdn.me>

	Update handling of <process.h> test-suite limitation.

	* include/process.h (-Wbuiltin-declaration-mismatch)
	[__IN_MINGWRT_TESTSUITE__ && __GNUC__ >= 7 && __cplusplus]: Drop...
	[__cplusplus]: ...this diagnostic constraint, in test case when...
	[__GNUC__ >= 9]: ...this applies; this diagnostic now affects both
	C and C++ compilers, with respect to each of...
	(execv, execve, execvp): ...these functions.

2020-01-17  Keith Marshall  <keith@users.osdn.me>

	Support GCC-9.x gratuitous use of non-standard errno accessor API.

	* include/stdlib.h (_get_errno, _set_errno): Declare prototypes;
	implement them in-line, for legacy Windows versions which may lack
	them, since GCC-9.x gratuitously and ill-advisedly requires them.
	(__STDLIB_H_SOURCED__): Define, and selectively #include...

	* include/errno.h: ...this, subject to criterion...
	[__STDLIB_H_SOURCED__]: ...for exposure of only...
	(errno): ...this public API declaration, and...
	(EINVAL): ...this symbolic constant.

2019-10-26  Keith Marshall  <keith@users.osdn.me>

	Fix MinGW-Issue #39757; avoid multiple vsnprintf() definitions.

	* include/stdio.h [C++] (__mingw_stdio_redirect__): Defer redirection
	to in-line definitions applicable for C, when the compiler suite is...
	[__GNUC__]: ...this.

2019-10-16  Keith Marshall  <keith@users.osdn.me>

	Address MinGW-Issue #39677; declare _findclose() only once.

	* include/io.h (_findclose): Relocate declaration within conditional
	block, to prevent second exposure when <io.h> is included in full,
	following partial inclusion by <wchar.h>

2019-07-06  Keith Marshall  <keith@users.osdn.me>

	Prepare and publish MinGW.org WSL-5.2.2 release.

	* All files (wsl-5.2.2-release): Tag assigned.

2019-07-03  Keith Marshall  <keith@users.osdn.me>

	Avoid built-in snprintf() prototypes; fix MinGW-Bug #39224

	* include/stdio.h [__USE_MINGW_ANSI_STDIO]
	(snprintf, vsnprintf): Implement them in-line, delegating to...
	(__mingw_vsnprintf): ...this external function.

	* mingwex/stdio/snprintf.c mingwex/stdio/vsnprintf.c: Assert
	copyright; include <stddef.h>, instead of <stdio.h>, to obtain a
	definition of "size_t"; this is required because the new in-line
	prototypes, now provided in <stdio.h>, conflict with the intent
	to provide external implementations.

	* tests/ansiprintf.at (MINGW_AT_CHECK_SNPRINTF): Conditionally
	circumvent conditions which may produce -Wformat warnings.

2019-07-01  Keith Marshall  <keith@users.osdn.me>

	Revert to macro implementation of "alloca()" functions.

	* include/alloca.h (alloca, _alloca): Delete any prior definitions;
	remove in-line implementations; replace with conventional prototypes,
	followed by corresponding function style macro definitions.

2019-01-22  Keith Marshall  <keith@users.osdn.me>

	Prepare and publish MinGW.org WSL-5.2.1 release.

	* All files (wsl-5.2.1-release): Tag assigned.

2019-01-22  Keith Marshall  <keith@users.osdn.me>

	Incorporate user-customized <features.h> configuration.

	* include/_mingw.h: Include <features.h>, or...
	[_MINGW_FEATURES_HEADER]: ...nominated alternative header.
	[!defined __MINGW_FEATURES__]: Provide fall-back definition.
	(__MINGW_FEATURES_BEGIN__, __MINGW_FEATURES_ENABLE__)
	(__MINGW_FEATURES_IGNORE__, __MINGW_FEATURES_UNSET__)
	(__MINGW_FEATURES_END__): New macros; define them.

	* tests/Makefile.in (install-mingwrt): Create <features.h> stub; this
	is an empty file, yielding the default fall-back configuration.

2019-01-21  Keith Marshall  <keith@users.osdn.me>

	Handle another GCC compile-time warning.

	* mingwex/memalign.c (is_power_of_two): Use in-line expansion...
	(memalign_is_power_of_two): ...of this new function; this is required
	to avoid -Wsequence-point warnings, which may arise when testing the
	result of an assignment expression passed as the macro argument.

2019-01-11  Keith Marshall  <keith@users.osdn.me>

	Fix a mkstemp() file name generator defect.

	* mingwex/cryptnam.c (crypto_random_filename_char): Revert 2018-09-06
	change; argument type must be unsigned char *, to avoid math errors.
	(__mingw_crypto_tmpname): Use explicit casts to resolve type conflicts.

2019-01-11  Keith Marshall  <keith@users.osdn.me>

	Fix a <stdio.h> typedef omission.

	* include/stdio.h: Adjust comment formatting.
	(__need___off64_t) [__MSVCRT__]: Require it, but remove...
	[!(__STRICT_ANSI__||__NO_MINGW_LFS)]: ...this exclusion filter.
	[!__MSVCRT__] (__need___off32_t): Require this alternative.
	(sys/types.h): Include unconditionally.

2018-12-23  Keith Marshall  <keith@users.osdn.me>

	Prepare and publish MinGW.org WSL-5.2 release.

	* All files (wsl-5.2-release): Tag assigned.

2018-12-22  Keith Marshall  <keith@users.osdn.me>

	Correct an optional DLL installation and packaging defect.

	* Makefile.in (optional_dll): New function macro; define it, and...
	(MAP_LIBMINGWEX_A_DLLVERSION): ...wrap this, replacing all usage of...
	(optional_dll_version, optional_dll_package): ...these; delete them,
	together with all dependent references.

2018-12-22  Keith Marshall  <keith@users.osdn.me>

	Update ANSI stdio feature test to accommodate ISO-C11.

	* include/_mingw.h.in (__USE_MINGW_ANSI_STDIO): Add a deprecation
	warning, for ill-advised direct definition in user code; include...
	(_ISOC11_SOURCE): ...this new user defined feature test macro as a
	further indirect enabling condition.

2018-12-20  Keith Marshall  <keith@users.osdn.me>

	Implement test suite for aligned heap management API.

	* tests/testsuite.at.in: Include...
	* tests/memalign.at: ...this new file; it replaces...
	* mingwex/tst-aligned-malloc.c: ...this; delete it.

2018-12-20  Keith Marshall  <keith@users.osdn.me>

	Reimplement aligned heap management API.

	* mingwex/mingw-aligned-malloc.c: Delete it; it is replaced by...
	* mingwex/memalign.c: ...this new file; it reimplements...
	(__mingw_aligned_offset_malloc, __mingw_aligned_offset_realloc)
	(__mingw_aligned_free): ...each of these public API functions; also...
	(__mingw_realloc, __mingw_free): ...adds these new public functions,...
	(__mingw_memalign_base, __mingw_memalign_realloc): ...these private,
	but globally exposed, supporting functions, and additionally...
	(__mingw_memalign_lwm): ...this global, private use, variable.

	* include/stdlib.h (__mingw_realloc, __mingw_free): Declare prototypes.

	* include/malloc.h (__mingw_aligned_malloc, __mingw_aligned_realloc):
	Implement them in-line; export them, via __LIBIMPL__, to libmingwex.a
	(_aligned_malloc, __mingw_aligned_malloc, _aligned_offset_malloc)
	(__mingw_aligned_offset_malloc): Add __MINGW_ATTRIB_MALLOC attribute.
	[__MSVCRT_VERSION__ < __MSVCR70_DLL] (_aligned_malloc, _aligned_free)
	(_aligned_realloc, _aligned_offset_malloc, _aligned_offset_realloc):
	Implement them in-line, as wrappers around their MinGW alternatives;
	export them, via __LIBIMPL__, to new library, libmemalign.a

	* Makefile.in (LIBMINGWEX_MEMALIGN): New macro; define it; derive...
	(LIBMINGWEX_MEMALIGN_OBJECTS): ...this macro; add compilation rule.
	(libmingwex.a): Add $LIBMINGWEX_MEMALIGN_OBJECTS; they replace...
	(mingw-aligned-malloc.$OBJEXT): ...this; remove dependency.
	(all-mingwrt-libs, install-mingwrt-libs): Add libmemalign.a
	(msvcrt_repl_funcs): Add alias references for...
	(free, realloc): ...these.

2018-12-04  Keith Marshall  <keith@users.osdn.me>

	Reimplement Win9x specific fseek()/fwrite() redirector.

	* include/stdio.h [__USE_MINGW_FSEEK]: Deprecate support for direct
	user definition; deduce it, as an internal private definition, from...
	[_WIN32_WINDOWS]: ...this, when appropriately defined for Win9x.
	[__USE_MINGW_FSEEK] (__mingw_fseek): Declare new prototype; map it as
	multiple __CRT_ALIAS inline function overrides for each of...
	(fseek, _fseeki64, fseeko64): ...these.
	[__USE_MINGW_FSEEK] (__mingw_fwrite): Likewise, overriding...
	(fwrite): ...this.
	(__mingw_fseeko64): Delete all references; it is no longer provided,
	nor required.

	* mingwex/stdio/fwrite.c: New file; it reimplements the Win9x
	fseek()/fwrite() function redirector interface, and thus replaces...
	* mingex/ming-fseek.c: ...this; delete it.

	* Makefile.in (libmingwex.a): Remove dependency on...
	(mingw-fseek.$OBJEXT): ...this object module; replace it with...
	(fwrite.$OBJEXT): ...this alternative dependency.

2018-12-04  Keith Marshall  <keith@users.osdn.me>

	Implement POSIX.1-1996 linked-list queue management API.

	* mingwex/insque.c mingwex/remque.c: New files; they implement the
	POSIX.1-1996 insque(), and remque() functions, respectively.

	* include/search.h (insque, remque): Declare function prototypes.

	* Makefile.in (libmingwex.a): Add dependencies on...
	(insque.$OBJEXT, remque.$OBJEXT): ...these.

2018-11-25  Keith Marshall  <keith@users.osdn.me>

	Emulate _fseeki64()/_ftelli64() API on legacy platforms.

	* mingwex/stdio/fseeki64.c: New file; it implements...
	(__mingw_fseeki64, fseeko64): ...both of these functions, avoiding any
	dependency on undocumented internal implementation details of...
	(fpos_t): ...this opaque data type, and replacing...
	* mingwex/stdio/fseeko64.c: ...this; delete it.

	* mingwex/stdio/ftelli64.c: New file; it implements...
	(_ftelli64, ftello64): ...both of these, again avoiding any dependency
	on undocumented internal implementation details of...
	(fpos_t): ...this opaque data type.

	* include/stdio.h (fpos_t): Make it more effectively opaque.
	(__mingw_fseeki64, __mingw_ftelli64): Declare them for legacy use.
	[_WIN32_WINNT < VISTA && __MSVCRT_VERSION__ < MSVCR80_DLL] (_fseeki64)
	(_ftelli64): Map inline emulations, to "__mingw" prefixed names.
	(ftello64): Remove inline implementation.

	* Makefile.in (libmingwex.a): Add references to...
	(fseeki64.$OBJEXT, ftelli64.$OBJEXT): these; remove reference to...
	(fseeko64.$OBJEXT): ...this.

2018-10-21  Keith Marshall  <keith@users.osdn.me>

	Update <conio.h> and <wchar.h> header files.

	* include/conio.h: Tidy layout; assert copyright.
	[_CONIO_H_]: Rename multiple inclusion guard macro, to conform to...
	[_CONIO_H]: ...this preferred convention; do not define when...
	[__WCHAR_H_SOURCED__]: ...this selective inclusion condition applies.
	[__need_wint_t, __need_wchar_t]: Define them; include <stddef.h>...
	(wint_t, wchar_t): ...for these corresponding data type definitions.
	[_WIN32_WINNT >= WINXP || __MSVCRT_VERSION__ >= __MSVCR70_DLL]
	(_getwch, _getwche, _ungetwch, _putwch): Declare function prototypes.
	[__MSVCRT_VERSION__>=__MSVCR80_DLL] (_getch_nolock, _getche_nolock)
	(_ungetch_nolock, _putch_nolock, _getwch_nolock, _getwche_nolock)
	(_ungetwch_nolock, _putwch_nolock): Likewise.
	[_BEGIN_C_DECLS, _END_C_DECLS]: Use them.

	* include/wchar.h: Selectively include <conio.h>, for...
	(_getwch, _getwche, _ungetwch): ...these function prototypes, and...
	[__MSVCRT_VERSION__>=__MSCVCR80_DLL] (_getwch_nolock)
	(_getwche_nolock, _ungetwch_nolock): ...these.

2018-10-18  Keith Marshall  <keith@users.osdn.me>

	Map compile-time constant references for POSIX clocks.

	* include/time.h (CLOCK_REALTIME, CLOCK_MONOTONIC): Redefine, using...
	(__MINGW_POSIX_CLOCKAPI): ...this new macro; it converts clock indices
	to odd-valued compile-time constant pseudo-pointers, (distinguishable
	from real pointers which are always even-valued), which may be passed
	as clockid_t references in POSIX clock API function calls.

	* mingwex/clockapi.h (struct __clockid__): Specify 4-byte alignment.
	(__clock_api_is_valid): Change return type to "clockid_t".

	* mingwex/clockapi.c (__clock_api_is_valid): Return an even-valued,
	non-NULL, "clockid_t" reference pointer, or "NULL" if invalid; use...
	(clock_reference): ...this new static inline function, to convert...
	(CLOCK_REALTIME, CLOCK_MONOTONIC): ...these odd-valued pseudo-pointers
	to their actual run-time pointer equivalents; delete their physical
	initializations, which have now become invalid.

	* mingwex/clockres.c (clock_getres)
	* mingwex/clocktime.c (clock_gettime)
	* mingwex/clockset.c (clock_settime): Update the "clockid_t" argument
	to match the real pointer returned by __clock_api_is_valid()

2018-10-08  Keith Marshall  <keith@users.osdn.me>

	Suppress autoconf detection of _aligned_malloc functions.

	* msvcrt-xref/msvcrt.def.in (_aligned_malloc, _aligned_free)
	(_aligned_offset_malloc, _aligned_realloc, _aligned_offset_realloc):
	Mark as requiring dlsym() lookup, when linking with MSVCRT.DLL

2018-10-07  Keith Marshall  <keith@users.osdn.me>

	Make alloca() API both GNU and Microsoft compatible.

	* include/malloc.h: Tidy layout; assert copyright.
	(_MALLOC_H_): Rename guard macro, for conformance with...
	(_MALLOC_H): ...this preferred guard macro naming convention.
	(GCC system_header): Add pragma, declaring it as such.
	[__MSVCRT_VERSION__ >= 0x0700]: Express symbolically, guarding...
	(_aligned_malloc, _aligned_offset_malloc)
	(_aligned_realloc, _aligned_offset_realloc)
	(_aligned_recalloc, _aligned_offset_recalloc): ...these...
	[__MSVCRT_VERSION__>=__MSVCR70_DLL]: ...thus.
	[_BEGIN_C_DECLS, _END_C_DECLS]: Use them.
	(alloca, _alloca): Factor them out, then include from...
	* include/alloca.h: ...this new header file; it reimplements...
	(alloca, _alloca): ...these, such that they remain Microsoft
	compatible, while adding GNU conformity, either explicitly when
	included by user code, or conditionally when included by...
	* include/stdlib.h [!__STRICT_ANSI__]: ...this.

	* tests/headers.at: Regenerated by "make check".
	(MINGWRT_AT_PACKAGE_HEADERS): Add alloca.h

2018-09-06  Keith Marshall  <keith@users.osdn.me>

	Avoid unwanted GCC warning diagnostic messages.

	* Makefile.in (libm_dummy.c): Remove "static" qualifier from...
	(__mingw_libm_dummy): ...this variable; it caused "-Wunused-variable"
	warning diagnostics, when compiled with "-Wall".

	* main.c (WinMain): Remove unnecessary argument names from prototype.
	(main): Make its argument list conform to convention, otherwise it
	causes a "-Wmain" warning diagnostic when compiled with "-Wall".

	* mingwex/clocktime.c (clock_gettime) [clock_id-type]
	* mingwex/clockapi.c (clock_api_getres_interval) [clock_api->type]:
	Ensure that switches include default cases; this avoids a "-Wswitch"
	warning diagnostic message, in each case, when compiled with "-Wall".

	* mingwex/cryptnam.c (crypto_random_filename_char): Remove "unsigned"
	qualifier from both argument and return type; this avoids an argument
	type mismatch, raising a "-Wpointer-sign" warning when called from...
	(__mingw_crypto_tmpname): ...here, and compiled with "-Wall".

	* mingwex/imaxdiv.c: Tidy layout; assert copyright.
	(lldiv): Correct return type; explicitly disable "-Wattribute-alias"
	diagnostic messages, under GCC pragma control.

	* mingwex/ofmt.c [__crtofmt__] (__mingw_set_output_format_fallback)
	[__crtnfmt__] (__mingw_get_printf_count_output_fallback): Likewise,
	disable "-Wattribute-alias" diagnostics.

	* mingwrt/mingwex/stdio/pformat.c (__pformat_ignore_flags): Adjust
	layout, to avoid a "-Wmisleading-indentation" warning diagnostic.
	(__pformat_argmap) [length]: Add a no-op default case, to avoid a
	"-Wswitch" warning diagnostic message.

	* mingwrt/profile/mcount.c: Explicitly disable "-Wframe-address"
	diagnostics, under GCC pragma control, to avoid warnings relating...
	(__builtin_return_address): ...this, when called from...
	(mcount): ...here.

	* mingwrt/setargv.c (__mingw_setargv): Insert parentheses, as advised,
	to eliminate "-Wparentheses" diagnostic messages.

2018-09-03  Keith Marshall  <keith@users.osdn.me>

	Prepare and publish MinGW.org WSL-5.1.1 release.

	* All files (wsl-5.1.1-release): Tag assigned.

2018-09-02  Keith Marshall  <keith@users.osdn.me>

	Make clockapi symbolic constants #ifdef detectable.

	* mingwex/clockapi.c (CLOCK_REALTIME, CLOCK_MONOTONIC): Add "const".
	* include/time.h (CLOCK_REALTIME, CLOCK_MONOTONIC): Likewise; also
	define both as self-referencing macros.

2018-08-26  Keith Marshall  <keith@users.osdn.me>

	Circumvent <process.h> testsuite failure with GCC-7+.

	* include/process.h (execv, execve, execvp): Subject declarations to
	#pragma GCC diagnostic ignored "-Wbuiltin-declaration-mismatch", if...
	[__cplusplus && __IN_MINGWRT_TESTSUITE__ && __GNUC__ >= 7]: ...this.

2018-04-16  Keith Marshall  <keith@users.osdn.me>

	Suppress glob-brace expansion within quoted arguments.

	* setargv.c (__mingw32_setargv) [quoted]: Handle '{', ',', and '}'
	in the same manner as '*', and '?'.

2018-04-16  Keith Marshall  <keith@users.osdn.me>

	Suppress glob-brace expansion of single item lists.

	* mingwex/glob.c (glob_match) [c == '{']: Look-ahead to matching '}';
	ignore intervening nested '{' ... '}' expression groups, and suppress
	special interpretation of '{' if '\0' encountered before '}' at outer
	nesting level, or if no unescaped ',' found within outer expression.

2018-02-26  Keith Marshall  <keith@users.osdn.me>

	Prepare and publish MinGW.org WSL-5.1 release.

	* All files (wsl-5.1-release): Tag assigned.

2018-02-22  Keith Marshall  <keith@users.osdn.me>

	Correct <sys/timeb.h> 32-bit vs. 64-bit time_t anomalies.

	* include/sys/timeb.h: Assert copyright; tidy layout.
	(_TIMEB_H_): Original multiple inclusion guard macro; rename it...
	(_SYS_TIMEB_H): ...conforming to this preferred naming convention.
	(GCC system_header): Add pragma, asserting it as such a header.
	(__need_time_t): Define for selective <sys/types.h> inclusion.
	(_BEGIN_C_DECLS, _END_C_DECLS): Use them as appropriate.
	(pragma pack): Push to pack all structs with 2-byte alignment.
	(struct timeb): Mark as deprecated, from POSIX.1-2001 onwards.
	(ftime): Likewise, mark as deprecated; always emulate it by in-line
	redirection to _ftime(), however this may be implemented.
	(struct __timeb32): Make its definition unconditionally visible.
	(_ftime32) [__MSVCRT_VERSION__ >= __MSVCR80_DLL]: Declare prototype.
	(_ftime32) [_WIN64 || _WIN32_WINNT >= _WIN32_WINNT_VISTA]: Likewise,
	otherwise emulate it by in-line redirection to 32-bit _ftime().
	(struct __timeb64, _ftime64): Make visibility condition symbolic...
	[__MSVCRT_VERSION__ >= __MSVCR61_DLL]: ...thus; add visibility for...
	[_WIN64 || _WIN32_WINNT >= _WIN32_WINNT_WIN2K]: ...these alternatives.
	(_ftime) [__MSVCRT_VERSION__ < __MSVCR80_DLL]: Declare prototype.
	(_ftime) [__MSVCRT_VERSION__ >= __MSVCR80_DLL]: Emulate it...
	[_USE_32BIT_TIME_T]: ...by in-line redirection to _ftime32(), else...
	[!_USE_32BIT_TIME_T]: ...to _ftime64().

	* tests/headers.at [sys/timeb.h]: Suppress "deprecated" warnings.

2018-02-22  Keith Marshall  <keith@users.osdn.me>

	Correct Windows version support for <utime.h> functions.

	* include/sys/utime.h: Tidy layout; assert copyright.
	(_UTIME_H_): Rename this repeat inclusion guard macro...
	(_SYS_UTIME_H): ...to this, for consistency with current practice.
	(_BEGIN_C_DECLS, _END_C_DECLS): Use them, as appropriate.
	(struct __utimbuf32): Define it unconditionally; remove...
	[__MSVCRT_VERSION__>=0x0800]: ...this prerequisite.
	(_utime32, _wutime32, _futime32): Declare them for...
	[_WIN32_WINNT >= _WIN32_WINNT_VISTA]: ...this, in addition to...
	[__MSVCRT_VERSION__>=__MSVCR80_DLL]: ...this original condition, but
	also emulate them in-line, if neither condition applies.
	[__MSVCRT_VERSION__>=__MSVCR80.DLL] (_utime, _wutime, _futime):
	Implement them in-line, delegating each respectively to...
	[_USE_32BIT_TIME_T] (_utime32, _wutime32, _futime32): ...these, or...
	[!_USE_32BIT_TIME_T] (_utime64, _wutime64, _futime64): ...to these.
	[__MSVCRT_VERSION__>=__MSVCR80.DLL] (utime): Implement in-line, or...
	[__MSVCRT_VERSION__<__MSVCR80.DLL] (utime): ...declare it.

2018-01-17  Keith Marshall  <keith@users.osdn.me>

	Fix faulty POSIX deprecation warning logic.

	* include/_mingw.h.in (__POSIX_2008_DEPRECATED): Do not nest...
	(__POSIX_2001_DEPRECATED): ...within defininion of this; similarly...
	(__POSIX_1995_DEPRECATED): ...neither within this; rename this as...
	(__POSIX_1996_DEPRECATED): ...this; although conditional upon...
	[_POSIX_C_SOURCE >= 199506L]: ...this, the corresponding standard was
	eventually ratified, not as POSIX.1-1995, but as POSIX.1-1996

2017-12-28  Keith Marshall  <keith@users.osdn.me>

	Fix a build issue, assembling generic SX files.

	* Makefile.in (%_generic.sx): Always use $(COMPILE.sx) to pre-process
	and assemble these; with $(CC) -c $(ALL_CPPFLAGS) $(ASFLAGS), versions
	of GCC, prior to GCC-4.3, will fail to identify the source file suffix
	correctly, resulting in failure to assemble the code.

2017-12-18  Keith Marshall  <keith@users.osdn.me>

	Support strtok() re-entrancy, per request [#2342].

	* mingwex/strtok_r.c: New file; it implements...
	(strtok_r): ...this function, per POSIX.1-1995 specification.
	* Makefile.in (libmingwex.a): Add reference; make it depend on...
	(strtok_r.$OBJEXT): ...this.

	* include/string.h: Declare corresponding runtime API.
	[_POSIX_C_SOURCE >= 199506L] (strtok_r): Add function prototype.
	[__MSVCRT_VERSION__ >= __MSVCR80_DLL] (strtok_s): Likewise; this is
	the Microsoft equivalent function, first introduced in this non-free
	MSVC runtime library; subsequently available in MSVCRT.DLL since...
	[_WIN32_WINNT >= _WIN32_WINNT_VISTA]: ...this release, likewise.

2017-12-16  Keith Marshall  <keith@users.osdn.me>

	Implement autotest module for POSIX clock API functions.

	* tests/clockapi.at: New file.
	* tests/testsuite.at.in (clockapi.at): Incorporate it.

2017-12-15  Keith Marshall  <keith@users.osdn.me>

	Implement a subset of the POSIX.1b-1993 clock API.

	* include/time.h [_POSIX_C_SOURCE >= 199309L]
	(clockid_t): New structured data type; define it opaquely, and...
	(CLOCK_REALTIME, CLOCK_MONOTONIC): ...declare these extern instances.
	(clock_getres, clock_gettime, clock_settime): New functions; declare
	prototypes.

	* mingwex/clockapi.h mingwex/clockapi.c mingwex/clockres.c
	* mingwex/clockset.c mingwex/clocktime.c: New files; they implement
	the preceding clock instances, and associated API functions.

	* include/sys/time.h [_POSIX_C_SOURCE >= 200809L] (gettimeofday):
	Mark it as "deprecated".

2017-12-14  Keith Marshall  <keith@users.osdn.me>

	Add support for POSIX.1 "obsolescence" warnings.

	* include/_mingwrt.h.in (__POSIX_1995_DEPRECATED)
	(__POSIX_2001_DEPRECATED, __POSIX_2008_DEPRECATED): New macros; define
	them, such as each is conditional on the specific value assigned to...
	[_POSIX_C_SOURCE]: ...this feature test macro, as the equivalent of...
	(__MINGW_ATTRIB_DEPRECATED): ...this, or of nothing, as appropriate.

2017-12-06  Keith Marshall  <keith@users.osdn.me>

	Prepare and publish MinGW.org WSL-5.0.2 release.

	* All files (wsl-5.0.2-release): Tag assigned.

	* Makefile.in (mingwrt-srcdist-package-files): Add reference...
	* $mingwrt_srcdir/*.sx: ...for files matching this template.

2017-12-02  Keith Marshall  <keith@users.osdn.me>

	Provide legacy OS work around for issue [#2357]

	* cpu_features.c: Delete; replace it with...
	* cpu_features.sx: ...this new assembly language file.

	* cpu_features.h [__ASSEMBLER__]
	(__cpu_features, __cpu_features_init): Suppress declarations.

	* Makefile (%.sx): Add $srcdir vpath reference.

2017-11-28  Keith Marshall  <keith@users.osdn.me>

	Handle indeterminate FLT_EVAL_METHOD; fix issue [#2352].

	* include/math.h [FLT_EVAL_METHOD == 0 || FLT_EVAL_METHOD == 1]
	(float_t, double_t): Define them explicitly, as appropriate for each
	of these two specific cases only; otherwise, define them as if for...
	[FLT_EVAL_METHOD == 2]: ...this explicit case, but also apply it as a
	suitable default compromise for the indeterminate case, in which...
	[FLT_EVAL_METHOD != 2]: ...emit indeterminacy warning.

2017-10-25  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Include, and make <sys/bsdtypes.h> test suite safe.

	* tests/headers.at (sys/bsdtypes.h): Add reference.

	* include/sys/bsdtypes.h [__IN_MINGWRT_TESTSUITE__]: Add to...
	[_BSD_SOURCE || _WINSOCK2_H]: ...these, as conditions for supression
	of "ill-advised usage" warning message.

2017-09-15  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Factor <sys/time.h> duplicate content out of winsock headers.

	* include/sys/time.h: Assert copyright; tidy layout.
	[_BEGIN_C_DECLS, _END_C_DECLS]: Use them to avoid C++ name mangling.
	[__WINSOCK_H_SOURCED__] (_SYS_TIME_H): Do not define it; hence...
	[!defined _SYS_TIME_H]: ...selectively expose definitions for only...
	(timerclear, timerisset, timercmp): ...these functional macros, and...
	(struct timeval): ...this data type; inhibit redefinition on...
	[defined _SYS_TIME_H && _WINSOCK_H]: ...second reading.
	(_TIMEVAL_DEFINED): Do not define; it isn't required.

2017-09-09  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Factor BSD non-standard type definitions into common header.

	* profile/gmon.h [_BSDTYPES_DEFINED]: Delete block; include...
	* include/sys/bsdtypes.h: ...this new file instead; it defines...
	(u_char, u_int, u_long, u_short): ...these non-standard data types.

	* profile/gmon.c profile/mcount.c [_BSD_SOURCE]: Declare it;
	it suppresses warnings from <sys/bsdtypes.h>, about ill-advised
	non-standard BSD typedef usage.

2017-07-30  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Prepare and tag for release of MinGW.org WSL-5.0.1

	* All files (wsl-5.0.1-release): Tag assigned.

2017-07-12  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Automate testsuite dependency generation.

	* tests/Makefile.in (testsuite) [$srcdir/*.at]: Automatically
	enumerate all such wildcard matches as prerequisites, instead of...
	(headers.at, ansiprintf.at, logarithms.at, powerfunc.at): ...these,
	which were previously enumerated explicitly.

2017-06-05  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Automatically correct obsolete _XOPEN_SOURCE usage.

	* include/_mingw.h.in (__paste, __valueless): New macros; define them.
	(_XOPEN_SOURCE) [defined with no value]: Use them to attempt to deduce
	this obsolete usage; if detected, redefine it with a default assigned
	value of one, emulating -D_XOPEN_SOURCE command line definition.

2017-05-24  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Fix snprintf()/vsnprintf() -Wformat vs. multiple definition issue.

	* include/stdio.h (__mingw_stdio_redirect__): Add reference to...
	(__Wformat): ...this new macro; define it, such that it expands via...
	(__Wformat_mingw_printf, __Wformat_msvcrt_printf): ...these new macros,
	ultimately expanding to an attribute declaration, in terms of...
	(__Wformat_ms_vprintf, __Wformat_ms_vfprintf, __Wformat_ms_vsprintf)
	(__Wformat_ms_printf, __Wformat_ms_fprintf, __Wformat_ms_sprintf):
	...any one of these; they map to an ms_printf attribute, or...
	(__Wformat_vprintf, __Wformat_vfprintf, __Wformat_vsprintf)
	(__Wformat_printf, __Wformat_fprintf, __Wformat_sprintf): ...any one
	of these; they map conditionally to...
	[__GNUC__>=6] (__mingw_printf__): ...this new format attribute, or...
	[__GNUC__< 6]: ...nothing.
	(snprintf, vsnprintf): Revert 2017-01-30 inline definitions; add...
	(__Wformat_snprintf, __Wformat_vsnprintf): ...these attributes; they
	are also mapped conditionally, in this case to...
	[__GNUC__>=6] (__mingw_printf__): ...this, or...
	[__GNUC__< 6] (__gnu_printf__): ...this.

2017-03-14  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Refactor mingwrt and w32api common makefile content.

	* Makefile.in (mingwrt-srcdist-config-files): Rename it...
	(mingwrt-srcdist-common-files): ...as this phoney build rule.
	(shared_include_file): New macro; define it, and include named file.
	(configure, config.status, Makefile, config.status.missing, _mingw.h)
	(w32api.h, PACKAGE_VERSION_SCRIPT, PACKAGE_VERSION_FORMAT): Factor
	out; relocate them to new file in common parent directory...
	* ../Makefile.comm: ...here.

2017-03-09  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Fix generated header file dependencies.

	* Makefile.in (_mingw.h, w32api): Make them depend on changes in...
	[VERSION.m4]: ...this; package version changes are no longer made...
	[configure.ac]: ...here; delete associated prerequisite reference.
	(distclean-local): Delete them.

2017-03-09  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Strip optional DLLs, when staging for distribution.

	* Makefile.in (mingwrt-%-optist): Recursively make...
	(install-strip-$*-optional-dll): ...this internal target, not...
	(install-$*-optional-dll): ...this.

2017-03-08  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Prepare and tag for release of mingwrt-5.0 package set.

	* All files (wsl-5.0-release): Tag assigned.

2017-03-07  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Avoid -shared-libgcc dependencies in optional DLLs.

	* Makefile.in (dllname): Qualify it, by addition of...
	(LIBGCC_LINK_OPTION): ...this DLL name specific linking option macro.
	(libmingwex.dll.a): Force it to use -static-libgcc for associated DLL.

2017-02-27  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Support optional DLL builds from static libraries.

	* aclocal.m4 (MINGW_AC_SET_DLLVERSION): New macro; define it, and...
	* VERSION.m4: ...use it here, to enumerate the specifcations for...
	(MINGW_AC_ENUMERATE_DLLVERSION_SPECS): ...this collection of DLL
	version identification records.

	* Makefile.in (DLLVERSION): New macro; define default, and capture
	library specific variants, as generated by AC_SUBST output from...
	(MINGW_AC_ENUMERATE_DLLVERSION_SPECS): ...this configuration macro.
	(a2dll, dllname, dllsuffix): New macros; define them, together with
	new pattern rule using them, to create DLLs and import libraries from
	existing static object libraries; augment these with...
	(optional_dll_version): ...this further new macro, used by...
	(install-optional-dlls, install-mingwrt-optional-dlls)
	(install-libmingwex-optional-dll): ...these new installation rules...
	(uninstall-optional-dlls, uninstall-mingwrt-optional-dlls): ...and
	counterpart rules, to uninstall all such optional DLL files.
	(optional_dll_package): Further new macro; it is required by...
	(optdist, mingwrt-optdist, mingwrt-libmingwex-optdist): ...these new
	distribution rules; they create packages for optional DLLs.
	(dist): Add optdist.

	* configure.ac (MINGW_AC_ENUMERATE_DLLVERSION_SPECS): Invoke it.

2017-02-24  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Make floating point environment more robust.

	* CRT_fp8.c CRT_fp10.c: Delete them; both are replaced by...
	* CRT_fenv.c: ...this new common source file; it implements...
	(_CRT_fenv): ...this new global variable, with alternative definitions
	evaluated during application start-up, to assign one or other of...
	[FE_PC53_ENV, FE_PC64_ENV]: ...these, as the preferred default...
	[FE_DFL_ENV]: ...represented by this; replacement linkage for...
	(_fpreset): ...this MSVCRT.DLL function is no longer supported.

	* Makefile.in: Add new static pattern rule, for compiling...
	(CRT_fp8.$OBJEXT, CRT_fp10.$OBJEXT): ...each of these, from CRT_env.c

	* crt1.c (_gnu_exception_handler, __mingw_CRTStartup): Do not call...
	(_fpreset): ...this; its linkage was non-deterministically ambiguous.
	(fesetenv): Use this, unambiguously, instead; initially configure the
	floating point environment to the predefined state, as assigned to...
	[_CRT_fenv]: ...this new global variable; thereafter, reset to...
	[FE_DFL_ENV]: ...this ISO-C99 mandatory configuration.

	* include/float.h: Assert copyright; tidy layout.
	[_MINGW_FLOAT_H_]: Retain, but replace in guard macro usage by...
	[_MINGW_FLOAT_H]: ...this, conforming to preferred naming convention.
	[_BEGIN_C_DECLS, _END_C_DECLS]: Use them, as appropriate.
	(_fpreset): Add _CRTIMP attribute; it is resolved by MSVCRT.DLL
	(fpreset): Deprecate it; provide inline __LIBIMPL__ fall-back.

	* include/fenv.h: Assert copyright; tidy layout.
	[_FENV_H_]: Rename multiple inclusion guard macro, adopting...
	[_FENV_H]: ...this preferred stylistic naming convention.
	[_BEGIN_C_DECLS, _END_C_DECLS]: Use them, as appropriate.
	(FE_INVALID, FE_DENORMAL, FE_DIVBYZERO, FE_OVERFLOW, FE_UNDERFLOW)
	(FE_INEXACT, FE_ALL_EXCEPT, FE_TONEAREST, FE_DOWNWARD, FE_UPWARD)
	(FE_TOWARDZERO): Redefine them, in terms of enumerated bit positions.
	(FE_PD53_ENV, FE_PD64_ENV): New predefined environment selectors; they
	serve as initialization-time aliases, causing redefinition of...
	[FE_DFL_ENV]: ...this, as run-time alias for one or other of...
	[FE_PC53_ENV, FE_PC64_ENV]: ...these, respectively.

	* mingwex/fesetenv.c: Assert copyright; tidy layout.
	(fesetenv) [FE_PD53_ENV || FE_PD64_ENV]: Handle them, assigning to...
	(FE_DFL_ENV): ...this ISO-C99 mandatory configuration, representing...
	(fenv_default): ...the value of this new static variable.
	(_fpreset): Call it directly; now always resolved by MSVCRT.DLL, so...
	(*_imp__fpreset): ...this indirection becomes unnecessary.

2017-02-21  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Make mingwrt and w32api test suites consistent.

	* Makefile.in (test): New rule; define it as a synonym for...
	(check tests): ...these, so maintaining consistency with w32api.

2017-02-16  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Work around GCC bug; force C++11 to support std::wcstof().

	* include/_mingw.h [_ISOC99_SOURCE && __cplusplus >= 201103L]
	[__GNUC__ < 6] (_GLIBCXX_HAVE_WCSTOF): Define it to 1; it is required
	because, prior to GCC-6, GCC's configuration process fails to specify
	it correctly, and so invalidates its own <string> header file.

2017-02-12  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Support brace expansion in globbing patterns.

	* include/glob.h (GLOB_BRACE): New manifest constant; define it...
	(__GLOB_FLAG__): ...in terms of this macro.

	* mingwex/glob.c (glob_match): Reindent, with preamble invoking...
	(glob_brace_expand): ...this new static inline function; implement it.
	(GLOB_INIT, GLOB_FREE): Redefine them, relating them to...
	(__GLOB_FLAG_OFFSET_HIGH_WATER_MARK): ...this.

	* setargv.c (__mingw32_setargv) [_CRT_glob]: Check if it includes...
	[GLOB_CASEMATCH | GLOB_BRACE]: either of these; remove check for...
	[__CRT_GLOB_CASE_SENSITIVE__]: ...this defunct option.

	* include/_mingw.h.in (GLOB_BRACE): Note its use in _CRT_glob.
	(GLOB_CASEMATCH): Likewise; this replaces all former usage of...
	(__CRT_GLOB_CASE_SENSITIVE__): ...this; delete definition.

2017-02-11  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Refactor <getopt.h> and <unistd.h> shared declarations.

	* include/getopt.h: Assert copyright.
	(_BEGIN_C_DECLS, _END_C_DECLS): Use as appropriate.
	(__GETOPT_H__, __GETOPT_LONG_H__): Delete them; replace them with...
	(_GETOPT_H): This new macro; it guards the entire file, except when...
	[__UNISTD_H_SOURCED__]: ...do not activate it; hence when...
	[!_GETOPT_H]: ...do not expose API declarations for...
	(getopt_long, getopt_long_only): ...these functions.
	[_GETOPT_H && _UNISTD_H]: Skip second pass API declarations for...
	(getopt): ...this function.

	* include/unistd.h: Use the #include "..." form when including...
	(io.h, process.h, getopt.h): ...these, to ensure correct association.
	(ftruncate): Map it directly to MSVCRT.DLL's _chsize() entry point.

2017-02-10  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Avoid unnecessary duplication of configuration files.

	* Makefile.in (vpath install-sh): Define it; it matches...
	(vpath %.m4): ...this; add $top_srcdir/..; search it first; delete
	rule for creating duplicate file reference links in $top_srcdir.
	(configure): Add '-I ..' option, when running autoconf.
	(mingwrt-srcdist-package-files): Remove dependencies on...
	(aclocal.m4 VERSION.m4 install-sh): ...these; reinstate them in...
	(mingwrt-srcdist-config-files): ...this new distributable files
	enumeration goal; add it as a new prerequisite of...
	(mingwrt-srcdist-files): ...this.

2017-02-07  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Ensure selective inclusion of the correct <strings.h>

	* include/string.h: Use "..." form for selective inclusion of ...
	(strings.h): ...this, to ensure that we get our own version, avoiding
	any inappropriate alternative which may have been insinuated into the
	system header include path.

2017-02-04  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Resolve a global variable naming inconsistency.

	* mingwex/ofmt.c (__mingw_output_format_flag): Rename it as...
	(__mingw_output_format_flags): ...this, at point of definition, and
	update all references, to maintain consistency with usage...
	* mingwex/ofmtctl.c (__mingw_output_format_flags): ...here.

	* mingwex/stdio/pformat.c: Update references.

2017-01-30  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Implement strerror_r()/strerror_s() API.

	* mingwex/strerror_r.c: New file; it implements...
	(strerror_r): ...this new POSIX.1-2001 conforming function.

	* include/string.h (strerror_s): Add function prototype, subject to...
	[_MSVCR80_DLL || _WIN32_WINNT_VISTA]: ...this DLL version dependency;
	otherwise implement an inline wrapper function to emulate it, using...
	[_POSIX_C_SOURCE > 200112L] (strerror_r): ...this; add prototype.

	* Makefile.in (libmingwex.a): Add strerror_r.$OBJEXT

2017-01-30  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Avoid -Wformat noise from snprintf() and vsnprintf()

	* include/stdio.h (snprintf, vsnprintf): Add inline implementations;
	they redirect to "__mingw_" prefixed alternatives, so suppressing the
	effect of automatic format attribute recognition.

2017-01-30  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Remove duplicate libmingwex.a entries.

	* mingwex/jmpstub.sx (DLLENTRY): Interpret it.

	* Makefile.in (jmpstub_awk_script): Handle DLLENTRY.
	(libmingwex.a): Remove explicit object file references to...
	(snwprintf, vsnwprintf): ...these.

	* include/stdio.h (snwprintf, vsnwprintf): Map them as __JMPSTUB__
	references to MSVCRT.DLL entry points, via DLLENTRY references to...
	(_snwprintf, _vsnwprintf): ...these, respectively.

	* mingwex/snwprintf.c: Redundant file; delete it.
	* mingwex/vsnwprintf.c: Likewise.

2017-01-29  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Clean up <limits.h> header file.

	* include/limits.h: Tidy layout; assert copyright.
	(#pragma GCC system_header): Declare it as being such.
	(_LIMITS_H_): Rename this multiple inclusion guard macro...
	(_LIMITS_H): ...to adopt this preferred form.
	[__STDC_VERSION__ >= 199901L]: Infer it...
	[_ISOC99_SOURCE]: ...from this.

2017-01-29  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Expose C99 features required by C++11; fix issue [#2335]

	* include/_mingw.h.in (_ISOC99_SOURCE): Ensure it is defined for...
	[__cplusplus >= 201103L]: ...this conformance level, in addition to...
	[__STDC_VERSION__>= 199901L || _POSIX_C_SOURCE >= 200112L]: ...these.
	[_GLIBCXX_USE_C99]: Force it for -std=c++11, subject to...
	[__GNUC__ < 6]: ...this.

	* include/ctype.h (isblank): Declare it only if...
	[_ISOC99_SOURCE]: ...this, thus simplifying declarative condition.
	* include/wctype.h (iswblank) [_ISOC99_SOURCE]: Likewise.
	* include/inttypes.h (SCNd8, SCNdLEAST8, SCNdFAST8, SCNi8, SCNiLEAST8)
	(SCNiFAST8, SCNo8, SCNoLEAST8, SCNoFAST8, SCNx8, SCNxLEAST8, SCNxFAST8)
	(SCNu8, SCNuLEAST8, SCNuFAST8) [_ISOC99_SOURCE]: Likewise.

2017-01-28  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Make strnlen() and wcsnlen() declaratively consistent.

	* include/string.h (strnlen): Do not expose its declaration, unless...
	[_POSIX_C_SOURCE >= 200809L]: ...this feature test is enabled.

2017-01-28  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Implement wcsnlen() API per feature request [#2332].

	* mingwex/strnlen.s: Rename it as...
	* mingwex/strnlen.sx: ...this; use C preprocessor logic to adapt...
	(__mingw_strnlen): ...this existing function implementation for use...
	[_UNICODE] (__mingw_wcsnlen): ...as this.

	* include/wchar.h [_POSIX_C_SOURCE >= 200809L] (wcsnlen): Declare...
	[__MSVCRT_VERSION__>=__MSVCR80_DLL]: ...using MS DLL implementation...
	[!__MSVCRT_VERSION__>=__MSVCR80_DLL] (__mingw_wcsnlen): ...otherwise,
	declare this, with inline __JMPSTUB__ implementation, providing...
	(wcsnlen): ...this.

	* Makefile.in (wcsnlen.$OBJEXT): New build rule.
	(libmingwex.a): Add wcsnlen.$OBJEXT as new prerequisite.
	(libmoldname.a, libmoldnamed.a): Add __JMPSTUB__ wrappers.
	(libmoldname70.a, libmoldname70d.a): Likewise.
	(libmoldname71.a, libmoldname71d.a): Likewise.

	for all other MSVC non-free associated oldname import libraries.
	(vpath): Add $srcdir/mingwex for %.sx; hence mapping for...
	(jmpstub.sx): ...this becomes redundant; delete it.

2017-01-26  Jason Hood  <jadoxa@yahoo.com.au>

	Honour GLOB_CASEMATCH for globbing sets; cf. issue [#2327].

	* include/glob.h (GLOB_CASEMATCH): Update comment.
	* mingwex/glob.c (glob_case_match): Move before, and use it in...
	(glob_in_set): ...this function, to test characters in the set.

2017-01-26  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Avoid snprintf() overhead in directory stream functions.

	* mingwex/dirent.c (dirent_update): Do not use either snprintf() or
	snwprintf() functions when updating dd->d_name and dd->d_namlen data;
	emulate them instead, using a lightweight inline char-by-char counted
	copy loop, operating on char or wchar_t data as appropriate.
	(DIRENT_ASSIGN_NAME): Macro no longer required; delete it.
	(NUL): New manifest constant; define it.

2017-01-26  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Avoid #include_next misbehaviour; cf. MinGW-Bug [#2330]

	* include/ctype.h (wctype.h): Use "..." form of #include, rather than
	the <...> form; we must include our own corresponding mingwrt version
	of this subsidiary header, and avoid any bogus alternative which may
	have been insinuated earlier in the system header path.

	* include/string.h (wchar.h): Likewise.

2017-01-25  Jason Hood  <jadoxa@yahoo.com.au>

	Correct quoted backslash handling, per bug [#2328].

	* setargv.c (__mingw32_setargv): Within single quotes, backslashes
	should be interpreted literally; copy them as-is.

2017-01-25  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Use C99 blanks as default argv separators, per issue [#2329].

	* setargv.c [_ISOC99_SOURCE]: Require it.
	(__mingw32_setargv): Separate command line arguments based on...
	[(quoted == 0) && isblank( c )]: ...this condition, instead of on...
	[(quoted == 0) && isspace( c )]: ...this, so that only blanks, rather
	than any whitespace characters, serve as default argument separators.

2017-01-10  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Correct <strings.h> preprocessor logic; fix bug [#2322]

	* include/strings.h (_stricmp, _strnicmp): Always declare, unless...
	[__STRICT_ANSI__ && __NO_INLINE__]: ...both of these are defined.

2016-11-28  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Implement POSIX.1 compatible setenv() and unsetenv() functions.

	* mingwex/setenv.c: New file; it implements...
	(__mingw_setenv): ...this function, providing common code for...
	* include/stdlib.h [_POSIX_C_SOURCE >= 200112L] (setenv, unsetenv):
	...these user visible functions, implemented as __CRT_ALIAS inlines;
	qualify them as __JMPSTUB__ and __LIBIMPL__ respectively, so ensuring
	that their corresponding external representations are automatically
	added to libmingwex.a

	* Makefile.in (libmingwex.a): Add setenv.$OBJEXT

2016-11-27  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Work around another C++11 compliance issue; fix bug [#2321].

	* include/excpt.h (__try1_setup, __except1_teardown): Add spaces to
	separate each use of '__wsize' and '__ts' macros from all surrounding
	string literals, to ensure that C++ parses them as distinct tokens.

2016-11-21  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Replace defective powf() and powl() function implementations.

	* mingwex/math/powf.c mingwex/math/powl.c: Delete; replaced by...
	* mingwex/math/pow_generic.sx: ...this new file; it implements...
	(__x87pow): ...this generic power function back-end, serving...
	(pow, powf, powl): ...each of these front-end entry points.

	* Makefile.in (libmingwex.a): Add x87pow.$OBJEXT

	* include/math.h (powf): Remove inline implementation; it no longer
	offers any inline advantage.

2016-11-18  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Implement unit tests for power functions.

	* tests/testsuite.at.in: m4_include...
	* tests/Makefile.in (testsuite): ...and add dependency on...
	* tests/powerfunc.at: ...this new file; it specifies unit tests to
	check POSIX.1-2008 compliance of results and errno assignment from...
	(pow, powf, powl): ...each of these functions.

2016-11-14  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Add POSIX compliant errno assignments to log functions.

	* include/errno.h: Make it assembly language compatible.
	[__ASSEMBLER__]: Omit <_mingw.h>; do not declare prototype for...
	(_errno): ...this accessor function; the declaration is syntactically
	invalid, in assembly language code.

	* mingwex/math/errno.sx: New file; when included by other assembly
	language files, it provides bindings for assignement of any constant
	defined in <errno.h> to the global errno variable, facilitated by...
	(errno): ...this new GAS macro.

	* mingwex/math/log_generic.sx: New file; it provides a generic back
	end implementation for multiple logarithmic functions, accessed via...
	(___x87log, ___x87log_chk): ...this pair of entry points, serving...
	(log, logf, log): ...each of these primary functions; it replaces...
	* mingwex/math/logf.s mingwex/math/logl.s: ...these; delete them.

	* mingwex/math/log1p_generic.sx mingwex/math/log10_generic.sx
	* mingwex/math/log2_generic.sx: New files; each acts as a wrapper for
	log_generic.sx, providing the front end entry stubs for each of...
	(log1p, log1pf, log1pl, log10, log10f, log10l, log2, log2f, log2l):
	...these functions; thus, they provide complete replacements for...
	* mingwex/math/log1p.s mingwex/math/log1pf.s mingwex/math/log1pl.s
	* mingwex/math/log10f.s mingwex/math/log10l.s mingwex/math/log2.s
	* mingwex/math/log2f.s mingwex/math/log2l.s: ...these; delete them.

	* mingwex/math/x87cvt_generic.sx: New file; it implements...
	(___x87cvt, ___x87cvtf): ...this pair of return value conversion
	routines, for conversion from the FPU's internal REAL10 data format,
	to REAL8 and REAL4, for double and float functions respectively.

	* Makefile.in (libmingwex.a): Add dependencies on...
	(x87cvt.$OBJEXT), x87cvtf.$OBJEXT), x87log.$OBJEXT), x87logf.$OBJEXT):
	...these object modules; implement pattern rule to build them from...
	(x87cvt_generic.sx, log_generic.sx): ...these generic sources; also
	provide for building the respective log function entry stubs from
	their respective generic sources.

2016-11-08  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Implement unit tests for logarithmic functions.

	* tests/testsuite.at.in: m4_include...
	* tests/Makefile.in (testsuite): ...and add dependency on...
	* tests/logarithms.at: ...this new file; it specifies unit tests to
	check POSIX.1-2008 compliance of results and errno assignment from...
	(log, logf, logl, log1p, log1pf, log1pl, log10, log10f, log10l, log2)
	(log2f, log2l): ...each of these functions.

2016-11-02  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Implement unit tests for ANSI printf() functions.

	* tests/Makefile.in (testsuite): Add dependency for...
	* tests/ansiprintf.at: ...this new file, and...
	* tests/testsuite.at.in: ...m4_include it.

2016-11-01  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Fix another printf() hex-float formatting bug.

	* mingwex/stdio/pformat.c (__pformat_emit_xfloat)
	[stream->flags & PFORMAT_ZEROFILL]: Ignore this; it should be...
	[(stream->flags & PFORMAT_JUSTIFY) == PFORMAT_ZEROFILL]: ...thus.

2016-10-30  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Merge post 2016-10-18 updates from legacy branch.

	* include/io.h include/wchar.h: Updated.
	* mingwex/stdio/pformat.c: Likewise.

2016-10-30  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Work around MSDN inconsistencies in _finddata_t naming.

	* include/io.h (_finddata64_t, _wfinddata64_): Define them
	respectively as aberrant alternative data type names for each of...
	(__finddata64_t, __wfinddata64_t): ...these original names.
	(_wfinddata32_t): Similarly, define this with...
	(__wfinddata32_t): ...this alternative name.

	* include/wchar.h (_wfinddata32_t): Correct references in comments.

2016-10-30  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Fix a potentially infinite printf() format conversion loop.

	* mingwex/stdio/pformat.c (__pformat_emit_xfloat)
	[value.__pformat_fpreg_mantissa == 0]: Do not attempt to normalize
	it; there are no 1-bits to promote, so repeated shifting until one
	appears in most significant position will never terminate.

2016-10-18  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Merge mingwrt-3.22.4 updates into 5.0-active branch.

	* configure.ac: Preserve original 5.0-active state.
	* include/wchar.h: Update per 2016-10-17 commits.

2016-10-17  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Prepare and tag mingwrt-3.22.4 patch release.

	* configure.ac (AC_INIT): Increment patch level.

2016-10-17  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Resolve an ANSI mode <string.h> vs. <wchar.h> conflict.

	* include/wchar.h [!(_WCHAR_H && _STRING_H)]: Change condition...
	[!(_WCHAR_H && (_STRING_H && !__STRICT_ANSI__))]: ...to this; the
	guarded declarations are not exposed by including <string.h> when...
	[__STRICT_ANSI__]: ...this is defined; hence, we must declare them
	when including <wchar.h>, even after including <string.h>

2016-10-14  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Add dependency tracking for tests/Makefile.

	* tests/Makefile.in (top_builddir): Define it.
	(Makefile): Add automatic rebuild rule, tracking both srcdir and
	top_builddir prerequisite changes.

2016-10-14  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Correct a minor typographic error.

	* tests/atlocal.in (autoconf_input): Replace invalid AC_SUBST tag...
	(configure_input): ...with this correctly named alternative.

2016-10-14  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Merge mingwrt-3.22.3 updates into 5.0-active branch.

	* configure.ac: Preserve original 5.0-active state.
	* include/_mingw.h.in include/string.h include/sys/types.h
	* include/io.h: Update per 2016-10-13 commits.

2016-10-13  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Prepare and tag mingwrt-3.22.3 patch release.

	* configure.ac (AC_INIT): Increment patch level.

2016-10-13  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Emulate glibc <string.h> POSIX.1 non-compliance.

	* include/_mingw.h.in (_EMULATE_GLIBC): New feature test macro.
	[_GNU_SOURCE || _BSD_SOURCE || !__STRICT_ANSI__]: Enable it when...
	[_XOPEN_SOURCE || _POSIX_C_SOURCE || _POSIX_SOURCE]: ...none of
	these have been pre-defined by the user.

	* include/string.h [_EMULATE_GLIBC]: Include <strings.h> in full...
	(strcasecmp, strncasecmp): ...so prototypes for these are declared.
	[!_EMULATE_GLIBC]: Preserve partial <strings.h> include, guarded by...
	[__STRING_H_SOURCED__]: ...this context selector, so suppressing the
	declarations of those function prototypes.

2016-10-13  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Resolve some non-ANSI typedef omissions.

	* include/sys/types.h (off_t, ssize_t): Always typedef them when...
	[_POSIX_C_SOURCE || !_NO_OLDNAMES]: ...either of these prevails.

	* include/io.h (_fsize_t): Do not suppress its typedef when...
	[__STRICT_ANSI__]: ...this compiler option applies, irrespective of...
	[!(_IO_H && _WCHAR_H)]: ...this, which otherwise causes supression.

2016-09-20  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Prepare and tag mingwrt-3.22.2 patch release.

	* configure.ac (AC_INIT): Increment patch level.
	* config.guess config.sub: Delete, per 2016-07-16 commit.
	* include/stdlib.h: Backport, per 2016-09-14 commit.
	* include/wchar.h: Backport, per 2016-09-17 commits.

2016-09-17  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Add missing <wchar.h> declarations when compiling C++.

	* include/wchar.h (fwide, mbsinit, wmemset, wmemchr, wmemcpy)
	(wmemmove, wcstoll, wcstoull): Declare each of these for either of...
	[_ISOC99_SOURCE || __cplusplus]: ...these conditions, rather than...
	[_ISOC99_SOURCE]: ...this alone.

2016-09-17  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Stricter <wchar.h> ISO-C99 conformity filtering.

	* include/wchar.h [__STRICT_ANSI__]: Do not include any part of...
	(direct.h, io.h, sys/stat.h, locale.h, process.h): ...any of these.

2016-09-14  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Relax strict ISO-C conformity to facilitate C99 support.

	* include/stdlib.h (_atoi64, _exit) [__STRICT_ANSI__]: Convention
	dictates that the Microsoft specific functions should not be declared;
	however, C99 provides equivalents in atoll() and _Exit(), for which we
	gratuituously use them to provide inline implementations; thus...
	[_ISOC99_SOURCE && !__NO_INLINE__]: ...declare them anyway.

2016-09-13  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Suppress expected header warnings when running testsuite.

	* include/dir.h include/dos.h [__IN_MINGWRT_TESTSUITE__]: New feature
	test; do not emit warning messages, which declare this pair of headers
	to be obsolete.  These warnings are expected, but their format may not
	be deterministically predictable; there is no reason to fail any test
	on account of any such expected warning message.

2016-09-13  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Create a preliminary autotest framework.

	* configure.ac (AC_TESTDIR): Initialize tests subdirectory.
	(AC_PROG_CXX): Identify C++ compiler; the testsuite will use it.
	(AC_CHECK_PROG): Check availability of autom4te; specify fallback.
	(AC_CONFIG_FILES): Add instantiation requests for tests/atlocal,
	tests/Makefile, and tests/testsuite.at.tmp

	* tests/testsuite.at.in tests/atlocal.in tests/headers.at
	* tests/Makefile.in: New files; implement them.

	* Makefile.in (check, check-recursive, tests): Implement new goals.
	(mingwrt-srcdist-files): Subdivide package files complement into...
	(mingwrt-srcdist-package-files): ...this original collection, and...
	(mingwrt-srcdist-testsuite-files): ...this additional set.

	* test_headers.c: Superseded by autotest; delete it.

2016-08-25  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Add pthreads-win32 courtesy support hooks.

	* include/errno.h: Assert copyright; tidy layout.
	(_ERRNO_H_): Rename this repeat inclusion guard macro as...
	(_ERRNO_H): ...this, conforming to preferred naming convention.
	[__PTW32_H]: Include "ptw32_errno.h".

	* include/time.h [__SCHED_H_SOURCED__]
	(struct timespec): Typedef it selectively; do not define...
	(_TIME_H): ...this.

2016-08-07  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Implement POSIX printf() feature per request [#2310].

	* mingwex/stdio/pformat.c [WITH_XSI_FEATURES]: Delete references.
	(PFORMAT_GROUPED): New manifest constant; define it.  It previously
	appeared in an occluded XSI feature reference, but is now required.
	(__pformat_t.tslen, __pformat_t.tschr, __pformat_t.grouping): New
	structure member fields; they maintain control state as set up by...
	(__pformat_enable_thousands_grouping): ...this new internal function.
	(__pformat_int_bufsiz): Use it; it may request a size increment.
	(__pformat_emit_digit, __pformat_emit_punct): New functions; they
	handle output of digits, radix point, and thousands digits separator
	punctuation for all numeric conversion formats, thus replacing...
	(__pformat_emit_numeric_value, __pformat_emit_radix_point): ...these;
	delete them, and update all callers to use appropriate replacements.
	(__pformat_int) [PFORMAT_GROUPED]: Add and emit group separators.
	(__pformat_xint_bufsiz): New internal function; it serves in place of
	__pformat_int_bufsiz(), for those integer data conversion formats
	which explicitly do not support thousands digits grouping, hence...
	(__pformat_xint): ...use it, rather than __pformat_int_bufsiz().
	(__pformat_adjust_for_grouping): New internal function; it adjusts the
	__gdtoa radix point index for fixed point conversion formats, to allow
	for the insertion of thousands digits group separators, hence...
	(__pformat_emit_float): ...use it, and emit separators as appropriate.
	(__pformat_emit_efloat) [PFORMAT_GROUPED]: Explicitly disable it.
	(__pformat): Initialise stream references for __pformat_t.grouping,
	__pformat_t.tslen, and _pformat_t.tschr, on entry; release any memory
	allocated for __pformat_t.grouping, when done.

2016-08-01  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Implement POSIX conforming getline() and getdelim() functions.

	* mingwrt/mingwex/stdio/getdelim.c: New file.
	* mingwrt/man/getline.3.man: Likewise.

	* mingwrt/include/stdio.h [_POSIX_C_SOURCE >= 200809L]
	(getdelim): New function, implemented externally; declare prototype.
	(getline): New function; declare prototype; implement as __CRT_ALIAS
	inline, with __LIBIMPL__ external representation.

	* mingwrt/Makefile.in (libmingwex.a): Add getdelim.$OBJEXT
	(mingwrt-man$man3ext): Add manpage dependency references to create...
	(getline.$man3ext, getdelim.$man3ext): ...these; declare them as
	distributable duplicates, to be generated from...
	(getline.$man3ext.man): ...this common source.

2016-08-01  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Merge mingwrt-3.22.1 legacy updates to 5.0-active branch.

	* mingwex/math/powl.c: Update per issue [#2036] workaround.
	* mingwex/stdio/pformat.c: Likewise, per issue [#2309] resolution,
	and subsequent 2016-07-24 optimization.

2016-07-31  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Prepare and tag all files for release of mingwrt-3.22.1.

	* configure.ac (AC_INIT): Adjust package version number; append
	patch level identification.

2016-07-31  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Interim workaround for issue [#2306].

	* mingwex/math/powl.c: Tidy layout; correct indentation.
	(powl, reducl): Use ISO-C declaration syntax; K&R is obsolescent.
	(powl) [OVERFLOW]: Correct representation of return value, using...
	(INFINITYL): ...this manifest constant value, instead of...
	(MAXNUML): ...this.

2016-07-24  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Optimize printf() field width accumulation function.

	* mingwex/stdio/pformat.c (__imul10plus): Omit multiply by ten on
	already accumulated zero total; it is unnecessary, since ten times
	zero is still zero.

2016-07-22  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Fix printf() field width parsing regression issue [#2309].

	* mingwex/stdio/pformat.c (__imul10plus): Coerce any accumulated
	negative total to zero; the only negative value to be handled is...
	(PFORMAT_IGNORE): ...this; it ceases to be applicable, on first call
	to __imul10plus(), to accumulate field width or precision.

2016-07-19  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Update install-sh to match mingw.org/build-aux package.

	* install-sh: Delete it; use version in parent directory instead,
	recreating local copy, (as symlink, if supported), on demand.

2016-07-17  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Eliminate redundant configuration files.

	* aclocal.m4 VERSION.m4: Delete them; restore them on demand, via...
	* Makefile.in ($top_srcdir/../%): ...this symlink dependency rule.

	* configure.ac (AC_PROG_LN_S): Add configuration check.

2016-07-17  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Merge mingwrt-3.22 packaging correction to 5.0-active branch.

2016-07-17  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Correct mingwrt-3.22 source package subdirectory omission.

	* Makefile.in (mingwrt-srcdist-files): Add msvcrt-xref.

2016-07-16  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Discard redundant config.guess and config.sub files.

	* config.guess config.sub: Delete them; they are no longer required.

2016-07-16  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Merge recent legacy branch updates to 5.0-active branch.

	* Makefile.in include/ctype.h include/excpt.h include/stdint.h
	* include/glob.h include/limits.h include/locale.h include/search.h
	* include/stdio.h include/stdlib.h include/wchar.h include/wctype.h
	* include/sys/param.h include/sys/stat.h mingwex/tdelete.c
	* mingwex/tfind.c mingwex/tsearch.c mingwex/twalk.c: Updated.

2016-07-14  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Prepare and tag all files for release of mingwrt-3.22.

	* configure.ac (AC_INIT): Adjust package version number.

2016-07-14  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Preserve kludge to evade GCC build failure on S_ISBLK misuse.

	* include/sys/stat.h (_NO_UNSUPPORTED): New feature test macro; it
	should be user defined, if desired, before inclusion; leave undefined.
	[!_S_IFBLK && !_NO_UNSUPPORTED && !_NO_OLDNAMES] (S_ISBLK): Define it,
	as appropriate for POSIX conforming usage; do not poison it.

2016-07-10  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Fix C++ strict type checking inconsistency in <glob.h>

	* include/glob.h (__ERRFUNC_P): New private macro; define it to match
	the type signature of the error function pointer, to be passed to...
	(glob): ...this function; use it to correctly represent error function
	pointer argument in inline implementation.

2016-07-09  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Factor out <ctype.h> vs. <wctype.h> duplicate elements.

	* include/ctype.h: Assert copyright; tidy layout.
	[!_CTYPE_H_]: Do not evaluate; rename macro to be tested, as...
	[!_CTYPE_H]: ...this preferred multiple inclusion guard macro name.
	(__CTYPE_H_SOURCED__): New macro; define it, and include <wctype.h>,
	so requesting partial inclusion, to retrieve definitions for...
	(_ALPHA, _BLANK, _CONTROL, _DIGIT, _HEX, _LOWER, _PUNCT, _SPACE)
	(_UPPER, WEOF): ...these macros; hence, do not define them locally.
	(wint_t, wchar_t, wctype_t): Likewise these type definitions...
	(iswalnum, iswalpha, iswascii, iswblank, iswcntrl, iswctype)
	(iswdigit, iswgraph, iswlower, iswprint, iswpunct, iswspace)
	(iswupper, iswxdigit, towlower, towupper, is_wctype): ...these function
	prototypes, and corresponding inline alternative implementations.
	(_BEGIN_C_DECLS, _END_C_DECLS): Use these as appropriate.
	[__MSVCRT_VERSION__<=__MSVCR70_DLL]: Likewise.

	* include/wctype.h: Assert copyright; tidy layout.
	[!_WCTYPE_H_]: Do not evaluate; rename macro to be tested, as...
	[!_WCTYPE_H]: ...this preferred multiple inclusion guard macro name;
	do not define it when partial inclusion only is selected, by...
	[__CTYPE_H_SOURCED__]: ...this; thence define only...
	(_ALPHA, _BLANK, _CONTROL, _DIGIT, _HEX, _LOWER, _PUNCT, _SPACE)
	(_UPPER): ...these character characterisation macros...
	(wint_t, wchar_t, wctype_t): ...these type definitions...
	(iswalnum, iswalpha, iswascii, iswblank, iswcntrl, iswctype)
	(iswdigit, iswgraph, iswlower, iswprint, iswpunct, iswspace)
	(iswupper, iswxdigit, towlower, towupper): ...these function
	prototypes, with corresponding inline alternative implementations...
	(is_wctype): ...this further prototype, qualified as deprecated...
	(WEOF): ...and this status reporting macro.
	(_ctype, _pctype, _pctype_dll, _imp___ctype, _imp___pctype): Delete
	declarations, and associated definitions; they do not belong here.
	(isleadbyte): Likewise, this Microsoft specific function prototype...
	(_LEADBYTE): ...and this associated character classification macro.
	(_BEGIN_C_DECLS, _END_C_DECLS): Use these as appropriate.

2016-07-04  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Do not pass MAKEFLAGS explicitly, when invoking recursive make.

	* Makefile.in (install-strip, uninstall): Delete explicit $(MAKEFLAGS)
	references from $(MAKE) command lines; make passes them implicitly.

2016-07-03  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Rework tsearch and friends; resolve issues [#1512] and [#1576].

	* include/search.h: Assert copyright; tidy layout.
	(_SEARCH_H_): Rename this multiple inclusion guard macro...
	(_SEARCH_H): ...to conform to this preferred standard convention.
	(__search_comparator): New function prototype typedef; it provides a
	convenient shorthand notation for argument declarations in functions
	which require a comparator function pointer; use it where appropriate.
	(tsearch, tfind, tdelete) [__MINGW_ATTRIB_NONNULL]: Apply to arguments
	#2 and #3; was previously incorrectly applied to arguments #1 and #3.
	(twalk) [__MINGW_ATTRIB_NONNULL]: Apply to both arguments #1 and #2.
	[_SEARCH_PRIVATE] (__MINGW_ATTRIB_NONNULL): Suppress its effect, to
	ensure that GCC does not optimize away checks within implementation.
	(_BEGIN_C_DECLS, _END_C_DECLS): Use these.

	* mingwex/tdelete.c: Tidy layout.
	(tdelete): Reimplement it as a thin wrapper around...
	(__tdelete): ...this; it encapsulates the original implementation as a
	__CRT_ALIAS (inline) function, to simplify void ** --> node_t ** casts.
	Remove unnecessary non-null assertions for arguments #1 and #3; prefer
	to validate arguments #2 and #3 internally, and simply return NULL if
	necessary; hence, do not include <assert.h>

	* mingwex/tfind.c: Tidy layout.
	(tfind): Similarly reimplement it as a thin wrapper around...
	(__tfind): ...this __CRT_ALIAS (inline) encapsulation of the original.
	Add non-null validation for argument #3; do not include <assert.h>

	* mingwex/tsearch.c: Tidy layout.
	(tsearch): Once again, reimplement it as a thin wrapper around...
	(__tsearch): ...this __CRT_ALIAS variant.  Add non-null validation for
	argument #3; do not include <assert.h>

	* mingwex/twalk.c: Tidy layout; do not include <assert.h>

2016-06-28  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Rework __try1/__except1 to resolve issue [#1328].

	* include/excpt.h: Assert copyright; tidy layout.
	(_EXCPT_H_): Multiple inclusion guard macro renamed to...
	(_EXCPT_H): ...this; update all references as appropriate.
	(_BEGIN_C_DECLS, _END_C_DECLS): Use these.
	(__typecast_alloca): New macro; define it, casting return type of...
	(__builtin_alloca): ...this to a specified data type; use it in...
	(__try1_setup, __except1_teardown): ...these new macros; define them
	as parameterized templates, providing both -masm-att and -masm-intel
	syntax implementations, with host specific word size and register
	assignment parameter substitutions; use them to redefine...
	(__try1, __except1): ...each of these, using __builtin_alloca to avoid
	direct stack pushes when registering exception handlers; assign the
	template parameters as appropriate to support implementation for...
	[_WIN64, _WIN32]: ...either of these, as the host requires.

2016-06-17  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Merge Cygwin CVS updates to legacy branch.

	* include/stdio.h: Merge 2011-11-30 and 2012-08-02 commits.
	(getc, getchar, putc, putchar): Declare function prototypes.
	(fopen64, ftello64): Likewise; change implementation classification
	from __CRT_INLINE to __CRT_ALIAS, to avoid C++ emitted code bloat.
	(_lock_file, _unlock_file): Add prototypes; modify merge to...
	[__MSVCRT_VERSION__>=__MSVCR80_DLL]: ...require this.

	* include/stdint.h: Merge 2012-07-30 commit; include <_mingw.h>

	* include/excpt.h: Merge 2012-08-01 commit.
	(__try1, __except1) [_WIN64]: Add alternative implementations.

	* include/stdlib.h: Merge 2012-08-02 commit.
	[__MSVCRT__VERSION__>=__MSVCR70_DLL || _WIN32_WINNT >= _WINXP]
	(_strtoi64, _strtoui64, _wcstoi64, _wcstoui64): Declare prototypes.
	[__MSVCRT__VERSION__>=__MSVCR80_DLL || _WIN32_WINNT >= _VISTA]
	(_strtoi64_l, _strtoui64_l, _wcstoi64_l, _wcstoui64_l): Likewise...
	[!__have_typedef_locale_t] (__need_locale_t): ...and define to get...
	(locale_t): ...this, by selective inclusion of <locale.h>
	[__WCHAR_H_SOURCED] (_wcstoi64, _wcstoui64, _wcstoi64_l)
	(_wcstoui64_l): Make these function prototypes available for selective
	inclusion by...
	* include/wchar.h: ...this; merge 2012-08-02 commit.
	[__MSVCRT__VERSION__>=__MSVCR70_DLL || _WIN32_WINNT >= _WINXP]
	(_wcstoi64, _wcstoui64): Note availability of function prototypes via
	selective inclusion of their actual declarations from <stdlib.h>
	[__MSVCRT__VERSION__>=__MSVCR80_DLL || _WIN32_WINNT >= _VISTA]
	(_wcstoi64_l, _wcstoui64_l): Likewise.

	* include/limits.h: Merge 2012-08-02 commit.
	[__STRICT_ANSI__] (PATH_MAX): Suppress definition.

	* include/sys/param.h: Merge 2012-08-02 commit.
	[PATH_MAX not defined] (MAXPATHLEN): Define it explicitly.
	[PATH_MAX defined] (MAXPATHLEN): Define it as an alias.

2016-06-12  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Add typedef and access support for opaque locale_t objects.

	* include/locale.h (locale_t, _locale_t): Define opaque types.
	[__need_locale_t]: Make them selectively accessible; define...
	(__have_typedef_locale_t): ...this, when they are available.
	[_LOCALE_H] (_create_locale, _get_current_locale, _free_locale):
	Declare function prototypes, on direct <locale.h> inclusion only.
	[_LOCALE_H || _WCHAR_H] (_wcreate_locale): Likewise; this is to be
	visible on direct inclusion, or when including <wchar.h>

	* include/stdio.h [!(_STDIO_H && _WCHAR_T)]: Correct expression of...
	[__MSVCR80_DLL || _WIN32_WINNT_VISTA]: ...this subsidiary condition;
	for all cases when this is true, (including when [_STDIO_H] alone)...
	[!__have_typedef_locale_t] (__need_locale_t): ...define this, and
	include <locale.h>, for selective definition of...
	(locale_t): ...this.

2016-05-19  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Occlude unsupported _S_IFBLK feature; resolve issue [#1146].

	* include/sys/stat.h (_MINGW_S_IFBLK_KLUDGE): New feature test macro;
	do not define it, and strongly recommend that it remains undefined.
	[!_MINGW_S_IFBLK_KLUDGE] (_S_IFBLK, S_IFBLK): Do not define them.
	[!_MINGW_S_IFBLK_KLUDGE] (_S_ISBLK, S_ISBLK): Poison them.
	[_MINGW_S_IFBLK_KLUDGE] (_S_IFBLK, S_IFBLK): Adjust definitions; use a
	modified value, which is guaranteed to be impossible to match in...
	[_S_ISBLK, S_ISBLK]: ...these, thus enforcing false test results.

2016-05-18  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Fix a typo in a <sys/stat.h> inline function definition.

	* include/sys/stat.h [__MSVCRT_VERSION__ >= __MSVCR80_DLL]
	(stat): First argument declared as 'int'; should be 'const char *';
	correct it.

2016-05-12  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Synchronize package version management with Win32-API.

	* VERSION.m4: New file; link it to keep in sync with identically named
	file in top level composite package source directory; it defines...
	(__VERSION__): ...this new composite package version macro.

	* aclocal.m4: Link it, to keep in sync with identically named files in
	top level composite source and sibling w32api sub-package directories.
	(__VERSION__): New macro; include VERSION.m4 to define it.
	(__BUG_REPORT_URL__): New macro; define it.

	* configure.ac (AC_INIT): Assign package version and bug report URL...
	(__VERSION__, __BUG_REPORT_URL__): ...from these, as defined through
	automatic inclusion of aclocal.m4

	* Makefile.in (configure): Add dependency on VERSION.m4

2016-05-12  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Resolve some strnlen() implementation issues.

	* mingwex/strnlen.s (__mingw_strnlen) [!NUL]: Correct termination
	logic; should have used jnz, not jz, to skip endpoint adjustment on
	scanning past a terminal NUL character code.

	* include/string.h [_POSIX_C_SOURCE >= 200809L] (strnlen): Do not
	#define it, as this breaks GCC compilation; use __CRT_ALIAS instead,
	with __JMPSTUB__ referencing via "oldname" libraries.

	* Makefile.in (jmpstub_awk_script, libimpl_awk_script): Adapt to
	facilitate assignment of __JMPSTUB__ and __LIBIMPL__ references to
	libraries other than libmingwex.a
	(strnlen.jmpstub.$OBJEXT): Assign it to all "moldname" libraries prior
	to libmoldname80.a, in addition to libcoldname.a, as specified by the
	__JMPSTUB__ assignment within <string.h>

2016-05-03  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Enforce consistent specification of package version.

	* include/_mingw.h: Rename as...
	* include/_mingw.h.in: ...this build-time template file.
	(__MINGW32_VERSION): Redefine it, in terms of...
	(%PACKAGE_VERSION_LONG%): ...this substitution template.
	(__MINGW32_MAJOR_VERSION, __MINGW32_MINOR_VERSION)
	(__MINGW32_PATCHLEVEL): Likewise, redefine them in terms of...
	(%PACKAGE_VERSION_MAJOR%, %PACKAGE_VERSION_MINOR%)
	(%PACKAGE_VERSION_PATCH%): ...these.

	* configure.ac (AC_CONFIG_SRCDIR): Adjust for renamed file.
	(MINGW_AC_CONFIG_EXTRA_SRCDIR): Likewise, for similarly renamed
	w32api/include/w32api.h.in file.

	* Makefile.in (all-mingwrt-stage-1-only): Add dependency on...
	(_mingw.h, w32api.h): ...these; add rule to generate them, using...
	(PACKAGE_VERSION_SCRIPT, PACKAGE_VERSION_FORMAT): ...these new macros;
	they apply appropriate substitutions to the renamed template files.
	(install-mingwrt-headers): Explicitly add _mingwrt.h

2016-04-30  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Make strnlen() available for all MSVCRT.DLL versions.

	* msvcrt-xref/msvcrt.def.in (strnlen): Mark it as...
	(__MINGW_DLSYM): ...this, excluding its exposure in libmsvcrt.dll, and
	thus requiring a dlsym() lookup for versions which provide it.

	* include/string.h [__MSVCRT_VERSION__>=__MSVCR80_DLL] (strnlen):
	Declare prototype, for use from these non-free DLLs, otherwise...
	[_POSIX_C_SOURCE >= 200809L] (strnlen): Define it as an alias for...
	(__mingw_strnlen): ...this new libmingwex.a function.

	* mingwex/strnlen.s: New file; it implements...
	(__mingw_strnlen, __mingw_strnlen_s): ...these new functions.

	* Makefile.in (libmingwex.a): Add requirement for...
	(strnlen.$OBJEXT): ...this; add vpath specification for its source.

2016-04-26  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Use correct paths for partially included header files.

	* include/io.h include/process.h: Use 'iquote' #include "stdint.h", to
	ensure that we get stdint.h from the same include directory.
	* include/stdio.h: Likewise for #include "stdarg.h", and "sys/types.h"
	* include/wchar.h: Likewise for all of #include "stdio.h", "stdlib.h",
	"direct.h", "sys/stat.h", "io.h", "time.h", "locale.h", and "process.h"
	* include/dir.h include/dos.h: Likewise for #include "io.h"
	* include/direct.h: Likewise for #include "dos.h"

2016-04-13  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Generalize procedure for installing manpages.

	* man/dirname.man: Rename it as...
	* man/dirname.3.man: ...this, with inherent MANSECT specification.
	(TH): Use %PAGEREF% substitution for NAME, MANSECT, and DATE.
	(MS-Windows): Do not append \[tm]; it doesn't render well in Windows
	console. Further, correct typos; some syntactic adjustments.

	* Makefile.in (%:%.man): New rule; define it.
	(%.mancopy, %.mancopy-recursive): New rules; define and use with...
	(reference_manpage): ...this new macro, defining it to map...
	(dirname.3.man): ...this as the reference source file for both of...
	(basename.3, dirname.3): ...these installed manpages.
	(format_manpage): Add MANSECT and DATE to expansion of...
	(%PAGEREF%): ...this sed substitution pattern.

2016-04-12  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Update several incorrectly attributed header files.

	* include/direct.h include/io.h include/locale.h include/math.h
	* include/process.h include/stdio.h include/stdlib.h include/string.h
	* include/sys/stat.h include/sys/types.h include/time.h: Identify the
	original author as Colin Peters; Rob Savoye merely imported them into
	the original CVS repository, when he created it.

	* include/wchar.h: Likewise, imported by Rob Savoye, but the original
	source file is unattributed.

2016-04-11  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Eliminate all references to non-standard __NO_ISOCEXT macro.

	* include/math.h: Tidy layout.
	[!defined __NO_ISOCEXT]: Do not use this ugly double negative; in any
	case, we do not want to encourage users to define such implementation
	private macros; instead, prefer to make use of...
	[defined _ISOC99_SOURCE]: ...this glibc compatible feature test.
	[__STDC_VERSION__ >= 199901L]: Do not require this; it is implied, by
	definition, in _ISOC99_SOURCE.
	* include/stdio.h [!defined __NO_ISOCEXT]: Likewise; replace with...
	[defined _ISOC99_SOURCE]: ...this, throughout.

2016-04-10  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Make resetting of __need_typedef requests more robust.

	* include/sys/types.h [__need_off_t, __need___off64_t]
	[__need_ssize_t, __need_time_t]: Move corresponding #undef out of, and
	after the respective conditional blocks, which provide each associated
	typedef, so ensuring that any repeat request is properly reset.

	* include/time.h [__need_time_t]: Always delegate to <sys/types.h> for
	typedef, and reset of request, even in cases where...
	[_TIME_H]: ...this is already defined.

2016-04-10  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Add a missing comment terminator.

	* include/io.h [!(defined _IO_H && defined _WCHAR_H)]: Properly
	terminate the comment annotating the closing #endif statement.

2016-04-06  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Declare <dir.h> as formally deprecated.

	* include/dir.h: Assert copyright.
	(pragma GCC system_header): Declare it.
	(_DIR_H): Define as multiple inclusion macro.
	[!_DIR_H]: Emit "obsolete header" warning message.

2016-04-06  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Factor out <wchar.h> vs. <io.h> duplicate declarations.

	* include/io.h: Assert copyright; tidy layout.
	(_IO_H_): Rename this multiple inclusion guard macro...
	(_IO_H): ...to this preferred form; do not define it when...
	[__WCHAR_H_SOURCED__]: ...this is defined, in which case declare...
	(_waccess, _wchmod, _wcreat, _wopen, _wsopen, _wunlink, _wmktemp)
	(_wfindfirst, _wfindnext, _wfindfirst64, _wfindnext64, _wfindfirsti64)
	(_wfindnexti64, _wfindfirst32i64, _wfindnext32i64, _wfindfirst64i32)
	(_wfindnext64i32, _wfindfirst32, _wfindnext32, _findclose): ...only
	these function prototypes, common to <wchar.h>, together with...
	(_fsize_t, struct _wfinddata_t, struct _wfinddatai64_t)
	(struct __wfinddata64_t, struct _wfinddata64i32_t)
	(struct _wfinddata32i64_t, struct __wfinddata32_t): ...these
	requisite data type definitions.
	(pragma GCC system_header): Declare it.
	(__need_intptr_t): Define, and include <stdint.h> to get...
	(intptr_t): ...this typedef; neither define it locally, nor define...
	(_INTPTR_T_DEFINED): ...this; delete all references.
	(_FSIZE_T_DEFINED): Do not define it; delete all references; rather...
	[!(defined _IO_H && defined _WCHAR)] (_fsize_t): Define it.
	(FILENAME_MAX): Define it unconditionally.
	(__struct_finddata_t): New temporary macro; define and use it to...
	(struct _finddata_t, struct _wfinddata_t, struct _finddatai64_t)
	(struct _wfinddatai64_t, struct __finddata64_t, struct __wfinddata64_t)
	(struct _finddata64i32_t, struct _wfinddata64i32_t)
	(struct _finddata32i64_t, struct _wfinddata32i64_t)
	(struct __finddata32_t, struct __wfinddata32_t): ...define these.

	* include/wchar.h (_WFINDDATA_T_DEFINED): Do not define it; delete all
	references; filter out associated data type definitions, namely...
	(struct _wfinddata_t, struct _wfinddatai64_t): ...these, and also...
	(struct __wfinddata64_t, struct _wfinddata64i32_t): ...these, and...
	(struct _wfinddata32i64_t, struct __wfinddata32_t): ...these.
	(_WIO_DEFINED): Likewise, do not define it; delete all references;
	filter out associated function prototype declarations for all of...
	(_waccess, _wchmod, _wcreat, _wopen, _wsopen, _wunlink, _wmktemp)
	(_wfindfirst, _wfindnext, _wfindfirst64, _wfindnext64, _wfindfirsti64)
	(_wfindnexti64, _wfindfirst32i64, _wfindnext32i64, _wfindfirst64i32)
	(_wfindnext64i32, _wfindfirst32, _wfindnext32): ...these; reproduce
	them by selective inclusion of <io.h>.

2016-04-04  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Factor out <wchar.h> vs. <process.h> duplicate declarations.

	* include/process.h: Assert copyright; tidy layout.
	(_PROCESS_H_): Rename this multiple inclusion guard macro...
	(_PROCESS_H): ...to this preferred form; do not define it when...
	[__WCHAR_H_SOURCED__]: ...this is defined, in which case declare...
	(_wexecl, _wexecle, _wexeclp, _wexeclpe, _wexecv, _wexecve, _wexecvp)
	(_wexecvpe, _wspawnl, _wspawnle, _wspawnlp, _wspawnlpe, _wspawnv)
	(_wspawnve, _wspawnvp, _wspawnvpe): ...only these functions.
	[!__WCHAR_H_SOURCED__] (_PROCESS_H): Define it; declare all functions
	normally specified herein, including those listed above, as required.
	(_BEGIN_C_DECLS, _END_C_DECLS): Use to wrap extern "C" declarations.
	(__need_intptr_t): Define it prior to including <stdint.h>.
	(pragma GCC system_header): Declare it.

	* include/wchar.h (_WPROCESS_DEFINED): Delete it; filter out...
	(_wexecl, _wexecle, _wexeclp, _wexeclpe, _wexecv, _wexecve, _wexecvp)
	(_wexecvpe, _wspawnl, _wspawnle, _wspawnlp, _wspawnlpe, _wspawnv)
	(_wspawnve, _wspawnvp, _wspawnvpe): ...these function prototypes;
	reproduce them, by selective inclusion of <process.h>.

2016-04-04  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Enable selective retrieval of intptr typedefs from <stdint.h>.

	* include/stdint.h: Assert copyright; tidy layout.
	[__need_intptr_t || __need_uintptr_t] (_STDINT_H): Do not define it;
	conceal all normally defined data types, except either or both of...
	[__need_intptr_t] (intptr_t): ...this, and/or...
	[__need_uintptr_t] (uintptr_t): ...this.
	(pragma GCC system_header): Declare it.

2016-03-29  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Factor out <wchar.h> vs. <sys/stat.h> duplicate declarations.

	* include/sys/stat.h: Assert copyright; tidy layout.
	(pragma GCC system_header): Declare it.
	(_STAT_H_): Rename multiple inclusion guard macro; adopt...
	(_SYS_STAT_H): ...this preferred naming convention; however, when...
	[__WCHAR_H_SOURCED__] (_SYS_STAT_H): ...do not define it; declare...
	(_wstat, _wstati64, _wstat64, _wstat32): ...these functions, and...
	(_wstat32i64, _wstat64i32): ...these, as appropriate to user specified
	__MSVCRT_VERSION__ and _WIN32_WINNT macro definitions, namely...
	[__MSVCRT_VERSION__ >= 0x601]: ...this, updated to become...
	[__MSVCRT_VERSION__ >= __MSVCR61_DLL]: ...this; augment it with...
	[|| _WIN32_WINNT >= _WIN32_WINNT_WIN2K]: ...this complement; also...
	[__MSVCRT_VERSION__ < 0x800]: this, updated to become...
	[__MSVCRT_VERSION__ < __MSVCR80_DLL]: ...this; likewise...
	[__MSVCRT_VERSION__ >= 0x800]: ...this, which becomes...
	[__MSVCRT_VERSION__ >= __MSVCR80_DLL]: ...this.
	(__struct_stat_defined): New macro; define, and use it to define...
	(struct stat, struct _stat, struct _stati64, struct __stat64)
	(struct __stat32, struct _stat32i64, struct _stat64i32): ...these.
	[!__WCHAR_H_SOURCED__] (_SYS_STAT_H): Define it; also include
	<sys/types.h>, delegating to it the inclusion of <_mingw.h>, and
	definition of types size_t and wchar_t; declare all header content,
	including that declared when __WCHAR_H_SOURCED__ is defined, unless
	already declared as a result of selective inclusion by <wchar.h>
	(__need_size_t, __need_wchar_t): Do not define them; consequently,
	there is no need to include <stddef.h>; do not do so.

	* include/wchar.h (_wstat, _wstati64, _wstat64): Factor out.
	(_wstat32, _wstat32i64, _wstat64i32, struct stat, struct _stat)
	(struct _stati64, struct __stat64, struct __stat32, struct _stat32i64)
	(struct _stat64i32): Likewise; reproduce them by selective inclusion
	of <sys/stat.h>

2016-03-28  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Factor out <wchar.h> vs. <direct.h> duplicate declarations.

	* include/direct.h: Conditionally partition it, such that...
	[__WCHAR_H_SOURCED__] (_DIRECT_H): Do not define it; declare only...
	(_wchdir, wchar_t, wchar_t, _wmkdir, _wrmdir): ...these, otherwise...
	[!__WCHAR_H_SOURCED__] (_DIRECT_H): Define it; expose all content.
	(_WDIRECT_DEFINED): Never define it; delete all references.

	* include/wchar.h (_WDIRECT_DEFINED): Delete all references.
	(_wchdir, wchar_t, wchar_t, _wmkdir, _wrmdir): Delete prototypes;
	selectively #include <direct.h> to reproduce them.

2016-03-26  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Factor out <direct.h> vs. <dos.h> duplicate declarations.

	* include/dos.h: Assert copyright; tidy layout.
	(pragma GCC system_header): Declare it.
	(_DOS_H_): Rename multiple inclusion guard macro, to adopt...
	(_DOS_H): ...this preferred convention; do not define it when...
	[__DIRECT_H_SOURCED__]: ...this applies; restrict declarations to...
	(struct _diskfree_t): ...this aggregate data type, together with...
	[_NO_OLDNAMES] (diskfree_t): ...this alternative name for it, and...
	(_getdiskfree): ...this associated function.
	[!__DIRECT_H_SOURCED__] (_DOS_H): Define it; expose all content, but
	emit a warning that this header is obsolete, and should not be used.
	(_BEGIN_C_DECLS, _END_C_DECLS): Use to wrap extern "C" declarations.
	(_DISKFREE_T_DEFINED): Do not define it; delete all references.
	(__need_wchar_t): Do not define it; it isn't needed here, and hence,
	neither is it necessary to #include <stddef.h>; do not do so.  Also,
	do not #include <_mingw.h> explicitly, but always #include <io.h>,
	which will implicitly #include <_mingw.h> anyway.

	* include/direct.h: Assert copyright; tidy layout.
	(pragma GCC system_header): Declare it.
	(_DIRECT_H_): Rename this multiple inclusion guard macro...
	(_DIRECT_H): ...to adopt this preferred naming convention.
	(_BEGIN_C_DECLS, _END_C_DECLS): Use to wrap extern "C" declarations.
	(_DISKFREE_T_DEFINED, diskfree_t, struct _diskfree_t): Do not define.
	(_getdiskfree): Likewise, do not declare prototype; instead...
	(__DIRECT_H_SOURCED__): ...define this, and #include <dos.h>; also
	delegate indirect inclusion of <_mingw.h> and <io.h> to this, rather
	than include them directly; undefine __DIRECT_H_SOURCED__ when done.
	(__need_wchar_t): Do not define it, and do not #include <stddef.h>;
	although needed, we may inherit it indirectly from <sys/types.h>,
	included by <io.h> via <dos.h>.

2016-03-26  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Evade CPP mismatched apostrophe warnings in windres comments.

	* msvcrt-xref/msvcrt.def.in (; pexports): 1,Gs/doesn't/does not/g

2016-03-20  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Factor out <locale.h> vs. <wchar.h> duplicate declarations.

	* include/locale.h: Assert copyright; tidy layout.
	(_LOCALE_H_): Rename multiple inclusion guard macro, to...
	(_LOCALE_H): ...this; do not define it when...
	[__WCHAR_H_SOURCED__]: ...this applies; restrict declarations to...
	(_wsetlocale): ...just this one visible function prototype.
	[!__WCHAR_H_SOURCED__] (_LOCALE_H): Define it; expose all content.
	(_WLOCALE_DEFINED): Do not define it; delete all references.
	(pragma GCC system_header): Declare it.

	* include/wchar.h (_wsetlocale): Delete prototype; maintain its
	visibility by selective inclusion of <locale.h> instead.
	(_WLOCALE_DEFINED): Delete all references.

2016-03-18  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Resolve some "implicit function declaration" warnings.

	* setargv.c (isspace): Include <ctype.h> for declaration.
	* cpu_features.h (__cpu_features_init): Declare function prototype.
	* crt1.c (_setargv): Likewise; (this isn't needed elsewhere).

2016-03-18  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Factor out <stdlib.h> vs. <wchar.h> duplicate declarations.

	* include/stdlib.h [__WCHAR_H_SOURCED__]
	(_STDLIB_H): Do not define it; restrict visible declarations to...
	(wcstol, wcstoul, wcstod, _wgetenv, _wputenv, _wsearchenv, _wsystem)
	(_wmakepath, _wsplitpath, _wfullpath, wcstof, wcstold): ...this subset
	of regular <stdlib.h> content; full content is declared only when...
	[!__WCHAR_H_SOURCED__] (_STDLIB_H): ...this applies; define it.
	(_WSTDLIB_DEFINED): Do not define it; delete all references.
	(pragma GCC system_header): Declare it; tidy layout.

	* include/wchar.h: Delete duplicated declarations for...
	(wcstol, wcstoul, wcstod, _wgetenv, _wputenv, _wsearchenv, _wsystem)
	(_wmakepath, _wsplitpath, _wfullpath, wcstof, wcstold): ...these;
	include <stdlib.h> selectively, to maintain their visibility.
	(_WSTDLIB_DEFINED): Delete all references.

2016-03-17  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Relocate misplaced umask() function prototypes.

	* include/sys/stat.h (umask, _umask): Declare prototypes; duplicate...
	* include/io.h (umask, _umask): ...these; POSIX doesn't expect them
	here, but leave them for backward, or Microsoft, compatibility.

2016-03-17  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Correct another _BEGIN_C_DECLS imbalance error.

	* include/wchar.h (_BEGIN_C_DECLS): One misplaced, superfluous, and
	unbalanced instance deleted; one correctly balanced instance remains.

2016-03-13  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Support installation of headers with empty parts directory.

	* Makefile.in (SUB_HEADERS_PRESENT): New macro; define it, and...
	(install-mingwrt-headers): ...invoke it; if false, do not perform...
	(INSTALL_SUB_HEADERS): ...this.

2016-03-13  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Reinstate typedef for non-standard off64_t.

	* include/sys/types.h [!__STRICT_ANSI__] (off64_t): Define it as...
	(__off64_t): ...typedef derived from this; although non-standard, it
	is gratuitously required when building GCC's libgfortran.a

2016-03-13  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Correct conditional compilation block nesting errors.

	* include/stdio.h include/time.h (_BEGIN_C_DECLS, _END_C_DECLS): Keep
	them balanced within, and around, conditional compilation blocks.

2016-03-10  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Feature test _MINGW32_EXTENDED_SOURCE renamed.

	* include/_mingw.h (_MINGW32_EXTENDED_SOURCE): Rename to...
	(_MINGW32_SOURCE_EXTENDED): ...this, to improve naming consistency...
	(_XOPEN_SOURCE_EXTENDED): ...with this POSIX-XSI feature test.
	(__USE_MINGW_ANSI_STDIO): Note that it is intended for internal use;
	users should enable any conventional feature test which implies it.

	* include/time.h (_MINGW32_EXTENDED_SOURCE): Update references...
	(_MINGW32_SOURCE_EXTENDED): ...i.e. to refer to this.

2016-02-28  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Correct atexit() and _onexit() export declaration regression.

	* msvcrt-xref/msvcrt.def.in (atexit, _onexit): These must be exported
	as DATA; declare them accordingly.

2016-02-18  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Refactor to make <parts/time.h> and <parts/wchar.h> redundant.

	* include/string.h: Tidy layout.
	(__STRING_H_SOURCED__): New macro; define it at start; delete at end.
	(_stricmp, _strnicmp): Include their prototypes, selectively from...
	* include/strings.h [__STRING_H_SOURCED__]: ...here, reproduce them...
	* include/parts/strings.h: ...from here; file is obsolete; delete it.

	* include/string.h (_wcscmpi): Define alias.
	(wcscat, wcschr, wcscmp, wcscoll, wcscpy, wcscspn, wcslen, wcsncat)
	(wcsncmp, wcsncpy, wcspbrk, wcsrchr, wcsspn, wcsstr, wcstok, wcsxfrm)
	(_wcsdup, _wcsicmp, _wcsicoll, _wcslwr, _wcsnicmp, _wcsnset, _wcsrev)
	(_wcsset, _wcsupr, _wcsncoll, _wcsnicoll, _wcserror, __wcserror)
	(wcscmpi, wcscmpi, wcsdup, wcsicmp, wcsicoll, wcslwr, wcsnicmp)
	(wcsnset, wcsrev, wcsset, wcsupr): Selectively include prototypes...
	* include/wchar.h [__STRING_H_SOURCED__]: ...from here; reproduce...
	* include/parts/wchar.h: ...from here; file is obsolete; delete it.

	* include/strings.h (_STRINGS_H): Do not define it, when...
	[__STRING_H_SOURCED__]: ...selectively included by <string.h>.
	* include/wchar.h (_WCHAR_H) [__STRING_H_SOURCED__]: Likewise.

2016-02-16  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Refactor to make <parts/time.h> redundant.

	* include/sys/types.h (time_t, __time32_t, __time32_t)
	[__need_time_t && !__have_typedef_time_t]: Reproduce definitions...
	* include/parts/time.h: ...from here; preserve selective exposure.

	* include/time.h (time_t, __time32_t, __time32_t): Get them...
	* include/sys/types.h: ...from here, by selective inclusion.

	* include/time.h (struct timespec, struct __mingw_extended_timespec)
	[__need_struct_timespec && !__struct_timespec_defined]: Reproduce...
	* include/parts/time.h: ...from here; preserve selective exposure.

	* include/parts/time.h: Delete file; it is no longer required.

2016-02-16  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Declare the nanosleep() function where POSIX expects it.

	* include/time.h (__mingw_sleep): Declare function prototype.
	(nanosleep): Declare prototype, and provide in-line implementation;
	this is a reproduction of the original implementation, relocated...
	* include/unistd.h (nanosleep): ...from here; remove it; hence...
	(struct timespec): ...this need not be declared here, and there is
	no need to include <parts/time.h>; remove reference.

2016-02-15  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Refactor <time.h> vs. <wchar.h> to avoid duplication.

	* include/wchar.h (__WCHAR_H_SOURCED__): New macro; define it...
	[_WCHAR_H]: ...at start of processing in this scope; delete at end.
	(struct tm): Delete definition; delegate it, together with each of...
	(_wctime, _wasctime, _wstrdate, _wstrtime, _wctime64, _wctime32)
	(wcsftime): ...these function prototypes; delete them, but note in
	comments, that they remain declared, via delegation to...
	* include/time.h: ...this; include it selectively, subject to...
	[defined __WCHAR_H_SOURCED__](__need_wchar_decls): ...this; define it.
	[defined __WCHAR_H_SOURCED__](_TIME_H): Suppress its definition.
	[_TIME_H]: Process all definitions and declarations; otherwise...
	[__need_wchar_decls]: ...process only <wchar.h> shared content, but...
	[_TIME_H && _WCHAR_H]: ...not on second, or later, time of processing.
	(_WTIME_DEFINED): Obsolete macro; delete all references.

2016-02-11  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Implement support for POSIX "%n$*m$" printf() format control.

	* mingwex/stdio/pformat.c (NL_ARGMAX): New macro; nominally, it should
	be defined in <limits.h>, but MinGW may not do so; provide a fallback.
	(__pformat_inline__): New macro; define, and use it where appropriate.
	(PFORMAT_CONVERSION_TYPE, PFORMAT_LENGTH_MODIFIER)
	(PFORMAT_TYPE_DOUBLE, PFORMAT_TYPE_INTEGER, PFORMAT_TYPE_POINTER)
	(PFORMAT_LENGTH_DEFAULT): New enumerated values; define them.
	(PFORMAT_ARGMAP_ENTRIES): New enumerated value tally; use it in...
	(__pformat_argmap_t): ...this new union data type; define it.
	(__pformat_indexed_argc, __pformat_sizeof_argument, __pformat_argmap)
	(__pformat_imul10plus, __pformat_arg_index, __pformat_read_arg_index)
	(__pformat_read_arg_index_after, __pformat_look_ahead_beyond_flags)
	(__pformat_look_ahead, __pformat_ignore_flags, __pformat_is_ldouble)
	(__pformat_is_conversion_type, __pformat_is_alt_ldouble_modifier)
	(__pformat_length_modifier, __pformat_check_length_modifier): New
	locally defined static and/or inline functions; implement, and...
	(__pformat): ...use them.

2016-02-11  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Add prototypes for Microsoft's _printf_p() family of functions.

	* include/stdio.h [>=__MSVCR80_DLL || >=_WIN32_WINNT_VISTA]
	(_printf_p, _printf_p_l, _vprintf_p, _vprintf_p_l, _fprintf_p)
	(_fprintf_p_l, _vfprintf_p, _vfprintf_p_l, _sprintf_p, _sprintf_p_l)
	(_vsprintf_p, _vsprintf_p_l): Add function prototypes; they require
	either a non-free MSVC runtime, or MSVCRT.DLL from Vista onward.
	(_wprintf_p, _wprintf_p_l, _vwprintf_p, _vwprintf_p_l, _fwprintf_p)
	(_fwprintf_p_l, _vfwprintf_p, _vfwprintf_p_l, _swprintf_p)
	(_swprintf_p_l, _vswprintf_p, _vswprintf_p_l): Likewise; make them
	available for selective inclusion by both <stdio.h> and <wchar.h>...
	[_STDIO_H || __WCHAR_H_SOURCED__]: ...when either of these defined.

2016-02-09  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Adapt msvcrt-xref to become msvcrt.def.in provider.

	* Makefile.in (msvcrt_version_script) [__MSVCRT_VERSION__]: Adjust
	filter value assignment; scale it upwards, by a factor of 0x10000.
	(%.def.in) [vpath]: Make it refer to msvcrt-xref directory.
	(%.def) [msvcr*]: Do not preserve comments; define...
	(__DLLNAME__): ...this preprocessor symbol.

	* msvcrt.def.in: Content is obsolete; delete file and replace with...
	* msvcrt-xref/msvcrt.def.in: ...this updated alternative.
	(__MINGW_DLSYM): New preprocessor macro; define it conditionally...
	[__MSVCRT_VERSION__ != 0]: ...to emit in-scope symbols it declares...
	[__MSVCRT_VERSION__ == 0]: ...to hide symbols it declares, followed by
	redefinition of __MSVCRT_VERSION__ itself, to a value of 0x10000.

2016-02-09  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Import msvcrt-xref documentation resources.

	* msvcrt-xref: New directory.
	* msvcrt-xref/ChangeLog msvcrt-xref/COPYING: New files.
	* msvcrt-xref/msvcrt-xref.ms msvcrt-xref/fdl-1.3.ms: New files.
	* msvcrt-xref/configure.ac msvcrt-xref/Makefile.in: New files.
	* msvcrt-xref/README.in msvcrt-xref/msvcrt.def.in: New files.

2016-01-29  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Refactor <stdio.h> vs. <wchar.h> to avoid duplication.

	* include/wchar.h: Some minor layout adjustments.
	(__WCHAR_H_SOURCED__): New macro; define it temporarily, only while
	within the scope of reading <wchar.h>; undefine it at end of file.
	(struct tm): Do not define; it is sufficient to keep it opaque.
	(FILE, FILENAME_MAX, NULL, __VALIST, off_t, __off64_t, size_t)
	(ssize_t, va_list, wchar_t, wint_t): Do not require or define them
	directly; delegate to indirect definition by including <stdio.h>.
	(fgetwc, fputwc, fgetws, fputws, fwprintf, fwscanf, getwc, getwchar)
	(_getws, putwc, putwchar, _putws, snwprintf, _snwprintf, swprintf)
	(swscanf, ungetwc, vfwprintf, vfwscanf, _vscwprintf, vsnwprintf)
	(_vsnwprintf, vswprintf, vwprintf, vswscanf, vwscanf, _wfdopen)
	(_wfopen, _wfreopen, _wfsopen, _wperror, _wpopen, wprintf, _wrename)
	(_wremove, wscanf, _wtmpnam, _wtempnam): Omit prototypes; acquire them
	indirectly, by selective inclusion from <stdio.h>; hence include it.

	* include/stdio.h: Assert copyright; tidy layout.
	(_STDIO_H_): Multiple inclusion guard macro, renamed as...
	(_STDIO_H): ...this, but defined conditionally, subject to...
	[__WCHAR_H_SOURCED__]: ...selectively define and declare only those
	entities which are required by <wchar.h>; do not define...
	[__WCHAR_H_SOURCED__] (_STDIO_H): ...this; define it only if...
	[!__WCHAR_H_SOURCED__]: ...this; define and declare ALL entities which
	are normally specified within <stdio.h>, INCLUDING those specifically
	itemised above, as selectively required by <wchar.h>.

	* pseudo-reloc.c: Some minor layout adjustments.
	(WIN32_LEAN_AND_MEAN): Define it; we don't need the windows baggage.
	[typedef ptrdiff_t]: Do not assume this is gratuitously defined;
	include <stddef.h> to guarantee it.

2016-01-29  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Enable selective definition of POSIX system types.

	* include/sys/types.h (_SYS_TYPES_H): Do NOT define, if including with
	any specific __need_TYPE selector having been set prior to inclusion;
	DO define it when no such selector is present, and undefine all such
	selectors as may have been set, after evaluation of their effects.
	(_DEV_T_, _FPOS64_T_, _INO_T_, _MODE_T_, _OFF_T_, _OFF64_T_, _PID_T_)
	(_SIGSET_T_, _SSIZE_T_): Unnecessary guard macros; delete them; this
	accommodates reorganization of the file, to achieve a tidier layout.
	(__have_typedef_off_t): New repeat definition guard; define it for
	compilers which may choke on any repeated typedef for either of...
	(off_t, _off_t): ...these; make them selectively defineable for...
	[_SYS_TYPES_H && !__have_typedef_off_t]: ...non-selective inclusion...
	[__need_off_t && !__have_typedef_off_t]: ...this specific selection;
	in either case, redefine them in terms of...
	(__off32_t): ...this new internal type, for consistency with...
	(__off64_t): ...this previously defined non-standard type; also make
	it selectively defineable, either by...
	[_SYS_TYPES_H && !__have_typedef___off64_t]: ...non-selective, or...
	[__need_off_t && !__have_typedef___off64_t]: ...selective inclusion.
	(__have_typedef___off64_t): New repeat definition guard; define it.
	(ssize_t, _ssize_t): Also make them selectively defineable, on...
	[_SYS_TYPES_H && !__have_typedef_ssize_t]: ...non-selective, or...
	[__need_off_t && !__have_typedef_ssize_t]: ...selective inclusion.
	(__have_typedef_ssize_t): New repeat definition guard; define it.

2015-12-30  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Avoid user namespace pollution by non-standard type 'off64_t'.

	* include/sys/types.h (off64_t): Rename it as...
	(__off64_t): ...this implementation-private alternative name, so
	eliminating the potential for user namespace pollution.

	* include/io.h (lseek64): Use '__off64_t', instead of 'off64_t', as
	return type, and type of offset argument, in both prototype and inline
	implementation; note that this addresses the issue of pollution in the
	user namespace, while avoiding the issue of MinGW-Bug [#2024].

	* include/stdio.h (fseeko64, __mingw_fseeko64): Use '__off64_t'
	instead of 'off64_t', as offset argument type in function prototypes.
	(ftello64): Likewise, for return type of inline function.

	* mingwex/mingw-fseek.c: Assert copyright; tidy layout.
	(WIN32_LEAN_AND_MEAN): Define, to minimize impact of <windows.h>.
	(__mingw_fseeko64): Use '__off64_t' per modified function prototype.

	* mingwex/stdio/fseeko64.c: Assert copyright.
	(fseeko64): Use '__off64_t' per modified function prototype.

2015-12-27  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Improve ISO-C conformity in MinGW printf(); cf. MinGW-Bug [#1761]

	* mingwex/ofmtctl.c: New file; it implements...
	(_mingw_output_format_control): ...this new function; it provides
	additional MinGW specific printf() format processing options.

	* Makefile.in (libmingwex.a) [prerequisites]: Add ofmtctl.$OBJEXT

	* include/stdio.h (_mingw_output_format_control): Declare it.
	(_EXPONENT_DIGIT_MASK, _MSVC_PRINTF_QUIRKS, _QUERY_MSVC_PRINTF_QUIRKS)
	(_ENABLE_MSVC_PRINTF_QUIRKS, _DISABLE_MSVC_PRINTF_QUIRKS): New
	manifest constant expressions; define them.

	* mingwex/stdio/pformat.c: Revise licensing terms.
	(__pformat) [%le, %lE, %lf, %lF, %lg, %lG, %lx, %lX]: When...
	[_mingw_output_format_flag & _MSVC_PRINTF_QUIRKS == 0]: ...ignore `l'
	modifier; this matches the behaviour specified by ISO-C99, else...
	[_mingw_output_format_flag & _MSVC_PRINTF_QUIRKS != 0]: ...revert to
	previous MSVC compatible behaviour, treating it as an `L' modifier.
	[!_WIN32] (_MSVC_PRINTF_QUIRKS): Force the zero match case.

	* mingwex/ofmt.c (ARGLIST): Subsume references to...
	(ARGTYPE): ...this now obsolete macro; delete it throughout.
	(update_output_format_flag): New inline function; it restricts flag
	operations to affect only Microsoft's exponent digit bits.
	[FUNCTION == _set_output_format]: Use it.
	[FUNCTION == _get_output_format]: Likewise.

2015-10-23  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Make atof() and strtod() conform to ISO-C; fix MinGW-Bug [#2273]

	* include/_mingw.h (_ISOC99_SOURCE): Ensure this feature test macro is
	defined, when implied by any STDC or POSIX version selection, viz. ...
	[__STDC_VERSION__ >= 199901L || _POSIX_C_SOURCE >= 200112L]: ...this.

	* include/stdlib.h: Assert copyright; tidy layout.
	(_STDLIB_H_): Multiple inclusion guard macro renamed...
	(_STDLIB_H): ...to this, preferring no trailing underscore.
	[!defined __NO_ISOCEXT]: Delete double negative references; use...
	[defined _ISOC99_SOURCE]: ...this feature test instead, when...
	(lldiv_t): ...defining this C99 specific aggregate data type, and...
	(lldiv, llabs, atoll, strtoll, strtoull, strtof, strtold, wcstof)
	(wcstold, _Exit): ...declaring these C99 function prototypes.
	(wtoll, lltoa, ulltoa, lltow, ulltow): Mark as deprecated, pending
	future removal; not in MSVCRT.DLL, these conform to no known standard.
	[__USE_MINGW_ANSI_STDIO] (atof, strtod): Implement inline, using...
	(__strtod): ...this libmingwex.a provided function; it handles string
	representations of hexadecimal-floats, infinities and NaNs, whereas...
	(strtod): ...this MSVCRT.DLL implementation does not.
	(__MSVCRT_VERSION__): Prefer symbolic comparison...
	[>= __MSVCR80_DLL]: ...for this requirement.

2015-10-22  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Rationalize definition of struct timespec.

	* include/parts/time.h (struct timespec): Redefine; use __time64_t for
	tv_sec field, in place of anonymous union, thus avoiding missing brace
	warnings when initializing; leave a copy of the previous definition...
	(struct __mingw32_expanded_timespec): ...named thus.

	* include/unistd.h (nanosleep): Adjust inline implementation, to match
	altered specification of tv_sec field in struct timespec.

	* include/_mingw.h (_MINGW32_EXTENDED_SOURCE): New feature test macro.
	[! defined __STRICT_ANSI__]: Define it, making it a default feature.

	* include/time.h [_MINGW32_EXTENDED_SOURCE] (mingw_timespec): New
	convenience function; defined as inline, with __LIBIMPL__ equivalent,
	it facilitates interpretation of an instance of struct timespec as if
	it were defined as struct __mingw32_expanded_timespec.

2015-09-14  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Make strings.h mostly POSIX.1-2008 compliant.

	* include/strings.h: Rewritten.  Do not include...
	(string.h): ...this; mandated by POSIX.1, it now defines...
	(strcasecmp, strncasecmp): ...these POSIX.1 functions, complete with
	prototypes, possible in-line implementations, and JMPSTUB references
	to corresponding external implementations, which will now become
	automatically created within libmingwex.a

	* include/parts/strings.h: New file; it declares prototypes for...
	(_stricmp, _strnicmp): ...these MSVC functions; nominally declared in
	string.h, but we also require them in strings.h

	* include/parts/wchar.h: New file; it declares prototypes for all wide
	character functions which MSVC specifies in both wchar.h and string.h

	* include/string.h: Miscellaneous layout adjustments.
	(strcasecmp, strncasecmp): Delete; they belong in strings.h
	(_stricmp, _strnicmp): Factor out; include them from parts/strings.h
	[!_WSTRING_DEFINED]: Factor out all associated function prototypes;
	include them from parts/wchar.h instead.

	* include/wchar.h [!_WSTRING_DEFINED]: Delete all associated function
	prototypes; include them from parts/wchar.h instead, so making this
	guard macro redundant; delete it.

	* Makefile.in (strcasecmp.$OBJEXT, strncasecmp.$OBJEXT)
	(wcscmpi.$OBJEXT): Implementations are now automatically generated
	from header file, for inclusion in libmingwex.a; remove free-standing
	implementations from the entire family of liboldname libraries, and...
	* strcasecmp.c strncasecmp.c wcscmpi.c: ...delete corresponding source
	files; they are no longer required.

2015-07-16  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Incorporate build system updates from w32api package.

	* Makefile.in (NTDDI_VERSION): Set default to NTDDI_WINNT4.
	(mkinstalldirs, INSTALL_DATA): Reimplement to support $(call ...)
	(install-strip, uninstall): New make command goals; implement them.
	(mingwrt-dist-staged): Use 'install-strip' in this rule; hence...
	(devdist, dlldist): ...these have no need to strip explicitly.
	(INSTALL_SUB_HEADERS): New macro; implement it, and use it...
	(install-mingwrt-headers): ...here.

2015-07-14  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Adapt platform feature checks to NTDDI_VERSION conventions.

	* include/_mingw.h: Assert copyright; include w32api.h
	(UNICODE, _UNICODE): Factor out consistency checks; relocate them
	to w32api/include/w32api.h, whence they remain in effect.
	(_EXTERN_C, _BEGIN_C_DECLS, _END_C_DECLS): Likewise.

2015-07-14  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Correct mismatched #if/#endif from preceding commit.

	* include/_mingw.h (#pragma GCC system_header)
	[__GNUC__ >= 3 && ! defined __PCC__]: Merge these conditions, thus
	correcting for inadvertent removal of matching #endif introduced by
	preceding 2015-06-19 commit.

2015-06-19  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Define symbolic names for alternative Microsoft runtime DLLs.

	* include/msvcrtver.h: New file; it assigns a value for...
	(__MSVCRT_VERSION__): ...this, making its default equivalent to...
	(__MSVCR60_DLL): ...this new manifest constant, with each of...
	(__MSVCR61_DLL, __MSVCR70_DLL, __MSVCR71_DLL, __MSVCR80_DLL)
	(__MSVCR90_DLL, __MSVCR100_DLL, __MSVCR110_DLL, __MSVCR120_DLL):
	...these also defined, as user assignable alternatives.

	* include/_mingw.h (__MSVCRT_VERSION__): Use include/msvcrtver.h
	to establish its default value.

2015-06-18  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Track dependencies on modified system header files.

	* Makefile.in (DEPFLAGS): Use -MD, rather than -MMD.

2015-06-18  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Correct an anomaly in stage 1 only build procedure.

	* Makefile.in (all-gcc): New goal; it is an alias for...
	(all-mingwrt-stage-1): ...this, renamed to match configure, as...
	(all-mingwrt-stage-1-only): ...this; upate all references.
	(active-goals): Adjusted accordingly; it now reguires...
	(all-deprecated-mingwrt-stage-1-only): ...this new goal.
	(install): Adjusted, as directed by...
	(DEFAULT_MAKECMDGOALS): ...this.

2015-06-13  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Prefer our hypot() implementation in complex maths operations.

	* mingwex/complex/cabs_generic.c: New file; it replaces...
	* mingwex/complex/cabs.c mingwex/complex/cabsf.c: ...all of...
	* mingwex/complex/cabsl.c: ...these.

	* mingwex/complex/catan_generic.c: New file; it replaces...
	* mingwex/complex/catan.c mingwex/complex/catanf.c: ...all of...
	* mingwex/complex/catanl.c: ...these.

	* mingwex/complex/clog_generic.c: New file; it replaces...
	* mingwex/complex/clog.c mingwex/complex/clogf.c: ...all of...
	* mingwex/complex/clogl.c: ...these.

	* mingwex/complex/cpow_generic.c: New file; it replaces...
	* mingwex/complex/cpow.c mingwex/complex/cpowf.c: ...all of...
	* mingwex/complex/cpowl.c: ...these.

	* mingwex/complex/csqrt_generic.c: Do not use...
	(_hypot): ...this Microsoft form of function reference; use...
	(hypot): ...this ANSI standard form instead.

2015-06-10  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Correct C++ compilation anomaly with hypotf() in cmath header.

	* include/math.h: Add copyright notice; generally tidy layout.
	(_BEGIN_C_DECLS, _END_C_DECLS): Use to wrap extern "C" declarations.
	(hypotf): Delete inline implementation; it did not properly handle
	range errors, and was uncompilable with optimization when any g++
	option implying __STRICT_ANSI__ conformity was specified.
	(_MATH_H_): Rename this multiple inclusion guard...
	(_MATH_H): ...to this.

	* mingwex/math/hypot_generic.c: New file; it implements...
	(hypot, hypotf, hypotl): ...these; use the latter pair in place of...
	* mingwex/math/hypotf.c mingwex/math/hypotl.c: ...these; delete them.

2015-06-08  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Prepare and tag all files for release of mingwrt-3.21.1.

	* configure.ac (AC_INIT): Adjust package version argument.
	* include/_mingw.h (__MINGW32_PATCHLEVEL): Increment to 1, and...
	(__MINGW32_VERSION): ...increment this to match.

2015-05-18  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Refactor to avoid possible time_t conflicts across headers.

	* include/parts/time.h (struct timespec): Make it more descriptive of,
	and better able to accommodate, potential ambiguity relating to...
	(time_t, __time32_t, __time64_t): ...these typedefs; define them here,
	whence they may be identically imported into each of...
	* include/sys/types.h include/time.h include/wchar.h: these; delete
	duplicate typedefs, and import accordingly.

	* include/sys/types.h: Add licence; general comment additions.
	(_TYPES_H_): Rename multiple inclusion guard macro...
	(_SYS_TYPES_H): ...to this.

	* include/time.h: Add licence; general comment/layout adjustments.
	(_BEGIN_C_DECLS, _END_C_DECLS): Use to wrap extern "C" declarations.
	(_TIME_T_DEFINED, _TIME32_T_DEFINED, _TIME64_T_DEFINED)
	(_CLOCK_T_DEFINED): Superfluous guard macros; delete them.
	(_TIME_H_): Rename multiple inclusion guard macro...
	(_TIME_H): ...to this.

	* include/unistd.h (nanosleep): Adjust to accommodate redefinition...
	(struct timespec): ...of this.

	* include/wchar.h: Add licence; general comment/layout adjustments.
	(_BEGIN_C_DECLS, _END_C_DECLS): Use to wrap extern "C" declarations.
	[GCC] (system_header): Add pragma, identifying header as such.
	(_WCHAR_H_): Rename multiple inclusion guard macro...
	(_WCHAR_H): ...to this.

2015-05-09  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Remove obsolete varargs.h header file.

	* include/varargs.h: Delete it; it was a mostly redundant wrapper for
	a GCC header which is no longer supported, and was always intended for
	ultimate removal; now is the long overdue time to do so.

2015-05-08  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Correct improper unistd.h function attribute declarations.

	* include/unistd.h (_cdecl): Correct usage throughout; should be...
	(__cdecl): ...this.

2015-03-12  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Fix GLOB_DOOFFS initialization bug.

	* mingwex/glob.c (__mingw_glob) [!GLOB_DOOFFS]: Ensure...
	(gl_data->gl_offs): ...this is properly initialized to zero.

2014-12-28  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Tag all files for release of mingwrt-3.21.

	* include/_mingw.h: Adjust version accordingly.

2014-12-28  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Improve usage notes in stdlib.h, for mkstemp() function.

	* include/stdlib.h (MKSTEMP_SETMODE): Explain usage; this is a copy of
	an original comment, explaining the need to use  _O_TEMPORARY, from...
	* mingwex/mkstemp.c: ...here; delete trailing white space.

2014-12-23  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Eliminate some potential definition inconsistencies.

	* include/stdio.h: Cosmetic formatting change, relating to...
	* include/unistd.h (SEEK_SET, SEEK_CUR, SEEK_END): Define them
	unconditionally; this allows the compiler to check for consistency
	with their primary definitions in stdio.h

2014-12-23  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Suppress expected warning diagnostics in LIBIMPL builds.

	* Makefile.in (LIBIMPL_CFLAGS): Redefine it; it now incorporates...
	(LIBIMPL_EXTRA_CFLAGS): ...this new macro; it includes the requisite
	GCC flag to supress warnings relating to deprecated declarations.

2014-12-23  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Provide more POSIX conforming sleep() functions.

	* include/sys/types.h (useconds_t): Make it explicitly long; int may
	be okay, but doesn't guarantee enough bits; mark as deprecated, since
	POSIX has declared it "obsolete", and no longer specifies it.

	* mingwex/usleep.c: Delete file; it provided an implementation of...
	(usleep): ...this now obsolete function, claiming POSIX.1 issue 6, but
	its error handling was hopelessly broken; replace it with...
	* mingwex/nsleep.c: ...this new file; it implements...
	(__mingw_sleep): ...this generic helper function; it supports sleep
	capability with interval specification to nanosecond precision.

	* include/unistd.h (__mingw_sleep): Declare prototype; use it as the
	basis for providing __LIBIMPL__ __CRT_INLINE implementations of...
	(sleep, nanosleep): ...these current POSIX functions, and also...
	(usleep): ...this obsolete one; mark it as deprecated.

	* include/parts: New directory; it is intended to host partial header
	implementations, for content which must be shared among arbitrary sets
	of multiple standard header files.

	* include/parts/time.h: New file; nominally declaring time.h content.
	(struct timespec): Declare it; it is currently used within unistd.h,
	to facilitate the __CRT_INLINE implementation of nanosleep().

	* Makefile.in (libmingwex.a): Remove reference to...
	(usleep.$OBJEXT): ...this; replace it with a reference to...
	(nsleep.$OBJEXT): ...this alternative.
	(mingwrt-includedirs): Add prerequisite to create...
	($includedir/parts): ...this new directory; it is populated by...
	(install-mingwrt-headers): ...this rule; add requisite command.

2014-12-13  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Delete an unnecessary Unicode wrapper file.

	* mingwex/wdirent.c: Delete it; Makefile.in knows how to compile the
	UTF-16LE API from dirent.c, without any need for this wrapper.

2014-12-13  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Some further inline function rationalization.

	* include/io.h (_CRTALIAS): Replace all references...
	(__CRT_ALIAS): ...using this syntactically preferred form.
	(lseek64): Specify __JMPSTUB__ semantics for extern implementation.
	[__cplusplus] (_BEGIN_C_DECLS, _END_C_DECLS): Use these.

	* include/unistd.h (ftruncate): Specify __JMPSTUB__ semantics.
	[__cplusplus] (_BEGIN_C_DECLS, _END_C_DECLS): Use these.

	* mingwex/stdio/lseek64.c: File is now redundant; delete it.
	* mingwex/ftruncate.c: Likewise.

	* Makefile.in (libmingwex.a): Delete obsolete dependencies on...
	(lseek64.$OBJEXT, ftruncate.$OBJEXT): ...these.

2014-12-13  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Some POSIX feature test adjustments.

	* include/stdlib.h (mkstemp): Available since SUSv3, so requires...
	[_POSIX_C_SOURCE >= 200112L]: ...this minimum level of POSIX support.
	(mkdtemp): This didn't become available until SUSv4, so requires...
	[_POSIX_C_SOURCE >= 200809L]: ...this increased feature level.

2014-12-11  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Another CRT_INLINE function implementation rationalization.

	* include/inttypes.h (imaxabs): Specify as __LIBIMPL__; declare...
	(llabs): ...this, to be implemented as its __LIBIMPL__ alias.
	[__cplusplus] (_BEGIN_C_DECLS, _END_C_DECLS): Use these.

	* Makefile.in (libimpl_sed_script): Handle ALIAS attribute.
	(libmingwex.a): Delete obsolete dependency on...
	(imaxabs.$OBJEXT): ...this.

	* mingwex/imaxabs.c: File is now redundant; delete it.

2014-12-11  Keith Marshall  <keithmarshall@users.sourceforge.net>

	More rationalization of CRT_INLINE function implementations.

	* include/stdio.h (fopen64): Add __JMPSTUP__ specification.
	(ftello64): Add __LIBIMPL__ specification for extern implementation.
	[__cplusplus] (_BEGIN_C_DECLS, _END_C_DECLS): Use these.

	* mingwex/stdio/fopen64.c: File is now redundant; delete it.
	* mingwex/stdio/ftell064.c: Likewise.

	* Makefile.in (libmingwex.a): Delete obsolete dependencies on...
	(fopen64.$OBJEXT, ftello64.$OBJEXT): ...these.

2014-12-11  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Don't implicitly define _POSIX_C_SOURCE too early.

	* include/_mingw.h (_POSIX_C_SOURCE): Delay implict definition.
	(__USE_MINGW_ANSI_STDIO): This must be initialized first, to ensure
	that it is not accidentally activated by implied _POSIX_C_SOURCE.

2014-12-10  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Correct complex arcsin computation per issue [#2245].

	* mingwex/complex/casin_generic.c: New file; it replaces...
	* mingwex/complex/casin.c: ...this; it is now obsolete; delete it.
	* mingwex/complex/casinf.c mingwex/complex/casinl: Likewise.

2014-12-10  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Correct complex square root computation per issue [#2246].

	* include/math.h (hypotf): Redirect __CRT_INLINE call to...
	(_hypot): ...this MSVCRT.DLL exported function, so avoiding...
	(hypot): ...this libmoldname.a indirection.

	* mingwex/complex/csqrt_generic.c: New file; it replaces...
	* mingwex/complex/csqrt.c: ...this; it is now obsolete; delete it.
	* mingwex/complex/csqrtf.c mingwex/complex/csqrtl: Likewise.

2014-12-10  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Adjust header guards to resolve issue [#2244].

	* include/_mingw.h (_POSIX_C_SOURCE): Define it implicitly...
	[_GNU_SOURCE || _BSD_SOURCE || _POSIX_SOURCE || !__STRICT_ANSI__]:
	...when any of these prevail, or as appropriate to correspond with...
	[_XOPEN_SOURCE]: ...this; set conformance level accordingly.

	* include/math.h [_POSIX_C_SOURCE || defined _USE_MATH_DEFINES]
	(M_E, M_LOG2E, M_LOG10E, M_LN2, M_LN10, M_PI, M_PI_2, M_PI_4, M_1_PI)
	(M_2_PI, M_2_SQRTPI, M_SQRT2, M_SQRT1_2): Define them, irrespective...
	[__STRICT_ANSI__]: ...of this; replace guard accordingly.

2014-12-01  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Add implementation of mkstemp() and mkdtemp() functions.

	* mingwex/cryptnam.c: New file; it implements...
	(__mingw_crypto_tmpname): ...this helper function; it generates a
	cryptographically secure sequence of characters, used as the random
	component in temporary file and directory names.

	* mingwex/mkstemp.c: New file; it implements...
	(__mingw_mkstemp): ...this provider of mkstemp() functionality.

	* mingwex/mkdtemp.c: New file; it implements...
	(__mingw_mkdtemp): ...this provider of mkdtemp() functionality.

	* include/stdlib.h (mkstemp): Declare protototye; provide an inline
	function implementation, with LIBIMPL extern semantics, in terms of...
	(__mingw_mkstemp): ...this; also declare prototype, and define...
	(_MKSTEMP_INVOKE, _MKSTEMP_DEFAULT): ...these supporting constants.
	(_MKSTEMP_SETMODE): New macro; define it, also providing...
	(MKSTEMP_SETMODE) [!_NO_OLDNAMES]: ...this alias.
	(mkdtemp): Declare prototype; provide inline implementation, with
	JMPSTUB extern semantics, in terms of...
	(__mingw_mkdtemp): ...this; declare prototype.

	* Makefile.in (libmingwex.a): Add dependency rule, to include...
	(mkstemp.$OBJEXT, mkdtemp.$OBJEXT, cryptname.$OBJEXT): ...these.

2014-11-30  Keith Marshall  <keithmarshall@users.sourceforge.net>

	More JMPSTUB rationalization of inline functions.

	* include/stdlib.h (_Exit, atoll, lltoa, ulltoa, wtoll, lltow)
	(ulltow): Add __JMPSTUB__ declarations; each is REMAPPED to its
	appropriate MSVCRT.DLL equivalent entry point.

	* mingwex/_Exit.c: File is now redundant; delete it.
	* mingwex/atoll.c mingwex/lltoa.c mingwex/ulltoa: Likewise.
	* mingwex/wtoll.c mingwex/lltow.c mingwex/ulltow: Likewise.

	* Makefile.in (jmpstub_awk_script): Add support for...
	[__JMPSTUB__((REMAPPED))]: ...this stub function attribute.
	(libmingwex.a): Remove dependencies on deleted files, namely...
	(_Exit.$OBJEXT, atoll.$OBJEXT, lltoa.$OBJEXT, ulltoa.$OBJEXT)
	(wtoll.$OBJEXT, lltow.$OBJEXT, ulltow.$OBJEXT): ...these.

2014-11-29  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Correct omission of complex conjugate functions from libmingwex.a

	* include/complex.h (conj, conjf, conjl): Add LIBIMPL declarations.
	(creal, crealf, creall): Likewise, for consistency of implementation.
	(cimag, cimagf, cimagl, carg, cargf, cargl): Likewise.

	* Makefile.in (libimpl_sed_script): Add processing for __CRT_INLINE
	declarations; they should be interpreted analogously to __CRT_ALIAS.
	(libmingwex.a): Remove object file references for functions which are
	now declared as LIBIMPL, and sort the remainder in ASCII collating
	order; deleted function references comprise the set consisting of...
	(carg.$OBJEXT, cargf.$OBJEXT, cargl.$OBJEXT): ...these...
	(creal.$OBJEXT, crealf.$OBJEXT, creall.$OBJEXT): ...these, and...
	(cimag.$OBJEXT, cimagf.$OBJEXT, cimagl.$OBJEXT): ...these.

	* mingwex/complex/carg.c: Replaced by LIBIMPL; delete it.
	* mingwex/complex/cargf.c mingwex/complex/cargl.c: Likewise.
	* mingwex/complex/creal.c mingwex/complex/cimag.c: Likewise.
	* mingwex/complex/crealf.c mingwex/complex/cimagf.c: Likewise.
	* mingwex/complex/creall.c mingwex/complex/cimagl.c: Likewise.

2014-11-24  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Back-port improved asinh() implementation from 4.0-dev branch.

	* mingwex/math/asinh_generic.c: New file; it replaces...
	* mingwex/math/asinh.c mingwex/math/asinhf.c mingwex/math/asinhl.c:
	...all of these; delete them.

2014-11-18  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Enable remake of lost LIBIMPL object files.

	* Makefile.in (libimpl_remake): New macro; define it, and...
	(%.libimpl.$OBJEXT) [%.libimpl exists]: ...use it in build rule.

2014-11-17  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Implement more robust _get_output_format fallback handling.

	* mingwex/ofmt.c: New file; it implements...
	(__mingw_output_format_flag): ...backing store, used by...
	(__mingw_get_output_format, __mingw_set_output_format): ...these
	MSVCRT.DLL version agnostic wrappers/emulators for each of these...
	(_get_output_format, _set_output_format): ...MSVCR80.DLL and later
	version specific Microsoft APIs, which are also supported by some
	later versions of MSVCRT.DLL, (excluding WinXP and earlier).
	(__mingw_get_output_format_fallback): Implement; it is aliased to...
	(__mingw_set_output_format_fallback): ...this; together they provide
	the emulation support for the preceding pair of functions, when they
	are not available within the run-time platform MSVCRT.DLL
	(__mingw_get_printf_count_output, __mingw_set_printf_count_output):
	Implement them; they wrap, and if necessary emulate...
	(_get_printf_count_output, _set_printf_count_output): ...these.
	(__mingw_get_printf_count_output_fallback): Implement; aliased to...
	(__mingw_set_printf_count_output_fallback): ...this; together they are
	required to support emulation of the preceding pair of functions, when
	they are not available within the run-time platform MSVCRT.DLL

	* include/stdio.h (_TWO_DIGIT_EXPONENT): Define it unconditionally.
	(_THREE_DIGIT_EXPONENT): New manifest constant; define it orthogonally.
	(__mingw_get_output_format, __mingw_set_output_format)
	(__mingw_get_printf_count_output, __mingw_set_printf_count_output):
	Unconditionally declare their prototypes, for subsequent inline use.
	[_MSVCRT_VERSION__ < 0x800] (_get_output_format): Emulate it inline.
	[_MSVCRT_VERSION__ < 0x800] (_set_output_format): Likewise.
	[_MSVCRT_VERSION__ < 0x800] (_get_printf_count_output): Likewise.
	[_MSVCRT_VERSION__ < 0x800] (_set_printf_count_output): Likewise.
	(__USE_MINGW_PRINTF): New manifest constant; define it. It is a
	counterpart to __USE_MINGW_ANSI_STDIO, which is guaranteed to always
	represent a compilable token.

	* mingwex/stdio/pformat.c (__pformat_exponent_digits): Do not require
	_get_output_format; consult __mingw_output_format_flag directly.

	* ofmt_stub.s: No longer required; delete it.

	* Makefile.in (ofmt_stub.$OBJEXT): Delete reference.
	(PFORMAT_CFLAGS) [__MSVCRT_VERSION__ = 0x800]: Remove requirement.
	(varofmt.$OBJEXT, crtofmt.$OBJEXT, getofmt.$OBJEXT, setofmt.$OBJEXT)
	(crtnfmt.$OBJEXT, getnfmt.$OBJEXT, setnfmt.$OBJEXT): Add build rule;
	all are compiled from ofmt.c

2014-11-16  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Do some more essential build tree clean up.

	* Makefile.in (mostly-clean-local): Add *.libimpl; matching files get
	in the way of a successful rebuild from clean.

2014-11-11  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Implement wrappers for emulation of POSIX dlfcn API.

	* include/dlfcn.h: New file; it declares the API.
	* mingwex/dlfcn.c: New file; implement it, with access via...
	(__mingw_dlfcn): ...this publicly addressable vector table.

	* Makefile.in (dlfcn.$OBJEXT): Add build requisite.
	(dlopen, dlsym, dlclose, dlerror): Build call stubs, using...
	(__LIBIMPL__): ...this automatic interface generator; implement it.
	(libstub_refnames): New macro; it is adapted from and replaces...
	(jmpstub_refs): ...this; when it is then invoked twice to build...
	(Makefile.stub): ...this, it handles both JMPSTUB and LIBIMPL.
	(jmpstub_awk_script): Adapt it to work with 'libstub_refnames'.
	(libimpl_awk_script): New inline script; it handles automated builds
	of LIBIMPL interfaces, as 'jmpstub_awk_script' does for JMPSTUB.
	(libimpl_sed_script): New inline script; it prepares intermediate C
	source code for LIBIMPL interfaces, as required to satisfy these...
	(%.libimpl, %.libimpl.$OBJEXT): ...new implicit build objectives.
	(LIBIMPL_CFLAGS): New macro; define it.

2014-11-08  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Move libgen functions to __mingw_ pseudo-namespace.

	* mingwex/dirname.c (dirname): Rename function, as implemented...
	(__mingwex_dirname): ...to this.

	* mingwex/basename.c (basename): Rename function, as implemented...
	(__mingwex_basename): ...to this.

	* include/libgen.h (__mingw_dirname, __mingw_basename): Declare
	prototypes, matching and augmenting original declarations for...
	(dirname, basename): ...these; reimplement as inline aliases, with
	__JMPSTUB__ references to the renamed implementation entry points.

2014-11-08  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Implement new command line argument globbing strategy.

	* include/_mingw.h: Backport feature defines from master...
	(__CRT_GLOB_USE_MINGW__, __CRT_GLOB_USE_MSVCRT__): New manifest
	constants; define them.  They select the preferred globbing algorithm.
	[_CRT_glob & __CRT_GLOB_USE_MINGW__] (__CRT_GLOB_USE_SINGLE_QUOTE__)
	(__CRT_GLOB_BRACKET_GROUPS__, __CRT_GLOB_CASE_SENSITIVE__): New option
	bit-map constants; define them.  When added to __CRT_GLOB_USE_MINGW__,
	they enable optional additional features supported by this algorithm.
	(__CRT_GLOB_ESCAPE_CHAR__): New manifest constant; define it.

	* CRTglob.c (_CRT_glob): Change default to __CRT_GLOB_USE_MINGW__.

	* Makefile.in (libmingw32.a): Add setargv.$OBJEXT, furnished by...
	* setargv.c: ...new file; it implements the initialization mechanism
	for the __CRT_GLOB_USE_MINGW__ globbing algorithm, when invoked by...
	(_setargv) [_CRT_glob & __CRT_GLOB_USE_MINGW__]: ...this new function;
	it invokes the algorithm via an API similar to that described by MSDN,
	while continuing to support our original _CRT_glob interpretation.
	(_setargv) [! _CRT_glob & __CRT_GLOB_USE_MINGW__]: Invoke Microsoft
	algorithm, via the MSDN-alike API, by calling back to...

	* crt1.c (_mingw32_init_mainargs): ...this original function, now
	relocated to here, as a publicly addressable function; formerly...
	(__mingw_CRTStartup): ...called directly from here, we now redirect
	the call through _setargv(), whence it may be called indirectly.

	* init.c: Redundant file; delete it.  It originally provided...
	(_mingw32_init_mainargs): ...this, now relocated as noted above, with
	original static attribute removed, to allow global addressing.

2014-11-07  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Backport glob implementation from master to legacy.

	* include/glob.h: New file; copy it from master branch.
	(__mingw_glob, __mingw_globfree): Add __JMPSTUB__ aliases for...
	(glob, globfree): ...each of these, respectively.

	* mingwex/glob.c: New file; copy it from master:src/libcrt/misc.
	(CRT_GLOB_HARD_ESCAPE) [ifndef __CRT_GLOB_ESCAPE_CHAR__]: Provide a
	fallback definition; default value is ASCII DEL, a.k.a. RUBOUT, code.
	(accept_glob_nocheck_match): New static function; it adds support for
	avoidance of globbing on patterns with no globbing token, so avoiding
	the case transliteration effect reported as MinGW-Bug #2106.
	(glob_match): Use it.

	* Makefile.in: Build glob.$OBJEXT; add it to libmingwex.a

2014-11-05  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Implement conventionally named dirent function trampolines.

	* mingwex/jmpstub.sx: New file; it implements a generic trampoline,
	which redirects a conventionally named function call to its __mingw_
	pseudo-namespace implementation.

	* aclocal.m4 (MINGW_AC_PROG_COMPILE_SX): New macro; define it.
	* configure.ac (MINGW_AC_PROG_COMPILE_SX): Use it; it identifies the
	appropriate protocol for compiling *.sx files, (supported natively by
	GCC >= v4.3, but older versions require `-x assembler-with-cpp').

	* Makefile.in (COMPILE.sx): New implicit rule; GNU make does not
	yet provide it, so we define it ourselves; deploy it for *.sx files.
	(Makefile.stub): New sinclude file; create it dynamically, using...
	(jmpstub_awk_script): ...this new inline script, which is based on...
	(jmpstub_refs, jmpstub_prerequisites): ...these new macros, and...
	(mingwex/jmpstub.sx): ...this new file; add vpath reference.
	(mostlyclean-local): Remove Makefile.stub; do likewise...
	(Makefile): ...when remaking this, to ensure that both will be
	remade together.

2014-11-03  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Make dirent implementation namespace and time_t clean.

	* include/_mingw.h (_EXTERN_C, _BEGIN_C_DECLS, _END_C_DECLS): New
	macros; define them.  They facilitate identification of symbols which
	must be compiled with `extern "C"' binding, when compiling C++ code.
	(__CRT_ALIAS): New macro; define it.  It is intended to replace...
	(_CRTALIAS): ...this, which is to be considered as deprecated.
	(__JMPSTUB__, __LIBIMPL__): New macros; define them.  They provide
	__CRT_ALIAS build hints, while remaining transparent to GCC.
	(UNICODE, _UNICODE) [user defined]: Define consistently.

	* mingwex/dirent.c: Reimplement; (this is a back-port from the
	4.0-dev branch, with additional ABI changes to improve stability).
	(opendir, readdir, telldir, seekdir, rewinddir, closedir)
	(_wopendir, _wreaddir, _wtelldir, _wseekdir, _wrewinddir, _wclosedir):
	Add `__mingw_' prefix to all publicly exposed symbol names.
	(dirent_findfirst, dirent_findnext, dirent_findclose): New locally
	implemented functions; they replace Microsoft's ambiguously defined
	_findfirst, _findnext, and _findclose, so avoiding ABI instability
	resulting from the ambiguous size of Microsoft's time_t.

	* include/dirent.h (struct dirent, struct _wdirent): Redefine them,
	removing unnecessary time_t and file size fields; (our replacements
	for _findfirst, and _findnext do not require them to be present).
	(DIR, _WDIR): Adjust typedefs; they are now opaque structs.
	(opendir, readdir, telldir, seekdir, rewinddir, closedir)
	(_wopendir, _wreaddir, _wtelldir, _wseekdir, _wrewinddir, _wclosedir):
	Adjust prototypes, making them inline aliases for public symbols which
	are now qualified by the `__mingw_' prefix; add build hints to support
	compilation of addressable stubs, with the original symbol names.
	(DT_REG, DT_DIR, DT_UNKNOWN): New manifest constants; define them.
	(DT_BLK, DT_CHR, DT_FIFO, DT_LNK, DT_SOCK): Likewise; (these are for
	BSD compatibility, but are fundamentally unsupported on MS-Windows).
	(_DIRENT_HAVE_D_TYPE, _DIRENT_HAVE_D_RECLEN, _DIRENT_HAVE_D_NAMLEN):
	New macros; define them.  (These show availability of optional fields
	within the dirent struct, which client code may wish to access).

2014-10-31  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Correct improper naming of assembly language source files.

	* mingwex/math/*.S: Rename all files with this extension...
	* mingwex/math/*.s: ...to this; (all are simple assembly language, and
	not extended `assembler-with-cpp' as implied by the former extension);
	adjust all internal `.file <name>' references accordingly.

	* Makefile.in (vpath %.S): Adjust reference to locate files....
	(vpath %.s): ...now renamed thus.

2014-10-29  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Streamline the build system infrastructure.

	* configure.ac: New file; it replaces...
	* configure.in: ...this; (name is obsolete); delete it.

	* aclocal.m4 Makefile.in: Substantially rewritten; avoid recursive
	make invocations, when processing subdirectories, and add automatic
	dependency tracking for all generated files.

	* configure: Delete it; as a generated file, it doesn't belong in SCM.

	* mingwex/Makefile.in: No longer required; delete it.
	* profile/Makefile.in: Likewise.

	* mkinstalldirs: Not required; delete it; (make should use `mkdir -p',
	or fall back on `install-sh -d', per AC_PROG_MKDIR_P).

	* jamfile: Delete it; it hasn't been updated in ages, is likely no
	longer relevant, and I have no desire to maintain it.

2012-08-02  Earnie Boyd  <earnie@users.sourceforge.net>

	Add another more rigorous __STRICT_ANSI__ filter.

	* include/limits.h [__STRICT_ANSI__] (PATH_MAX): Suppress definition.
	* include/sys/param.h [PATH_MAX defined] (MAXPATHLEN): Alias it.
	[PATH_MAX not defined] (MAXPATHLEN): Define it directly.

2012-08-02  Ivan Maidanski  <ivmai@users.sourceforge.net>

	Add missing function prototypes per issue [#1305].

	* include/process.h [#ifndef _WPROCESS_DEFINED]
	(_wexecl, _wexecle, _wexeclp, _wexeclpe, _wexecv, _wexecve)
	(_wexecvp, _wexecvpe, _wspawnl, _wspawnle, _wspawnlp, _wspawnlpe)
	(_wspawnv, _wspawnve, _wspawnvp, _wspawnvpe): Declare them.

2012-08-02  Earnie Boyd  <earnie@users.sourceforge.net>

	Add function prototype declarations per issue [#1293].

	* include/stdio.h (_lock_file, _unlock_file): Declare them.

2012-08-02  Earnie Boyd  <earnie@users.sourceforge.net>

	Apply some more rigorous __STRICT_ANSI__ filtering.

	* include/stdio.h (_getws, _putws, _wfdopen, _wfopen)
	(_wfreopen, _wfsopen, _wtmpnam, _wtempnam, _wrename, _wremove)
	(_wperror, _wpopen): Do not declare these functions unless...
	[#ifndef __STRICT_ANSI__]: ...this is satisfied.

2012-08-02  Earnie Boyd  <earnie@users.sourceforge.net>

	Add string to 64-bit integer conversion function prototypes.

	* include/stdlib.h (_strtoi64, _strtoi64_l, _strtoui64, _strtoui64_l)
	(_wcstoi64, _wcstoi64_l, _wcstoui64, _wcstoui64_l): Declare them.
	* include/wchar.h (_wcstoi64, _wcstoi64_l, _wcstoui64, _wcstoui64_l):
	Likewise; these are duplicates of the <stdlib.h> declarations.

2012-08-01  Earnie Boyd  <earnie@users.sourceforge.net>

	Update for _WIN64 exception handler readiness.

	* include/excpt.h [_WIN64] (__try1, __except1): Add alternative inline
	assembly code implementation, based on X86-64 architecture.

2012-07-30  Earnie Boyd  <earnie@users.sourceforge.net>

	Correct missing inclusion of <_mingw.h>.

	* include/stdint.h: Add omitted #include; all mingwrt headers are
	expected to include this; it is required to define __int64.

2011-11-30  Ozkan Sezer  <sezero@users.sourceforge.net>

	Correct prototypes for _wfindfirst()/_wfindnext() function family.

	* include/io.h (_wfindfirst, _wfindfirst32, _wfindfirsti64)
	(_wfindfirst32i64, _wfindfirst64i32): Return type changed to intptr_t.
	(_wfindnext, _wfindnext32, _wfindnexti64, _wfindnext32i64)
	(_wfindnext64i32, _wfindnext64): Type of parameter #1 must match.

2011-11-30  Earnie Boyd  <earnie@users.sourceforge.net>

	Avoid potential GCC "missing function prototype" warnings.

	* include/stdio.h (getc, putc, getchar, putchar, fopen64)
	(ftello64): Provide a function prototype declaration for each of
	these, prior to the corresponding inline implementation.

2011-08-23  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* include/_mingw.h: Increment version to 3.20.

2011-08-23  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* tlsmthread.c: Update to reflect changes in tlssup.c.
	* tlssup.c: code clean-up.

2011-08-20  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* include/_mingw.h: Increment version to 3.19.

2011-08-19  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* include/float.h: Modify guard to accomodate CLang.

	Thanks to Ruben Van Boxem for the report.

2011-08-19  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* tlssup.c: Remove mingwm10.dll fallback.

2011-08-19  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* include/sys/types.h (ssize_t): Defined as int as opposed to long.

	Thanks to bvassche for the report.

2011-05-31  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Correct checking for short option matches in getopt_long_only().

	* mingwex/getopt.c (getopt_verify): New static inline function.
	(getopt_parse) [getopt_mode_long_only]: Use it, to validate as a
	possible short option match after failing to match, or ambiguously
	matching as a long option.

2011-05-24  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* include/stdlib.h (strtod): Declare as extern to resolve compilation issues.

	Thanks to cgf for the report.

2011-05-23  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* include/time.h (daylight, timezone, tzname): Rework guards to expose when
	compiles with __STRICT_ANSI__.

	Thanks to Felipe Contreras for the report.

2011-05-22  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* include/stdlib.h (strtod): Remove possible static declaration to resolve
	issue with gcc.

	Thanks to Tobias Burnus for the report.

2011-05-22  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* include/stdlib.h (_rotl, _lrotl, _rotr, _lrotr): Resolve conflict with gcc
	by wrapping the functions in brackets.

	Thanks to Kai Tietz for the report.

2011-05-22  A.B., Khalid  <abkhd@users.sourceforge.net>

	* Makefile.in: Add support for msvcr100.dll.
	* msvcrt.def.in: Ditto.

2011-05-22  Antoine LECA  <antoinel@users.sourceforge.net>

	* mingwex/mingw-fseek.c: The anonymous union feature for LARGE_INTEGER is
	not always available, go the long way and use the explicit named union
	members, which are also declared in winnt.h.

2011-05-22  Antoine LECA  <antoinel@users.sourceforge.net>

	* mingwex/isblank.c: Fix typo in declaration.

2011-05-22  Antoine LECA  <antoinel@users.sourceforge.net>

	* include/_mingw.h: Define GCC system_header only if PCC is not defined.
	* include/stdlib.h: Fix a long-standing typo which prevented correct use of
	the MB_CUR_MAX macro/variable when DECLSPEC is not supported and <stdlib.h>
	is included before <ctype.h>.

2011-05-22  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* include/wchar.h: Include stdio.h to grab definition of FILENAME_MAX.

	Thanks to Jim Bell for the report and Greg Chicares for the fix.

2011-01-07  Jacky Lai  <crazyjacky@users.sourceforge.net>

	Correct hexadecimal formatting of double and long double values.

	* mingwex/stdio/pformat.c (__pformat_xdouble): Delete function.
	(__pformat) [A format]: Cast double values to long double, and use...
	(__pformat_xldouble): ...this instead, with corrected adjustment of
	exponent and alignment of mantissa, when formatting subnormals.

2010-12-27  Ozkan Sezer  <sezero@users.sourceforge.net>

	* include/dirent.h (dd_handle): Define as intptr_t.

2010-11-08  Rodrigo Rivas Costa  <rodrigorivascosta@gmail.com>

	* tlssup.c (__dyn_tls_init): Use an integer variable to iterate between
	__xd_a and __xd_z.

2010-08-17  Keith Marshall  <keithmarshall@users.sourceforge.net>

	* include/limits.h (PATH_MAX): Make it agree with Microsoft's
	semantically identical MAX_PATH; correct value is 260.

2010-07-25  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Accept that mingwrt headers are not guaranteed to precede GCC's in the
	system include search path; (issue reported by Mark Brand).

	* include/float.h: Add multiple inclusion guard around...
	[! defined _FLOAT_H___]: ...include_next <float.h> for GCC's version,
	only when this define does not indicate that it has already been seen;
	update comments to document rationale; move it within the scope of...
	[! defined _MINGW_FLOAT_H_]: ...this multiple inclusion guard, so that
	GCC's float.h, after an appropriate complementary modification, need
	not perform a further include path search when this implementation
	specific extension has already been processed.

2010-07-22  Ozkan Sezer  <sezero@users.sourceforge.net>

	* include/io.h (_findfirst, _findnext, _findclose, _findfirst32,
	_findnext32, _findfirsti64, _findnexti64, _findfirst32i64, _findfirst64i32,
	_findnext32i64, _findnext64i32, _findnext64, _findfirst, _findnext,
	_findfirsti64, _findnexti64, _findfirst, _findnext, _findfirsti64,
	_findnexti64): Correct definition.

2010-04-27  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/mb_wc_common.h (get_codepage): Revert change of 2006-09-19.

2010-03-06  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* include/_mingw.h: Increment version to 3.18.

2010-03-02  Daniel Atallah  <datallah@users.sourceforge.net>

	* include/stdio.h: (_vscprintf, _vscwprintf)
	* include/tchar.h: (_vsctprintf)

2010-02-14  Roumen Petrov  <rumen@users.sourceforge.net>

	Issue [2134161]: time64 functions and types for msvcrt >= 8.0
	(initial implementation)

	* new type: __time32_t

	* new structures: _finddata32_t, _finddata32i64_t, _finddata64i32_t,
	__stat32, _stat32i64, _stat64i32, __timeb32, __utimbuf32,
	__wfinddata32_t, _wfinddata32i64_t, _wfinddata64i32_t

	* new functions: _ctime32, _difftime32, _difftime64, _findfirst32
	_findfirst32i64, _findfirst64i32, _findnext32, _findnext32i64,
	_findnext64i32, _fstat32, _fstat32i64, _fstat64i32, _ftime32,
	_futime32, _gmtime32, _localtime32, _mkgmtime32, _mkgmtime64,
	_mktime32, _stat32, _stat32i64, _stat64i32, _time32, _utime32,
	_wctime32, _wfindfirst32, _wfindfirst32i64, _wfindfirst64i32,
	_wfindnext32, _wfindnext32i64, _wfindnext64i32, _wstat32,
	_wstat32i64, _wstat64i32,_wutime32

	* new define _USE_32BIT_TIME_T set 32 or 64 aliases for: time_t,
	ctime, difftime, _findfirst, _findfirsti64, _findnext, _findnexti64,
	_fstat, _fstati64, _ftime, _futime, gmtime, localtime, mktime,
	_stat, _stati64, time, _utime, _wctime, _wfindfirst, _wfindfirsti64,
	_wfindnext, _wfindnexti64, _wstat, _wstati64, _wutime

2010-01-25  Kai Tietz  <kai.tietz@onevision.com>

	Implement TLS Callback.

	* tlsmcrt.c: New file.
	* tlsmthread.c: Ditto.
	* tlssup.c: Ditto.
	* tlsthrd.c: Ditto.
	* Makefile.in: Include new files.
	* crt1.c: Implement TLS Callback.
	* dllcrt1.c: Ditto.
	* mthr_stub.c: Remove.

2009-11-29  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* include/_mingw.h: Increment version to 3.17.

2009-11-25  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* mingwex/gdtoa/misc.c: Fix security vulnerability in gdtoa:
	cf. http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2009-0689

2009-11-13  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* include/io.h (_open_osfhandle): Correct definition.

	Thanks to Alexander Shaduri for the information.

2009-11-02  Charles Wilson  <mingw@cwilson.fastmail.fm>

	Final sync of pseudo-reloc.c with mingw64 and cygwin
	* lib/pseudo-reloc.c (__report_error) [CYGWIN]: Correct size bug
	regarding error messages.

2009-10-29  Charles Wilson  <mingw@cwilson.fastmail.fm>

	Honor DESTDIR for winsup/mingw and winsup/w32api.
	Detect and report error if installation paths are win32
	format, but DESTDIR is non-empty.

	* Makefile.in (DESTDIR): Honor per convention.
	(need-DESTDIR-compatibility): New macro; define it and a
	corresponding rule.
	(fail-DESTDIR-compatibility): New dependency goal.
	(install-dirs): Require need-DESTDIR-compatibility.
	* mingwex/Makefile.in (DESTDIR): Honor per convention.
	(need-DESTDIR-compatibility): New macro; define it and a
	corresponding rule.
	(fail-DESTDIR-compatibility): New dependency goal.
	(install): Require need-DESTDIR-compatibility.
	* profile/Makefile.in: Ditto.

2009-10-25  Charles Wilson  <mingw@cwilson.fastmail.fm>

	Sync pseudo-reloc.c with mingw64
	* psuedo-reloc.c: Remove unnecessary includes.
	Forward declare _pei386_runtime_relocator.
	Decorate _image_base__ symbol with macro for
	mingw64 compatibility. Whitespace changes.
	(__print_reloc_error): Renamed to...
	(__report_error): This. "Returns" void, and
	always aborts. Now used on all platforms.
	(__write_memory): Remove special case error handling
	for different platforms - always call __report_error.
	(do_pseudo_reloc): Remove special case error handling
	for different platforms - always call __report_error.
	(_pei386_runtime_relocator): Decorate _image_base__
	symbol with mingw64 compatibility macro.

2009-10-23  Charles Wilson  <mingw@cwilson.fastmail.fm>

	Sync pseudo-reloc.c with cygwin/lib/
	* pseudo-reloc.c [CYGWIN]: Added comments throughout and various
	whitespace fixes. Exploit cygwin_internal(CW_EXIT_PROCESS,...)
	for fatal error handling that is consistent with cygwin process
	life-cycle. Ensure state variable (in _pei386_runtime_relocator)
	is unique to each address space, across fork().
	[CYGWIN] (__print_reloc_error): New function for reporting
	errors in a manner supported by cygwin at this early stage of
	the process life-cycle.
	[CYGWIN] (_pei386_runtime_relocator): Ensure relocations
	performed only once for each address space, but are repeated
	after fork() in the new address space.
	[MINGW] (__write_memory): Ensure that b is always initialized
	by call to VirtualQuery, even if -DNDEBUG.

2009-09-29  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Make MinGW printf() "%p" format compatible with MSVCRT scanf().
	(Based on MinGW-patch 2844514 by Peter Rosin <peda@lysator.liu.se>)

	* mingwex/stdio/pformat.c (__printf) [%p]: Do not arbitrarily apply...
	(PFORMAT_HASHED): ...this formatting attribute; honour only user
	specified format qualifiers, except in special case...
	[%p && stream.flags == flags && state == PFORMAT_INIT]: Apply...
	(PFORMAT_ZEROFILL): ...this default formatting attribute...
	(stream.precision): ...filled to at least 2 * sizeof( uintptr_t )
	hexadecimal digits.

2009-09-01  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Avoid multiple link time definitions of _printf() for C++;
	(problem reported by Alexander Shaduri, via MinGW-users ML).

	* include/stdio.h [__USE_MINGW_ANSI_STDIO]:
	(__mingw_stdio_redirect__) [__cplusplus]: remove `static' keyword.

2009-08-14  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* include/_mingw.h: Increment version to 3.16.

2009-08-08  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/math.h (__fpclassifyl, __isnan, __isnanf, isnanl, __signbit,
	__signbitf, __signbitl, sinhf, tanhf, expf, frexpf, ldexpf, hypotf, powf,
	__fp_unordered_compare): Add prototypes.
	* include/stdio.h (vsnwprintf): Add prototype.
	* include/wchar.h (vsnwprintf): Add prototype.
	* include/stdlib.h (_Exit): Protect inline definition with !__STRICT_ANSI__.
	* include/unistd.h (ftruncate): Move prototype out of __NO_INLINE__ guard.

2009-07-29  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Correct disposition of wchar_t output in printf().

	* mingwex/stdio/pformat.c (__pformat) [%C]: Create new instance of...
	(argval): ...this, in inner scope, with singular type `wchar_t'; use
	it to pass one wchar to __pformat_wputchars(), for output.

2009-07-27  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* mingwex/stdio/pformat.c: Implement better fix for type punned warning.

2009-07-27  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Convert to monolithic configuration procedure.

	* configure.in (AC_CHECK_TOOL): All instances; tabulate arguments.
	(AC_SUBST): Use its 2nd argument to initialise MinGW default settings.
	(PACKAGE_TARNAME) [target_os ~ cygwin]: Redefine it as appropriate.
	(W32API_INCLUDE): Redefine; make it relative to `top_srcdir'.
	(CRT0S): Relocate from `profile'; define it as appropriate.
	(LIBM_A): Define and AC_SUBST it unconditionally.
	(AC_CONFIG_SUBDIRS): Remove; none to configure.
	(AC_OUTPUT_FILES): Add `Makefile' for each of...
	(mingwex, profile): ...these subdirectories.

	* configure: Regenerated.

	* Makefile.in (PACKAGE, host_os): Let AC_SUBST define them.
	(top_srcdir, top_builddir): New macros; let AC_SUBST define them.
	(datarootdir): New macro; autoconf > 2.59 wants AC_SUBST to define it.
	(SUBDIRS): Define explicitly, to run recursive `make' in...
	(mingwex, profile): ...these; simplify build commands...
	(rootme, rootsrc): ...without these shell variables.
	(all, subdirs): Delete redundant build commands.
	(FIXME): Flag various issues for follow up.

	* mingwex/Makefile.in (INCLUDES): Redefined macro; refer it to...
	(top_srcdir): ...this new macro; let AC_SUBST define it.
	(top_builddir, datarootdir): New macros; let AC_SUBST define them.
	(Makefile): Make it depend on...
	(top_builddir/config.status): ...this, itself depending on...
	(top_srcdir/configure): ...this.
	(FIXME): Flag various issues for follow up.

	* mingwex/aclocal.m4: File no longer required; delete it.
	* mingwex/configure mingwex/configure.in: Likewise.

	* profile/Makefile.in (INCLUDES): Redefined macro; refer it to...
	(top_srcdir): ...this new macro; let AC_SUBST define it.
	(top_builddir, datarootdir): New macros; let AC_SUBST define them.
	(Makefile): Make it depend on...
	(top_builddir/config.status): ...this, itself depending on...
	(top_srcdir/configure): ...this.
	(FIXME): Flag various issues for follow up.

	* profile/aclocal.m4: File no longer required; delete it.
	* profile/configure profile/configure.in: Likewise.

2009-07-23  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* msvcrt.def.in: disable time symbol for libmsvcr90.a and libmsvcr90d.a due
	to complaints that it causes issues.

2009-07-23  Jacky Lai  <crazyjacky@users.sourceforge.net>

	* mingwex/math/fminf.c: switch to using __isnanf() as opposed to _isnan().

2009-07-18  Gregory McGarry  <gregorymcgarry@users.sourceforge.net>

	* include/inttypes.h include/math.h include/stdio.h include/stdlib.h
	include/string.h include/unistd.h include/wchar.h: Add __NO_INLINE__ guard
	to all inline functions.

2009-07-18  Gregory McGarry  <gregorymcgarry@users.sourceforge.net>

	* CRT_fp8.c: Add PCC alternative to GCC-specific constructs.
	* CRT_fp10.c: Ditto.

2009-07-18  Gregory McGarry  <gregorymcgarry@users.sourceforge.net>

	* cpu_features.c: replace gcc-specific construct with portable alternative
	and match the code a few lines above.
	* crt1.c: remove gcc-specific noreturn attribute with mingw alternative

2009-07-18  Gregory McGarry  <gregorymcgarry@users.sourceforge.net>

	* include/_mingw.h: Changes required for PCC compiler.

2009-07-18  Jeff Lu  <jll544@yahoo.com>

	* mingwex/usleep.c: round up to next ms

2009-07-17  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* mingwex/math/cephes_mconf.h mingwex/math/erfl.c mingwex/math/lgamma.c
	mingwex/math/lgammal.c mingwex/math/powl.c mingwex/math/sinhl.c
	mingwex/math/tanhl.c mingwex/math/tgamma.c mingwex/math/tgammal.c: Based on
	the fixes from the mingw-w64 code tree, fixed strict-aliasing issues.

2009-07-12  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* mingwex/stdio/pformat.c: Fix compiler warnings with GCC 4.4.0.

2009-06-28  Ozkan Sezer  <sezero@users.sourceforge.net>

	* mingwex/gdtoa/README.mingw mingwex/gdtoa/gdtoa_fltrnds.h: New files.
	* mingwex/gdtoa/README mingwex/gdtoa/dmisc.c mingwex/gdtoa/dtoa.c
	mingwex/gdtoa/g__fmt.c mingwex/gdtoa/g_dfmt.c mingwex/gdtoa/g_ffmt.c
	mingwex/gdtoa/g_xfmt.c mingwex/gdtoa/gd_arith.h mingwex/gdtoa/gd_qnan.h
	mingwex/gdtoa/gdtoa.c mingwex/gdtoa/gdtoa.h mingwex/gdtoa/gdtoaimp.h
	mingwex/gdtoa/gethex.c mingwex/gdtoa/gmisc.c mingwex/gdtoa/hd_init.c
	mingwex/gdtoa/hexnan.c mingwex/gdtoa/misc.c mingwex/gdtoa/qnan.c
	mingwex/gdtoa/smisc.c mingwex/gdtoa/strtodg.c mingwex/gdtoa/strtodnrp.c
	mingwex/gdtoa/strtof.c mingwex/gdtoa/strtopx.c mingwex/gdtoa/sum.c
	mingwex/gdtoa/ulp.c:  Update the gdtoa library to match the netlib.org
	sources as of Apr. 20, 2009.  Update further to match the sources in
	the mingw-w64 tree as of June 28, 2009, by removing IBM, CRAY and VAX
	code, removing KR_headers, ANSI, Void and Char ifdefs, renaming the
	double/ulong union from U to dbl_union for better grepping and white-
	space tidy-ups.

2009-06-16  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* include/stdlib.h (_wtof): Define.

2009-04-11  Danny Smith  <dannsymith@users.sourceforge.net>

	* include/stdint.h (int_fast8_t): Specify as signed char.
	(INT8_C, UINT8_C, INT16_C, UINT16_C): Simplify: just allow promotion to int.
	(INT32_C, UINT32_C): Remove 'L' type specifier on constant.

2009-03-05  Kai Tietz  <kai.tietz@onevision.com>

	* pseudo-reloc.c: Rewrite to enable pseudo_reloc version 2.

2009-02-08  Keith Marshall  <keithmarshall@users.sourceforge.net>

	MinGW-Feature-Request [2222263]: Make getopt() GNU / BSD compatibile.
	(Requested by Robert Riebisch)

	* mingwex/getopt.c (getopt_parse): Track external increments of...
	(optind): ...this global variable.

2009-01-10  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* include/_mingw.h: Increment version to 3.15.2.

2009-01-04  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Fix MinGW-Bug [2445962]; (reported by Keishi Suenaga).
	Also add tentative support for BSD specific `optreset' feature.

	* include/getopt.h (optreset) [_BSD_SOURCE]: Define; map it to...
	(__mingw_optreset): ...this new global variable.

	* mingwex/getopt.c (__mingw_optreset): Instantiate it...
	(getopt_parse) [optind < 1]: ...make it true; use it to reset argument
	parsing context.

2008-12-31  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Partial fix for MinGW-Bug [2457778]: (Reported by Sisyphus).
	Correct mishandling of invalid characters in printf() format specs.

	* mingwex/stdio/pformat.c (__pformat): Save `fmt' scan position in...
	(backtrack): ...this new automatic variable, at start of each format
	conversion specification substring; use it to backtrack, and print the
	substring literally, if any invalid character is encountered.

2008-12-16  Danny Smith  <dannysmith@users.sourceforge.net>

	* msvcrt.def.in (___lc_codepage_func, ___lc_collate_cp_func,
	___lc_handle_func, ___mb_cur_max_func, ___setlc_active_func,
	___unguarded_readlc_active_add_func, __crtCompareStringW,
	__crtGetStringTypeW, __crtLCMapStringW, __pctype_func,
	__pwctype_func, __iob_func, __uncaught_exception, __wcserror,
	__CxxDetectRethrow, __CxxExceptionFilter, __CxxQueryExceptionSize,
	__CxxRegisterExceptionObject, __CxxUnregisterExceptionObject,
	__CxxCallUnwindDtor, __DestructExceptionObject, _aligned_free,
	_aligned_malloc, _aligned_offset_malloc, _aligned_offset_realloc,
	_aligned_realloc, _cgetws, _cputws, _cwprintf, _cwscanf, _getwch,
	_getwche, _putwch, _resetstkoflw, _scprintf, _scwprintf,
	_set_SSE2_enable, _snscanf, _snwscanf, _strtoi64, _strtoui64,
	_ungetwch, _vscprintf, _vscwprintf, _wcserror, _wcstoi64,
	_wcstoui64, _wctype, _wtof, _get_heap_handle): Always export.

2008-12-08  Dmitry G. Gorbachev  <d.g.gorbachev@gmail.com>

	* cpu_features.c (__cpu_features_init): Remove erroneous ';'.

2008-10-28  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Correct some binary distribution packaging defects.

	* Makefile.in (bindist): Remove `make' conditionals; segregate into...
	(bindist-common, bindist-mingwrt, bindist-mingw-runtime): ...these new
	intermediate goals; they make packages of files, as specified by...
	(BINDIST_FILES, DEVDIST_FILES, DLLDIST_FILES): ...these new macros.
	(dist_prefix) [target_alias !~ cygwin]: Leave it undefined.

2008-10-18  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Fix MinGW-Bug [2136252]: (Reported by Roumen Petrov).
	Remove extraneous radix point in printf( "%.0f", v ) for v < 0.5

	* mingwex/stdio/pformat.c (__pformat_emit_float): Always make output
	of radix point conditional on precision != 0 or `#' flag specified.

2008-10-13  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Fix MinGW-Bug [2160227]
	Eliminate conflicting declarations and implementations of scalb().

	* moldname.def.in (scalb): Comment out of EXPORTS list.
	* include/math.h (scalb): Comment out OLDNAMES prototype; it conflicts
	with GCC's built-in declaration.

2008-10-12  Christopher Faylor  <me+cygwin@cgf.cx>

	* Makefile.in: Use a different method to invoke gcc in a cygwin-hosted
	environment.
	* mingwex/Makefile.in: Ditto.
	* profile/Makefile.in: Ditto.
	* configure.in: Record mingw front-end for building under Cygwin.
	* mingwex/configure.in: Ditto.
	* profile/configure.in: Ditto.
	* configure: Regenerate.
	* mingwex/configure: Ditto.
	* profile/configure: Ditto.

2008-10-11  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Use de-facto standard Makefile goals to invoke test suite.

	* Makefile.in: Some minor formatting adjustments.
	(test_headers): Unconventionally named goal renamed to...
	(check-headers): ...this; make it a prerequisite of...
	(check): ...this new conventionally named goal.

2008-10-11  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Make strtod() inline definition C89 compliant.
	(Issue reported by Ilya Shestopalov and Ian Puleston)
	(Correction identified by Danny Smith)

	* include/stdlib.h (strtod): Declare as `__inline__', not `inline';
	reformat inline function definition.

2008-10-04  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* include/_mingw.h: Increment version to 3.15.1 and introduce
	__MINGW32_PATCHLEVEL variable.

2008-10-03  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Fix MinGW-Bug [2144266]: getopt() sets `optind' incorrectly.
	(Reported by Christian Franke)

	* mingwex/getopt.c (optind): Make global variable value conform to
	behaviour specified by POSIX; do not use it for internal state in...
	(getopt_parse): ...this static function; use...
	(optbase): ...this new static local variable instead.
	(getopt_resolved): Update `optind' as required.

2008-10-03  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Improve package identification in configure script.

	* configure.ac (AC_INIT): Redefine parameters...
	(PACKAGE_NAME): Set to `MinGW Runtime'.
	(PACKAGE_BUGREPORT): Set to `http://mingw.org/reporting_bugs'
	(PACKAGE_TARNAME): Set to `mingwrt'.
	(PACKAGE_VERSION): Set generically to `v3.x'; reassigned by...
	(MINGW_AC_CONFIG_SRCDIR): ...this macro, which extracts...
	(__MINGW32_VERSION): ...this, from file `include/_mingw.h'.

	* aclocal.m4 (MINGW_AC_CONFIG_SRCDIR): Do not redefine...
	(PACKAGE_TARNAME): ...this.

	* configure: Regenerated.

2008-09-25  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Fix MinGW-Bug [2125708].
	(Reported by Alexandr Zamaraev).

	* include/stdlib.h (intptr_t) [!_INTPTR_T_DEFINED]: Unused typedef;
	not wanted here; remove it; replace it by...
	(uintptr_t) [!_UINTPTR_T_DEFINED]: ...this typedef; needed by...
	(_invalid_parameter_handler): ...this function typedef.

2008-09-23  Chris Sutcliffe  <ir0nh34d@users.sf.net>

	* Makefile.in: Don't include host_os as part of snapshot filename.

2008-09-19  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Fix MinGW-Bug [2119504].
	(Reported by Peiyuan Song).

	* mingwex/getopt.c (getopt_resolved): Do not overwrite...
	(*retindex): ...this already correctly assigned return variable...
	(opt[index].val): ...with this; this should have been assigned to...
	(*opt[index].flag) [opt[index].flag != NULL]: ...this instead.

2008-09-19  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Fix MinGW-Bug [2117379].
	(Reported by Peiyuan Song).

	* include/stdio.h (__argv): Replace all references in function
	prototype argument lists and inline function local variables, with ...
	(__local_argv): ...this, to avoid potential conflict with ...
	* include/stdlib (__argv): ...this #defined macro.

2008-09-07  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* include/_mingw.h: Increment version to 3.15.

2008-09-06  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* Makefile.in: Adjust to new naming standard for MinGW while maintaining old
	naming standard for Cygwin.

2008-08-31  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Reimplement getopt.c to add getopt_long_only() function.

	(N.B. this reimplementation removes support for BSD/Mac-OS-X
	`optreset' nonsense; user code should set `optind = 0' instead,
	to reinitialise option scanning).

	* mingwex/getopt.c: Delete all content; reimplement it.
	* include/getopt.h: Likewise.

	* include/unistd.h (__UNISTD_H_SOURCED__): New macro; define it.
	(__UNISTD_GETOPT__): This macro is no longer required; remove it.

2008-08-30  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Implement conditional replacement for printf() family functions.

	* include/_mingw.h (__USE_MINGW_ANSI_STDIO): New macro; define it.
	(__MINGW_ANSI_STDIO__): New manifest constant; define as bitmapped
	flag for use in user specified __MINGW_FEATURES__ attribute.
	(__MINGW_LC_MESSAGES__, __MINGW_LC_ENVVARS__): New manifest constants;
	currently unused: reserved as components of...
	(__MINGW_LC_EXTENSIONS__): ...this new manifest constant; earmarked as
	a __MINGW_FEATURES__ enhancement to setlocale().

	* include/stdio.h (__mingw_printf, __mingw_vprintf): Prototype them.
	(__mingw_fprintf, __mingw_vfprintf): Likewise.
	(__mingw_sprintf, __mingw_vsprintf): Likewise.
	(__msvcrt_printf, __msvcrt_vprintf): Likewise.
	(__msvcrt_fprintf, __msvcrt_vfprintf): Likewise.
	(__msvcrt_sprintf, __msvcrt_vsprintf): Likewise.
	(printf, vprintf) [!__USE_MINGW_ANSI_STDIO]: Prototype for default
	usage; link to DLL import stub, importing from MSVCRT.
	(fprintf, vfprintf) [!__USE_MINGW_ANSI_STDIO]: Likewise.
	(sprintf, vsprintf) [!__USE_MINGW_ANSI_STDIO]: Likewise.
	(printf) [__USE_MINGW_ANSI_STDIO]: Redirect to __mingw_printf; use
	locally defined static stub implementation.
	(fprintf, sprintf) [__USE_MINGW_ANSI_STDIO]: Likewise; redirect to
	__mingw_fprintf and __mingw_sprintf respectively.
	(vprintf) [__USE_MINGW_ANSI_STDIO]: Redirect to __mingw_vprintf; use
	static inline implementation for C++ and GNU C, or locally defined
	static stub otherwise.
	(vfprintf, vsprintf) [__USE_MINGW_ANSI_STDIO]: Likewise; redirect to
	__mingw_vfprintf and __mingw_vsprintf respectively.

2008-08-27  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Avoid access violations, passing NULL to printf( "...%s..." );
	(inconsistencency with MSVCRT and glibc, reported by Colin Harrison).

	* mingwex/stdio/pformat.c (__pformat_puts): Substitute "(null)"
	for argument value, if caller passes a NULL pointer.
	(__pformat_wcputs): Likewise, substitute L"(null)".

2008-08-14  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Add missing dependencies for building libmingwex.a.

	* mingwex/Makefile.in (printf.o, fprintf.o, sprintf.o): Make them...
	(vprintf.o, vfprintf.o, vsprintf.o): ...and also these, depend on...
	(pformat.h): ...this.

2008-08-11  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Add replacements for remaining members of printf() family.

	* mingwex/stdio/printf.c: New file.
	* mingwex/stdio/fprintf.c: New file.
	* mingwex/stdio/sprintf.c: New file.
	* mingwex/stdio/vprintf.c: New file.
	* mingwex/stdio/vfprintf.c: New file.
	* mingwex/stdio/vsprintf.c: New file.

	* mingwex/Makefile.in (STDIO_DISTFILES): Add them.
	(STDIO_OBJS): Add their corresponding object files.

2008-07-29  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Replace __mingw_snprintf() with new generic family implementation;
	likewise, replace __mingw_vsnprintf().

	* mingwex/stdio/pformat.c mingwex/stdio/pformat.h: New files.
	* mingwex/stdio/snprintf.c mingwex/stdio/vsnprintf.c: New files.
	* mingwex/Makefile.in (STDIO_DISTFILES): Add them.
	(GDTOA_DISTFILES): Remove mingw_snprintf.c
	(STDIO_OBJS): Add pformat.o, snprintf.o and vsnprintf.o
	(GDTOA_OBJS): Remove mingw_snprintf.o
	(PFORMAT_CFLAGS): New macro; define it, as required by...
	(pformat.o): ...this new explicit build target.
	(snprintf.o, vsnprintf.o): Declare prerequisites.

	* mingwex/gdtoa/mingw_snprintf.c: Redundant file; delete it.

2008-07-28  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Lay foundations for new printf() function family implementation.

	* ofmt_stub.s: New file; implement forward compatibility stub for...
	(_get_output_format): ...this MSVCR80.DLL and later function.

	* Makefile.in (SRCDIST_FILES): Add ofmt_stub.s.
	(NM, OBJCOPY): New macros; define them with AC_SUBSTed values.
	(sym_prefix, NM_LOOKUP, MINGW_REPL_FUNCS): New macros; define them.
	(lib%.a): Include ofmt_stub.o when import library does not already
	advertise availability of the _get_output_format() function;
	Add alias stubs for MINGW_REPL_FUNCS, such that...
	(__msvcrt_printf): ...is an alias for Microsoft's printf().
	(__msvcrt_fprintf): ...is an alias for Microsoft's fprintf().
	(__msvcrt_sprintf): ...is an alias for Microsoft's sprintf().
	(__msvcrt_vprintf): ...is an alias for Microsoft's vprintf().
	(__msvcrt_vfprintf): ...is an alias for Microsoft's vfprintf().
	(__msvcrt_vsprintf): ...is an alias for Microsoft's vsprintf().
	(clean): Add msvcr*.def.

	* configure.in (NM, OBJCOPY): Use AC_CHECK_TOOL to specify them.
	* configure: Regenerated.

2008-07-06  Gregory McGarry   <gregorymcgarry@users.sourceforge.net>

	* include/ctype.h (_imp____mb_cur_max): Correct spelling.
	(_imp____mb_cur_max_dll): Likewise.

2008-07-04  Danny Smith  <dannysmith@users,sourceforge.net>

	* include/stdio.h (swprintf, vswprintf): Guard with  #ifndef __STRICT_ANSI__
	* include/wchar.h (swprintf, vswprintf): Likewise.

2008-07-01  Keith Marshall  <keithmarshall@users.sourceforge.net>

	* msvcrt.def.in [__msvcr80__, __msvcr80d__, __msvcr90__, __msvcr90d__]
	(_get_output_format, _set_output_format): Add references.

	* include/stdio.h [__MSVCRT_VERSION__ >= 0x800]
	(_get_output_format, _set_output_format): Declare prototypes.
	(_TWO_DIGIT_EXPONENT): Define.
	Some other minor formatting adjustments.

2008-06-14  Danny Smith  <dannysmith@users.sourceforge.net>

	[mingw-Bugs-1801641]
	* include/wchar.h (_wfdopen): Const-ify second arg.
	* include/stdio.h (_wfdopen): Likewise.
	Thanks to <tdragon at users dot sourceforge net>

2008-06-02  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Avoid precision errors in round(), lround() and llround() functions.

	* mingwex/math/round_generic.c: New file; it replaces...
	* mingwex/math/round.c: ...this; delete it.
	* mingwex/math/roundf.c: ...and this; ditto.
	* mingwex/math/roundl.c: ...and this; ditto.

	* mingwex/math/lround_generic.c: New file; it replaces...
	* mingwex/math/lround.c: ...this; delete it.
	* mingwex/math/lroundf.c: ...and this; ditto.
	* mingwex/math/lroundl.c: ...and this; ditto.
	* mingwex/math/llround.c: ...and this; ditto.
	* mingwex/math/llroundf.c: ...and this; ditto.
	* mingwex/math/llroundl.c: ...and this; ditto.

	* mingwex/math/round_internal.h: New file; it provides generic common
	code, which is shared by `round_generic.c' and `lround_generic.c'; the
	implementation is based on techniques suggested by Danny Smith and
	Greg Chicares.

	* mingwex/Makefile.in (MATH_DISTFILES): Remove `round.c', `roundf.c',
	`roundl.c', `lround.c', `lroundf.c', `lroundl.c', `llround.c',
	`llroundf.c' and `llroundl.c'; replace by `round_internal.h',
	`round_generic.c' and `lround_generic.c'.
	(MATH_OBJS): Factor out files listed in...
	(MATH_ROUND_OBJS, MATH_LROUND_OBJS, MATH_LLROUND_OBJS): ...these new
	macros; define them; specify dependencies and build rules; add to...
	(LIB_OBJS): ...this list.

2008-05-22  Danny Smith  <dannysmith@users.sourceforge.net>

	[ mingw-Bugs-1961893 ]
	* mingwex/gdtoa/mingw_snprint.c (x_sprintf): Always set __ldtoa
	mode to 2 for E format.

2008-05-15  Ramiro Polla  <ramiro@lisha.ufsc.br>

	* include/stdlib.h: Fix strtod under C++.

2008-05-06  Ramiro Polla  <ramiro@lisha.ufsc.br>

	* mingwex/gdtoa/strtodnrp.c: Remove alias from strtod to __strtod.
	* include/stdlib.h: Define strtod to __strtod when __NO_ISOCEXT is not set.

2008-05-04  Ramiro Polla  <ramiro@lisha.ufsc.br>

	* include/sys/types.h (useconds_t): typedef.
	* include/unistd.h (usleep): Add prototype.
	* mingwex/usleep.c: New file.
	* mingwex/makefile.in: Add usleep source and object.

2008-05-02  Ramiro Polla  <ramiro@lisha.ufsc.br>

	Make strtod() conform to C99.

	* include/stdlib.h (strtod): Declare this mingwex function, and...
	(_strtod): rename this MSVCRT counterpart.

	* mingwex/gdtoa/strtodnrp.c (strtod): Alias to __strtod.

2008-04-26  Chuck Wilson  <cwilso11@users.sourceforge.net>

	* Makefile.in: correct issues with mingw10.dll having multiple relocs.

2008-04-25  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/process.h: Include stdint.h for intptr_t definition.
	(_execl, _execle, _execlp, _execlpe, _execv, _execve, _execvp, _execvpe,
	_spawnl, _spawnle, _spawnlp, _spawnlpe, _spawnv, _spawnve, _spawnvp,
	_spawnvpe): Return intptr_t.
	(execl, execle, execlp, execlpe, execv, execve, execvp, execvpe, spawnl,
	spawnle, spawnlp, spawnlpe, spawnv, spawnve, spawnvp, spawnvpe): Return
	intptr_t.
	* include/wchar.h: Guard wide process.h functions with !__STRICT_ANSI__.

	[!_WPROCESS_DEFINED]: Include stdint.h for intptr_t definition.
	(_wexecl, _wexecle, _wexeclp, _wexeclpe, _wexecv, _wexecve, _wexecvp,
	_wexecvpe, _wspawnl, _wspawnle, _wspawnlp, _wspawnlpe, _wspawnv, _wspawnve,
	_wspawnvp, _wspawnvpe): Return intptr_t.

2008-04-25  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/wchar.h (fwide): Return success code rather than failure in inline
	definition.
	* mingwex/fwide.c (fwide): ANSI-fy. Get rid of Q8 comments.  Return success
	code rather than failure.

2008-03-21  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/math.h (float_t, double_t): Define.

2008-02-08  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/gdtoa/gdtoaimp.h (USE_LOCALE): Define.
	* mingwex/gdtoa/mingw_snprintf.c: [USE_LOCALE] Include locale.h.
	(x_sprintf): [USE_LOCALE] Use  *localeconv()->decimal_point.

2008-02-28  Joseph Myers  <joseph@codesourcery.com>

	* include/complex.h: Don't condition contents on C99 or not
	__STRICT_ANSI__.

2008-02-01  Brian Dessent  <brian@dessent.net>

	* Makefile.in: Add rules to generate multiple versions of libmoldname.a for
	the different runtime versions.

2008-01-19  Danny Smith  <dannysmithusers.sourceforge.net

	* inclue/wchar.h (fwide): Add prototype and guard inline definition.
	(mbsinit): Likewise.

2007-12-27  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* include/_mingw.h: Increment version to 3.14.

2007-11-26  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* Makefile.in: Add libmsvcr90.a and libmsvcr90d.a targets.
	* msvcrt.def.in: Add support for __msvcr90__ and __msvcr90d__ defines.
	* mingwex/math/log10f.S: Correct issue with comments.
	* mingwex/math/log10l.S: Ditto.
	* mingwex/math/log1p.S: Ditto.
	* mingwex/math/log1pf.S: Ditto.
	* mingwex/math/log1pl.S: Ditto.
	* mingwex/math/log2.S: Ditto.
	* mingwex/math/log2f.S: Ditto.
	* mingwex/math/log2l.S: Ditto.
	* mingwex/math/logf.S: Ditto.
	* mingwex/math/logl.S: Ditto.

2007-10-03  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/gdtoa/mingw_snprintf.c: fixed warning during compile.

2007-10-03  Bernd Becker  <hugin@users.sourceforge.net>

	* include/io.h (__finddata64_t, __wfinddata64_t): changed member 'size'
	from '_fsize_t' to '__int64' to be consistent with the other ...64
	structures and the value set there is 8 bytes not 4.  Add guard for both
	as the are only used by functions available from 6.1 on.

	* include/malloc.h (_HEAP_MAXREQ): Define.
	(_aligned_offset_recalloc): Define.
	(_aligned_recalloc()): Define.

	* include/math.h: fixed a typo in a comment.
	(atanhf): Fixed declaration.

	* include/wchar.h (__wfinddata64_t): changed member 'size' from '_fsize_t'
	to '__int64' to be consistent with the other ...64 structures and the value
	set there is 8 bytes not 4.  Added guard as this function is only used by
	functions available from 6.1 on.

	* include/sys/stat.h: some members of 'stat' were declared with types with
	a prefixed underscore, while the ones without the underscore should have
	been used.  Added guard to '__stat64' as it is only used by functions
	available from 6.1 on.  Added the wide character versions of the
	exec()/spawn() family for completion
	(_stati64): changed the type of the 'st_mode' member from 'unsigned int' to
	'_mode_t'

	* include/sys/timeb.h (timeb, _timb): changed the type of the 'time' member
	from 'long' to 'time_t'
	(__timeb64): moved declaration of structure directly before the declaration
	of the function '_ftime64()', so it is guarded as well

	* include/sys/utime.h (__utimbuf64): moved declaration of structure directly
	before the declaration of the functions using it, so it is guarded as well

2007-09-24  David C. Daeschler  <daveregs@rsaisp.com>

	* mingwex/gdtoa/mingw_snprintf.c (x_sprintf): Correct LEN_L typo in 'l'
	case.  Add missing break in 's'/LEN_S case.

2007-08-25  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Make snprintf() and vsnprintf() conform to C99.

	* include/stdio.h: Add note about incompatibility between...
	(snprintf, vsnprintf): These two mingwex functions, and...
	(_snprintf, _vsnprintf): these MSVCRT counterparts.

	* mingwex/Makefile.in (STDIO_OBJS): Remove snprintf.o and vsnprintf.o
	(STDIO_DISTFILES): Remove snprintf.c and vsnprintf.c

	* mingwex/stdio/snprintf.c: Delete.
	* mingwex/stdio/vsnprintf.c: Delete.

	* mingwex/gdtoa/mingw_snprintf.c (snprintf): Alias to __mingw_snprintf
	(vsnprintf): Alias to __mingw_vsnprintf.

2007-07-25  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* include/_mingw.h: Increment version to 3.13.
	* Makefile.in: Reset CYGRELEASE to 1

2007-07-23  Keith Marshall  <keithmarshall@users.sourceforge.net>

	* Makefile.in (SUBDIRS): Delete stray line continuation artifact,
	resulting from incomplete removal of enclosing `for ...; do ...; done'
	loop from compound command; (reported by Greg Chicares).

2007-07-19  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/fcntl.h (_O_WTEXT, _O_U16TEXT, _O_U8TEXT) Define for
	Vista.

2007-07-12  Danny Smith  <dannysmith@users.sourceforge.net>

	[mingw-Bugs-1734142]
	* include/wchar.h (_wsystem) Declare.
	(_wputenv) Declare.
	(_wgetenv): Declare.
	(_wsearchenv): Declare.
	(_wmakepath): Declare.
	(_wsplitpath): Declare.
	(_wfullpath): Declare.
	* include/stdlib.h (_wsystem) Declare.
	(_wputenv, _wgetenv, _wsearchenv, _wmakepath, _wsplitpath,
	_wfullpath): Move into _WSTDLIB_DEFINED guard.
	* include/tchar.h (_tsystem): New UNICODE mapping define.

2007-06-29  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/gdtoa/mingw_snprintf.c: New file.
	* mingwex/Makefile.in (GDTOA_DISTFILES): Add mingw_snprintf.c.
	(GDTOA_OBJS): Add mingw_snprintf.o.

2007-06-28  Danny Smith  <dannysmith@users.sourceforge.net>

	* msvcrt.def.in: Update comment.
	Exclude _ctype stub if using msvcr71.dll or newer.
	* include/ctype.h: Don't declare _ctype if using msvcr71.dll or newer.
	* include/wctype.h: Likewise.

2007-06-23  Danny Smith  <dannysmith@users.sourceforge.net>

	*include/wctype.h: Qualify all functions with __MINGW_NOTHROW.
	*include/dirent.h: Likewise.

2007-06-23  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/assert.h: Qualify all  functions with __MINGW_NOTHROW.
	* include/conio.h: Likewise.
	* include/ctype.h: Likewise.
	* include/direct.h: Likewise.
	* include/dos.h: Likewise.
	* include/errno.h: Likewise.
	* include/fenv.h: Likewise.
	* include/float.h: Likewise.
	* include/inttypes.h: Likewise.
	* include/io.h: Likewise.
	* include/libgen.h: Likewise.
	* include/locale.h: Likewise.
	* include/malloc.h: Likewise.
	* include/mbctype.h: Likewise.
	* include/mbstring.h: Likewise.
	* include/process.h: Likewise.
	* include/search.h: Likewise.
	* include/setjmp.h: Likewise.
	* include/signal.h: Likewise.
	* include/stdio.h: Likewise.
	* include/stdlib.h: Likewise.
	* include/string.h: Likewise.
	* include/time.h: Likewise.
	* include/wchar.h: Likewise.
	* include/sys/stat.h: Likewise.
	* include/sys/time.h: Likewise.
	* include/sys/timeb.h: Likewise.
	* include/sys/utime.h: Likewise.

2007-06-22  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/Makefile.in (LIB_OBJS): Revert accidental removal.

2007-06-22  Danny Smith  <dannysmith@users.sourceforge.net>

	Add POSIX binary tree search API.

	* mingwex/tfind.c: New file.
	* mingwex/tdelete.c: New file.
	* mingwex/tsearch.c: New file.
	* mingwex/twalk.c: New file.
	* mingwex/Makefile.in (DISTFILES): Add tsearch.c twalk.c tdelete.c tfind.c.
	* mingwex/Makefile.in (POSIX_OBJS): Add tsearch.o twalk.o tdelete.o tfind.o.
	* include/search.h (tfind): Declare.
	(tdelete): Declare.
	(tsearch): Declare.
	(twalk): Declare.
	(ENTRY): Define.
	(ACTION): Define.
	(VISIT): Define.
	(node_t): Define, on condition of _SEARCH_PRIVATE.

2007-06-22  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/_mingw.h (__MINGW_NOTHROW): Define.

2007-06-18  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/stdio.h (vsnprintf): Remove inline definition.
	Add prototype.

2007-06-16  Danny Smith  <dannysmith@users.sourceforge.net>

	* CRTfmode.c: Nit-pick comment fix.

2007-06-16  Christopher Faylor  <me+cygwin@cgf.cx>

	* CRTfmode.c: Fix nested comment.

2007-06-16  Christopher Faylor  <me+cygwin@cgf.cx>

	* include/string.h (strcasecmp): Fix typo in declaration prototype.

2007-06-14  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/io.h (lseek64) : Add prototype.

2007-06-14  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/string.h (strcasecmp): Add prototype.
	(strncasecmp): Add prototype.

2007-06-13  Danny Smith  <dannysmith@users.sourceforge.net>

	* Makefile.in (CRT0S): Revert last change.
	* CRTfmode.c. Correct comment.

2007-06-13  Danny Smith  <dannysmith@users.sourceforge.net>

	* Makefile.in (CRT0S): Add back CRTfmode.o.

2007-06-13  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/stdlib.h: Don't include stdint.h. Conditionally define intptr_t.
	* include/io.h: Likewise.

2007-06-11  Danny Smith  <dannysmith@users.sourceforge.net>

	* crt1.c (__mingw_CRTStartup): Add explicit call to gcc's __main.

2007-05-08  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/stdint.h (intptr_t): Fix typo.
	Thanks to Charles Wilson for report.

2007-05-07  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/stdint.h (intptr_t): Protect with _INTPTR_T_DEFINED.
	 Condition on _WIN64.
	(uintptr_t): Protect with _UINTPTR_T_DEFINED. Condition on _WIN64.
	(INTPTR_MIN, INTPTR_MAX, UINTPTR_MAX): Condition on _WIN64.
	(PTRDIFF_MIN): Define as INTPTR_MIN.
	(PTRDIFF_MAX): Define as INTPTR_MAX.
	(SIG_ATOMIC_MIN): Define as INTPTR_MIN.
	(SIG_ATOMIC_MAX): Define as INTPTR_MAX.

2007-04-07  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* Makefile.in: Removed mansuffix variable. Changed mansection to support
	Cygwin man page location.

2007-04-05  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* Makefile.in: Added mansection and mansuffix variables. Changed mandir to
	support Cygwin man page location.

2007-03-25  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* Include/_mingw.h: Increment version to 3.12.

2007-03-22  Brian Ripley  <ripleybd@users.sourceforge.net>

	* include/_mingw.h (__CRT_INLINE): Make conditional on __GNUC_STDC_INLINE__.

2007-03-20  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* Makefile.in: Tweak srcdist to fix build issue.

2007-03-20  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Add --enable-mingw-manpage-transform configure option.

	* aclocal.m4 (MINGW_AC_MANPAGE_TRANSFORM): New macro.
	* configure.in, Makefile.in: Use it.
	* configure: Regenerated.

2007-03-18  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/_mingw.h (__CRT_INLINE): Use __gnu_inline__ for gcc 4.2.x too.

2007-03-10  Keith Marshall  <keithmarshall@users.sourceforge.net>

	Add manpages for dirname and basename functions.

	* man: New directory.
	* man/dirname.man: New file; it sources both manpages.
	* Makefile.in: Add provisional rules to distribute them.

2007-03-08  Keith Marshall  <keithmarshall@users.sourceforge.net>

	* mingwex/basename.c: Make it work with path names containing
	multibyte character strings.
	* mingwex/dirname.c: Likewise.

2007-03-05  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/io.h (__mingw_access): New static inline wrapper to restore
	pre-Vista 'access (fname, X_OK)' behaviour.
	(__USE_MINGW_ACCESS): Use to map access() to __mingw_access().

2007-03-05  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/fesetround.c (fesetround): Use unsigned int as operand
	to stmxcsr.
	Thanks to Alexey Kuznetsov <ring0_mipt at users dot sf dot net>

2007-02-27  Thorsten Dahlheimer  <tdahlheim@gmx.net>

	* include/stdio.h (_unlink, unlink): Add prototypes.

2007-02-18  Aurimas Cernius  <aurisc4@gmail.com>

	* include/excpt.h: Replace "_try1" in comments with "__try1".

2007-02-15  Danny Smith  <dannysmith@users.sourceforge.net>

	* Makefile.in (ALL_CFLAGS): Put W32API_INCLUDE after INCLUDES.
	(ALL_CXXFLAGS): Likewise.
	* mingwex/Makefile.in (ALL_CFLAGS): Put W32API_INCLUDE after INCLUDES.
	(ALL_CXXFLAGS): Likewise.
	* profile/Makefile.in (ALL_CFLAGS): Put W32API_INCLUDE after INCLUDES.
	(ALL_CXXFLAGS): Likewise.

2007-02-08  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/io.h (X_OK): Revert 2007-01-24 change, but leave comment.

2007-01-27  Danny Smith  <dannysmith@users.sourceforge.net>

	Expose some more msvcr80.dll functions.
	* include/stdio.h (_fseek_nolock. _ftell_nolock, _fseeki64,
	_ftelli64, _fseeki64_nolock, _ftelli64_nolock) Add prototypes
	* msvcrt.def.in (_fseek_nolock. _ftell_nolock, _fseeki64,
	_ftelli64, _fseeki64_nolock, _ftelli64_nolock) Add stubs.

2007-01-26  Danny Smith  <dannysmith@users.sourceforge.net>

	Expose some msvcr80.dll functions.
	* include/stdlib.h (_set_abort_behavior): Add prototype.
	(_WRITE_ABORT_MSG, _CALL_REPORTFAULT): Add defines for
	_set_abort_behavior mask argument.
	(_invalid_parameter_handler): Add typedef.
	(_set_invalid_parameter_handler): Add prototype.
	* include/stdio.h (_get_printf_count_output): Add prototype.
	(_set_printf_count_output): Add prototype.
	* msvcrt.def.in (_get_printf_count_output,_set_printf_count_output,
	_set_abort_behavior, _set_invalid_parameter_handler): Add stubs.

2007-01-26  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/_mingw.h (CRT_INLINE): Correct typo.

2007-01-24  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/io.h (X_OK): Define to F_OK.

2007-01-19  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/stdio.h (SEEK_SET, SEEK_CUR, SEEK_END): Define
	unconditionally. Change comment.
	* include/unistd.h (SEEK_SET, SEEK_CUR, SEEK_END): Define
	here too.
	* include/io.h (rename): Declare.
	(remove): Declare.

2006-12-31  Keith Marshall  <keithmarshall@users.sourceforge.net>

	* include/libgen.h: New file; required by...
	* mingwex/basename.c, mingwex/dirname.c: New files.
	* mingwex/Makefile.in (DISTFILES): Add them...
	(POSIX_OBJS): ...with corresponding basename.o, dirname.o
	(Dependencies): Typo; s/Dependancies/Dependencies/

2006-11-25  Keith Marshall  <keithmarshall@users.sourceforge.net>

	* Makefile.in (VERSION): Let configure define it.

	* aclocal.m4 (MINGW_AC_CONFIG_SRCDIR): New macro.
	* configure.in: Use it.
	Correct quoting of autoconf macro arguments throughout.
	(AC_INIT, AC_OUTPUT): Update to autoconf 2.5x preferred syntax.
	(AR, AS, RANLIB, LD, DLLTOOL, DLLWRAP): Don't need AC_SUBST.
	(AC_ALLOCA): Invalid after GCC_NO_EXECUTABLES; removed.
	(AC_CONFIG_FILES): Add, to generate Makefile.

	* configure: Regenerated.

2006-11-21  Danny Smith  <dannysmith@users.sourceforge.net>

	* Makefile.in: Add aclocal.m4 to source release.
	* mingwex/Makefile.in: Ditto.
	* profile/Makefile.in: Ditto.

2006-11-18  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* Include/_mingw.h: Increment version to 3.11.
	* Makefile.in: Ditto.

2006-11-09  Danny Smith  <dannysmith@users.sourceforge.net>

	[ mingw-Bugs-1590623 ]
	* include/_mingw.h (__CRT_INLINE): Use __gnu_inline__ attribute
	in C99 mode.

2006-10-04  Corinna Vinschen  <corinna@vinschen.de>

	* Makefile.in: Semi-revert semi-reversion of 2006-08-30 change, now
	correctly parenthesized.

2006-09-19  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/mb_wc_common.h (get_codepage): Get it
	from __lc_codepage.

2006-09-18  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/gdtoa/g_xfmt.c (g_xfmt): Fix representation of infinity.
	Use fpclassify.
	* mingwex/gdtoa/strtopx (__strtopx): Avoid cast of long double* to
	void*.
	* mingwex/gdtoa/gdtoa.h (__g_fmt): Make declaration consistent with
	others.

2006-09-16  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/gdtoa/strtopx.c (strtopx): Fix long double representation
	of infinity.

2006-09-11  Christopher Faylor  <cgf@timesys.com>

	* Makefile.in: Semi-revert 2006-08-30 change.

2006-09-10  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/_mingw.h (__MINGW_ATTRIB_DEPRECATED): Define.
	(__MINGW_IMPORT): Ansify.
	* include/stdlib.h (_sleep, _beep, _seterrormode): Add
	__MINGW_ATTRIB_DEPRECATED.

2006-09-10  Keith Marshall  <keithmarshall@users.sourceforge.net>

	* aclocal.m4 (LIB_AC_PROG_CC, LIB_AC_PROG_CC_GNU, LIB_AC_PROG_CXX):
	Redundant macros; deleted.

	* configure.in (LIB_AC_PROG_CC): Replaced by...
	(AC_PROG_CC): ...this.

	* configure: Regenerated.

2006-09-06  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/gdtoa/misc.c (pow5mult): Restore original code.
	* mingwex/gdtoa/gdtoa.h. Add comment that files have been modified.
	* mingwex/gdtoa/gdtoaimp.h: Include system headers with <> brackets.

2006-09-01  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/gdtoa/(arithchk.c, dmisc.c, dtoa.c, g__fmt.c, g_dfmt.c,
	g_ffmt.c, g_xfmt.c, gd_arith.h, gd_qnan.h, gdtoa.c, gdtoa.h,
	gdtoaimp.h, gethex.c, gmisc.c, hd_init.c, hexnan.c, misc.c, qnan.c,
	README, smisc.c, strtodg.c, strtodnrp.c, strtof.c, strtopx.c, sum.c,
	ulp.c): New files.
	* mingwex/(strtof.c, strtold.c, ldtoa.c): Remove files.
	* mingwex/math/(cephes-emath.c, cephes-emath.h): Remove files.
	* mingwex/mb_wc_common.h (get_cp_from_locale); Rename to get_codepage().
	* mingwex/(btowc.c, wctob.c, mbrtowc.c, wcrtomb.c): Adjust call to get_codepage().
	* mingwex/wcstold.c: Avoid using strtold internals.
	* mingwex/wcstof.c: Rewrite.
	* mingwex/Makefile.in (GDTOA_DISTFILES): Add to distribution.
	(GDTOA_OBJS): Add to library.
	(DISTFILES): Remove strtof.c strtold.c ldtoa.c cephes-emath.c cephes-emath.h.
	(STDLIB_OBJS): Remove.
	(STDLIB_STUB_OBJS): Remove strtof.o wcstof,o.
	(Q8_OBJS): Add wcstof.o wcstold.o.
	* include/stdlib.h (strtof): Remove inline definition.
	(wcstof): Likewise.
	* include/wchar.h (wcstof): Remove inline definition.

2006-08-30  Corinna Vinschen  <corinna@vinschen.de>

	* Makefile.in: Add with_cross_host to allow more granular checks.
	Set installation directories accordingly. Override CC setting only
	if building a Cygwin target.
	* aclocal.m4: Regenerate.
	* configure.in: Move AC_CANONICAL_SYSTEM check up. Add
	GCC_NO_EXECUTABLES. Substitute with_cross_host in depending files.
	Test AC_ALLOCA only if building on a native system.
	* configure: Regenerate.

2006-08-27  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* include/ctype.h: Fix typo.

2006-08-25  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/ctype.h: Expose iswblank if __cplusplus.
	* include/wctype.h: Expose iswblank if __cplusplus.

2006-08-03  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/ctype.h: Remove stray ')';

2006-08-03  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/ctype.h (_BLANK): Expand comment.
	(isblank): Add prototype and inline definition.
	(iswblank): Add prototype and inline definition.
	* include/wctype.h (iswblank): Add prototype and inline definition.
	* mingwex/isblank.c: New file.
	* mingwex/iswblank.c: New file.
	* mingwex/Makefile.in: Add isblank, iswblank to libmingwex.a

2006-07-06  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/math.h (__INFF,__INFL): Remove '#'.

2006-07-04  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/Makefile.in: Add -I$(srcdir)/.. to INCLUDES.

2006-07-03  Danny Smith  <dannysmith@users.sourceforge.net>

	Support SSE float environment in fenv.h functions.
	* cpu_features.c: New file.
	* cpu_features.h: New file.
	* crt1.c: Include "cpu_features.h".
	(__mingw_CRTStartup): Call cpu_features_init().
	* Makefile.in (MING_OBJS): Add cpu_features.c.
	(SRCDIST_FILES): Add cpu_features.c, cpu_features.h.
	* include/fenv,h ( fenv_t;): Append __mxcsr field.
	(__MXCSR_EXCEPT_FLAG_SHIFT): New define.
	(__MXCSR_EXCEPT_MASK_SHIFT): New define.
	(__MXCSR_ROUND_FLAG_SHIFT): New define.
	* mingwex/feclearexcept.c: Include "cpu_features.h".
	Handle SSE environment.
	* mingwex/fegetenv.c: Likewise.
	* mingwex/feholdexcept.c: Likewise.
	* mingwex/fesetenv.c: Likewise.
	* mingwex/fesetexceptflag.c: Likewise.
	* mingwex/fesetround.c: Likewise.
	* mingwex/fetestexcept.c: Likewise.
	* mingwex/feupdateenv.c: Likewise.
	* mingwex/fegetround.c: Add comment.

2006-06-25  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* Include/_mingw.h: Increment version to 3.10.
	* Makefile.in: Ditto.

2006-06-26  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/math/tgamma.c (SQTPI): Add braces.

2006-06-26  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/wcrtomb.c (wcsrtombs): Fix src end-pointer thinko.
	* mingwex/math/lgamma.c: (LOGPI) Avoid type punning.
	(LS2PI): Likewise.
	* mingwex/math/sf_erf.c (erff): Initialize z.
	(erfcf): Likewise.
	* mingwex/math/tgamma.c (SQTPI): Avoid type punning.

2006-06-25  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* Include/_mingw.h: Increment version to 3.10.
	* Makefile.in: Ditto.

2006-06-23  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/sys/time.h (struct timezone): Define.
	* include/time.h: Correct comment about timezone.

2006-06-18  Danny Smith  <dannysmith@users.sourceforge.net>

	* configure.in (AC_CONFIG_AUX_DIR): Remove.
	* configure: Regenerate.

2006-06-18  Chris Sutcliffe  <ir0n3h4d@users.sourceforge.net>

	* configure: add srcdir as a possible location for install-sh.

2006-06-18  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/dirent.c (_tGetFileAttributes): New helper function.
	(_topendir): Use it.

2006-06-18  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/sys/time.h: Add header guard. Add extern "C" bracketing
	for __cplusplus.
	(gettimeofday): Add prototype.
	* mingwex/gettimeofday.c: New file.
	* mingwex/makefile.in: Add gettimeofday source and object.

2006-06-13  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/math.h (HUGE_VAL): Define as builtin if __GNUC__ >= 3.3,
	else global library variable.
	(HUGEVALF): Likewise.
	(HUGEVALL): Likewise.
	(INFINITY): Likewise.
	(NAN): LiKewise.

2006-06-13  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/wcrtomb.c (wcrtomb_cp): Correct typo.

2006-06-13  Danny Smith  <dannysmith@users.sourceforge.net>

	* Makefile.in (SUBDIRS): Change to lowercase for autoconf 2.59.

2006-05-24  Christopher Faylor  <cgf@timesys.com>

	* configure.in: Update to newer autoconf.
	(thanks to Steve Ellcey)
	* mingwex/configure.in: Ditto.
	* profile/configure.in: Ditto.
	* configure: Regenerate.
	* mingwex/configure: Ditto.
	* profile/configure: Ditto.
	* aclocal.m4: New file.
	* mingwex/aclocal.m4: Ditto.
	* profile/aclocal.m4: Ditto.

2006-05-17  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/wcrtomb.c (wcrtomb_cp): Test (wc > 255) only if C locale.
	Use supplied codepage as arg to WideCharToMultiByte.

2006-02-13  Earnie Boyd  <earnie@users.sf.net>

	* Makefile.in (libmsvcr80.a): Add import lib.
	(libmsvcr80d.a): Ditto.

2006-01-18  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* Makefile.in: Bump cygwin build number.

2005-10-27  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* Include/_mingw.h: Increment version to 3.9.
	* Makefile.in: Ditto.

2005-10-14  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/limits.h (SSIZE_MAX): Define.
	(LLONG_MAX, LLONG_MIN, ULLONG_MAX): Separate from non-ISO names.

2005-10-13  Wu Yongwei  <adah@users.sourceforge.net>

	* include/tchar.h: Include <wchar.h> when _UNICODE is defined.
	(_TEOF): New macro definition for _UNICODE and non_UNICODE cases.

2005-10-12  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/stddef.h: Remove.
	* include/stdarg.h: Remove.

2005-10-12  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/complex/csqrt.c (csqrt): The sign of real part
	of result is positive when real part of arg == 0;
	* mingwex/complex/csqrtf.c (csqrtf): Ditto.
	* mingwex/complex/csqrtl.c (csqrtl): Ditto.

2005-10-12  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/time.h (_time64): Correct prototype.

2005-10-08  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/fegetenv.c (fegetenv): Restore exception masks.
	* mingwex/feholdexcept.c (feholdexcept): Don't set exceptions
	to non-stop. Use "fnclex" to clear exception flags.

2005-09-24  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/math.h (HUGE_VALF, HUGE_VALL, INFINITY, NAN)
	Avoid raising FP exceptions.

2005-09-19  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/stdlib.h (strtof): Add prototype. Uglify
	parameter names in inline definition.
	(wcstof): Likewise.
	(_Exit): Uglify	parameter names in inline definition.
	(llabs): Add prototype.
	(_set_error_mode): Add prototype and input defines.

2005-08-25  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/fe*.c: Revert previous changes.
	* include/fenv.h: Revert previous changes.

2005-08-25  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/feclearexcept.c (feclearexcept): Change declaration.
	Do not return a value.
	* mingwex/fegetexceptflag.c (fegetexceptflag): Likewise.
	* mingwex/feraiseexcept.c (feraiseexcept): Likewise.
	* mingwex/fesetexceptflag.c (fesetexceptflag): Likewise.
	* mingwex/fegetenv.c (fegetenv): Likewise.
	* mingwex/fesetenv.c (fesetenv): Likewise.
	* mingwex/feupdateenv.c (feupdateenv): Likewise.
	* include/fenv.h (feclearexcept, fegetexceptflag, feraiseexcept,
	fesetexceptflag, fegetenv, fesetenv, feupdateenv): Correct
	prototypes.

2005-08-25  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/stdio/fseeko64.c (fseeko64): Flush stream before
	getting filelength for SEEK_END.

2005-08-13  Chris Sutcliffe  <ir0nh34d@users.sourceforge.net>

	* Include/_mingw.h: Increment version to 3.8.
	* Makefile.in: Ditto.

2005-08-10  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/wctype.h (towupper, towlower): Change arg and return value
	types to wint_t.
	* include/ctype.h (towupper, towlower): Likewise.

2005-08-10  Danny Smith  <dannysmith@users.sourceforge.net>

	* mthr_stub.c (__mingwthr_key_dtor): Replace assert(0) with
	a diagnostic, guarded by #ifdef DEBUG.
	(__mingwthr_remove_key_dtor): Likewise.

2005-08-08  Danny Smith  <dannysmith@users.sourceforge.net>

	* moldname.def.in (sleep, beep, seterrormode): Remove.

2005-06-16  Danny Smith  <dannysmith@users.sourceforge.net>

	* profile/profile.h (_MCOUNT_CALL): Define as regparm(2)
	(_MCOUNT_DECL): Use it.
	(MCOUNT): Save and restore eax, ecx, edx registers.
	* profile/mcount.c (_mcount): ANSI-fy.

2005-06-16  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/_mingw.h (__MINGW_GNUC_PREREQ): Define. Use to
	guard __MINGW_ATTRIB macro definitions.
	* include/math.h (logb[fl]): Don't define inlines for
	GCC-4.0+ && __FAST_MATH__.
	(rint[fl], lrint[fl], llrint[fl]); Likewise. Clean up
	line-continuation backslashes.

2005-06-06  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/_mingw.h (__MINGW_ATTRIBUTE_NONNULL): Fix typo
	in GNUC version guard.

2005-05-20  Danny Smith  <dannysmith@users.sourceforge.net>

	* crt1.c (_gnu_exception_handler): Handle illegal instruction
	OS exception as a signal if user has defined a SIGILL handler.

2005-05-10  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/math/nexttoward.c: New file.
	* mingwex/math/nexttowardf.c: New file.
	* mingwex/math/nextafterl.c: Add nexttowardl alias.
	* mingwex/Makefile.in (MATH_DISTFILES): Add nexttoward.c,
	mexttowardf.c,
	(MATH_OBJS): Add nexttoward.o,	nexttowardf.o,
	* include/math.h (nexttoward, nextowardf, nexttowardl): Add
	prototypes.

2005-05-09  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/math/nextafterf.c (nextafterf): Correct
	handling of -0.0.
	* mingwex/math/nextafterl.c: New file.
	* mingwex/Makefile.in (MATH_DISTFILES): Add nextafterl.c.
	(MATH_OBJS): Add nextafterl.o.
	* include/math.h (nextafterl): Uncomment prototype.

2005-05-08  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/math/erfl.c: New file.
	* mingwex/Makefile.in (MATH_DISTFILES): Add erfl.c.
	(MATH_OBJS): Add erfl.o.
	* include/math.h (erfl, erfcl): Uncomment prototypes.

2005-05-04  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/wchar.h (WCHAR_MAX): Define as 0xffff, so preprocessor
	#if (WCHAR_MAX <= WCHAR_MIN) is false.
	* include/stdint.h (WCHAR_MAX): Likewise.
	(WINT_MAX): Likewise.

2005-05-03  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/math/signbit.c (__signbit): Make return value
	consistent with GCC's __builtin_signbit.
	* mingwex/math/signbitf.c (__signbitf): Likewise.
	* mingwex/math/signbitf.c (__signbitl): Likewise.
	* include/math.h (__signbit, __signbitf, __signbitl): Likewise
	for inlines.

2005-05-02  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/_mingw.h (__MINGW_ATTRIB_NONNULL): Don't define as
	variadic macro.
	* mingwex/mbrtowc.c (__mbrtowc_cp): Use __MINGW_ATTRIB_NONNULL.
	Remove unused MBTOWC_FLAGS define.

2005-04-23  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/mbrtowc.c: New file.
	* mingwex/wcrtomb.c: New file.
	* mingwex/btowc.c: New file.
	* mingwex/wctob.c: New file.
	* mingwex/mb_wc_common.h: New file.
	* mingwex/Makefile.in (DISTFILES): Add new files.
	(Q8_OBJS): Add new objects.
	* include/wchar.h: Adjust comment about mbrtowc() and related
	funcions. Add __restrict__ to pointer params in prototypes.
	(wmemset. wmemchr, wmemcpy, wmemmove, wcstoll, wcstoull): Remove
	arg names from protototypes.

2005-04-23  Wu Yongwei  <adah@sh163.net>

	* mingwex/dirent.c: Formatting changes.
	* mingwex/dirent.c (_topendir): Make the end-of-path slash check
	MBCS-safe.

2005-03-31  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/_mingw.h (__MINGW_ATTRIB_NONNULL): Define.

2005-03-24  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/stdio.h (__mingw_fwrite): Change return value to
	size_t.
	* mingwex/mingw-fseek.c (__mingw_fwrite): Likewise.

2005-03-15  Hans Leidekker  <hans@it.vu.nl>

	* include/malloc.h (_FREEENTRY, _USEDENTRY): Correct defines.

2005-02-25  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/wctype.h (wctrans): Remove _CRTIMP.
	(towctrans): Likewise.
	(wctype): Likewise,

2005-02-25  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/wctype.h: Add comment on wctrans, towctrans, wctype.

2005-02-25  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/wctype.c: New file.
	* mingwex/wctrans.c: New file.
	* mingwex/Makefile.in (DISTFILES): Add wctype.c, wctrans.c.
	* mingwex/Makefile.in (Q8_OBJS): Add wctype.o, wctrans.o.

2005-02-11  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/tchar.h (_tstat64, _tstati64): Add Unicode/ANSI mappings.

2005-02-11  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/assert.h: Remove header guard. #undef assert macro.
	(_assert): Use __MINGW_ATTRIB_NORETURN define.

2005-02-11  Gregory W. Chicares  <chicares@cox.net>

	* include/math.h (expm1, expm1f, expm1l): Add prototypes.
	* mingwex/Makefile.in (MATH_DISTFILES): Add expm1.c,
	expm1f.c, expm1l.c.
	(MATH_OBJS): Add expm1.o, expm1f.o, expm1l.o.
	* mingwex/math/expm1.c: New file.
	* mingwex/math/expm1f.c: New file.
	* mingwex/math/expm1l.c: New file.

2005-02-07  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/sys/stat.h (struct stat): Guard with _NO_OLDNAMES.
	* include/wchar.h (struct stat): Likewise.
	Bug reported to Debian by Anand Kumria <wildfire@progsoc.org>

	* include/sys/stat.h: Remove empty __STRICT_ANSI__ guard.

2005-02-01  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/strtold.c (__asctoe64): Set endptr to 'e' if exponent
	string is not valid.

2005-01-26  Oliver Stoeneberg  <oliverst@online.de>

	* include/malloc.h: Add missing return code defines for
	_heapwalk()

2005-01-17  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/sys/stat.h (struct __stat64): Change st_size type to
	 __int64.
	* include/wchar.h (struct __stat64): Change st_size type to __int64.

2005-01-13  Earnie Boyd  <earnie@users.sf.net>

	* include/sys/stat.h (_S_IFLNK, S_IFLNK, _S_ISLNK, S_ISLNK, _lstat,
	lstat): Remove.
	* include/errno.h (ELOOP): Ditto.
	* include/_mingw.h: Increment version to 3.7.
	* Makefile.in: Ditto.

2005-01-11  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/tchar.h (_tfreopen): Add UNICODE mappings.

2005-01-11  Earnie Boyd  <earnie@users.sf.net>

	* include/sys/stat.h (_S_IFLNK, S_IFLNK, _S_ISLNK, S_ISLNK, _lstat,
	lstat): Conditionalize defines for __STRICT_ANSI__.

2005-01-10  Earnie Boyd  <earnie@users.sf.net>

	* include/errno.h (ELOOP): Add definition.

2005-01-10  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/complex/(cabsl.c cacosl.c cacoshl.c cargl.c casinl.c
	casinhl.c catanl.c catanhl.c ccosl.c ccoshl.c cexpl.c cimagl.c
	clogl.c cpowl.c cprojl.c creall.c csinl.c csinhl.c csqrtl.c
	ctanl.c ctanhl.c): New files.
	* mingwex/Makefile.in (COMPLEX_DISTFILES): Adjust.
	(COMPLEX_OBJS): Adjust.
	* include/complex.h (cabsl, cacosl, cacoshl, cargl, casinf.
	casinhl, catanl, catanhl, ccosl, ccoshl, cexpl, cimagl, clogl,
	cpowl, cprojl, creall, csinl, csinhl, csqrtl, ctanl, ctanhl):
	Declare.

2005-01-06  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/_mingw.h (__int16): Define as short.
	Thanks to: Leo Yuriev <leoyuriev at users dot sf dot net>

2005-01-06  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/stdio.h (P_tmpdir): Add define.

2005-01-03  Earnie Boyd  <earnie@users.sf.net>

	* Makefile.in (inst_docdir): For Cygwin target set to share/doc/.

2005-01-02  Earnie Boyd  <earnie@users.sf.net>

	* include/_mingw.h: Increment version to 3.6
	* Makefile.in: Ditto

2004-12-26  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/complex/(cabsf.c cacosf.c cacoshf.c cargf.c casinf.c
	casinhf.c catanf.c catanhf.c ccosf.c ccoshf.c cexpf.c cimagf.c
	clogf.c cpowf.c cprojf.c crealf.c csinf.c csinhf.c csqrtf.c
	ctanf.c ctanhf.c): New files.
	* mingwex/Makefile.in (COMPLEX_DISTFILES): Adjust.
	(COMPLEX_OBJS): Adjust.
	* include/complex.h (cabsf, cacosf, cacoshf, cargf, casinf.
	casinhf, catanf, catanhf, ccosf, ccoshf, cexpf, cimagf, clogf,
	cpowf, cprojf, crealf, csinf, csinhf, csqrtf, ctanf, ctanhf):
	Declare.

2004-12-20  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/wchar.h (wcsdup): Correct prototype.
	* include/string.h (wcsdup): Correct prototype.

2004-10-14  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/sys/stat.h: Make S_ISLNK comment comply with ISO C90.

2004-10-07  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/math/fastmath.h: New file.
	* mingwex/math/asinh.c: New file.
	* mingwex/math/asinhf.c: New file.
	* mingwex/math/asinhl.c: New file.
	* mingwex/math/acosh.c: New file.
	* mingwex/math/acoshf.c: New file.
	* mingwex/math/acoshl.c: New file.
	* mingwex/math/atanh.c: New file.
	* mingwex/math/atanhf.c: New file.
	* include/math.h (asinh, asinhf, asinhl, acosh, acoshf, acoshl,
	atanh, atanhf, atanhl): Add prototypes.
	* mingwex/Makefile.in (MATH_OBJS): Add objects for above to list.
	(MATH_DISTFILES): Add sources for above and fastmath.h to list.
	Specify dependency on fastmath.h for new objects.

2004-09-08  Earnie Boyd  <earnie@users.sf.net>

	* include/sys/stat.h (_S_IFLNK): Add definition.
	(S_IFLNK) Ditto.
	(_lstat) Ditto.
	(lstat) Ditto.
	(_S_ISLNK) Recode.
	(S_ISLNK) Ditto.

2004-09-08  Earnie Boyd  <earnie@users.sf.net>

	* include/sys/stat.h (_S_ISLNK): Add definition.
	(S_ISLNK): Ditto.

2004-09-05  Earnie Boyd  <earnie@users.sf.net>

	* include/_mingw.h: Increment minor version for 3.5 release.
	* Makefile.in: Ditto.
	* mingwex/Makefile.in: Correct typo in list of DISTFILES.

2004-08-24  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/malloc.h (__mingw_aligned_offset_malloc,
	__mingw_aligned_offset_realloc, __mingw_aligned_malloc,
	__mingw_aligned_realloc, __mingw_aligned_free): Add
	prototypes.
	* mingwex/Makefile.in (DISTFILES): Add mingw-aligned-malloc.c,
	tst-aligned-malloc.c.
	(REPLACE_OBJS): Add mingw-aligned-malloc.o.

2004-08-24  Steven G. Johnson  <stevenj@alum.mit.edu>

	* mingwex/mingw-aligned-malloc.c: New file.
	* mingwex/tst-aligned-malloc.c: New file.

2004-08-24  Danny Smith  <dannysmith@users.sourceforge.net>

	* crt1.c: (__mingw_CRTStartup): Change return to void. Add
	noreturn attribute. Align stack to 16 bytes before passing args
	to main.
	(mainCRTStartup): Change return to void.
	(WinMainCRTStartup): Likewise.

2004-08-15  Danny Smith  <dannysmith@users.sourceforge.net>

	* profile/COPYING: New file.
	* profile/CYGWIN_LICENSE: New file.
	* profile/Makefile.in (DISTFILES): Add COPYING, CYGWIN_LICENSE.

2004-08-15  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/fopen64.c: Move.
	* mingwex/fseeko64.c: Move.
	* mingwex/ftello64.c: Move.
	* mingwex/lseek64.c: Move.
	* mingwex/stdio/fopen64.c: To here.
	* mingwex/stdio/fseeko64.c: To here.
	* mingwex/stdio/ftello64.c: To here.
	* mingwex/stdio/lseek64.c: To here.

2004-08-15  Danny Smith  <dannysmith@users.sourceforge.net>

	* profile/gmon.c [__MINGW32__]: Include string.h for
	memset prototype.

2004-08-08  Christopher Faylor  <cgf@timesys.com>

	* mingwex/stdio/vwscanf.c: Add stdio.h needed after 2004-08-07 change.

2004-08-07  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/complex.h: Remove __attribute__ ((const)) from
	transcendantal and trig functions. Replace __attribute__ ((const))
	with __MINGW_ATTRIB_CONST on other declarations.

2004-08-07  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/wchar.h: Reorganize, avoid including other headers.

2004-08-07  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/string.h (memchr, memcmp, strchr, strcmp, strcspn)
	(strlen, strncmp, strpbrk, strrchr, strspn, strstr): Add pure
	attribute.

2004-07-30  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/dirent.h (struct _wdirent): Remove obsolete comment.

2004-07-30  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/string.h: Revert 2004-07-26 additions of
	__ATTRIBUTE_PURE.

2004-07-28  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/math/powl.c (powl): Revert change of 2004-02-01.
	(__convert_inf_to_maxnum): New.static inline.
	(reducl): Use it to protect against Inf - Inf.
	(__fast_ldexpl): New function. Use in lieu of ldexpl.

2004-07-27  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/math/expl.c (expl): Move body of code to new static
	function __expl, removing tests for +/-Inf. Extern function
	expl calls __expl after testing for max, min log thresholds.

2004-07-26  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/stdio/vsscanf.c: Add "edi" to registers-modified field
	* mingwex/stdio/vfscanf.c: Likewise.
	* mingwex/stdio/vswscanf.c: Likewise.
	* mingwex/stdio/vfwscanf.c: Likewise.

2004-07-26  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/_mingw.h: Use only two underscores to uglify
	__MINGW_ATTRIB_* macros.
	* include/stdlib.h: Adjust __MINGW_ATTRIB_* tokens.
	* include/setjmp.h: Likewise.

	* include/sting.h: Add __MINGW_ATTRIB_PURE to locale-independent
	string functions.
	(_strdup, strdup): Add __MINGW_ATTRIB_MALLOC.

2004-07-25  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/string.h: Group wide string functions together,
	and protect with _WSTRING_DEFINED.

2004-07-25  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/_mingw.h (__MINGW_ATTR_*): Replace with
	__MINGW_ATTRIB_*.
	* include/stdlib.h (_ATTRIB_NORETURN): Replace with
	__MINGW_ATTRIB_NORETURN, throughout.
	(malloc): Declare with __MINGW_ATTRIB_MALLOC.
	(calloc): Likewise.
	(abs): Declare with __MINGW_ATTRIB_CONST.
	(labs): Likewise.
	(div): Likewise.
	(ldiv): Likewise.
	(lldiv): Likewise.
	(_rotl): Likewise.
	(_rotr): Likewise.
	(_lrotl): Likewise.
	(_lrotr): Likewise.
	* include/setjmp.h (longjmp): Add __MINGW_ATTRIB_NORETURN.

2004-07-21  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/_mingw.h: Undefine __attribute__.
	(__MINGW_ATTR_NORETURN): New define.
	(__MINGW_ATTR_CONST): New define.
	(__MINGW_ATTR_MALLOC): New define.
	(__MINGW_ATTR_PURE): New define.
	(_CRTIMP, __cdecl, __stdcall, __UNUSED_PARAM): Ansi-fy
	expansions.

2004-07-19  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/time.h (__time64_t): Add missing ';'.

2004-07-17  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/time.h (wcsftime): Move out of !__STRICT_ANSI__ block.
	(struct tm): Protect with _TM_DEFINED.

2004-07-17  Christopher Faylor  <cgf@timesys.com>

	* Makefile.in (CC): Strip inappropriate include file settings from any
	passed-in CC.

2004-07-15  "dgun"  <dgun@umpire.com>

	* include/complex.h (conj): Correct typo in prototype.

2004-07-15  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/math.h: Add pragma GCC system_header.

2004-07-15  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/complex/carg.c: New file.
	* mingwex/Makefile.in: Really add carg.o to libmingwex.a.

2004-07-15  Corinna Vinschen  <corinna@vinschen.de>

	* Makefile.in (INCLUDES): Temporarily revert previous change.
	* mingwex/Makefile,in (INCLUDES): Ditto.
	* profile/Makefile,in (INCLUDES): Ditto.
	* mingwex/Makefile,in: Drop carg.o dependency.

2004-07-14  Christopher Faylor  <cgf@timesys.com>

	* mingwex/fwide.c: Include <stdio.h> to resolve FILE usage.

2004-07-14  Danny Smith  <dannysmith@users.sourceforge.net>

	* Makefile.in (INCLUDES): Designate $(srcdir)/../include as a
	system dir.
	* mingwex/Makefile,in (INCLUDES): Ditto.
	* profile/Makefile,in (INCLUDES): Ditto.

	* mingwex/Makefile,in: Add carg.o to libmingwex.a.

2004-07-13  Earnie Boyd  <earnie@users.sourcefourge.net>

	* Makefile.in: Move use of --nostdinc++ as GCC3.4 warns to use it
	for C modules.
	* mingwex/Makefile.in: Ditto.
	* profile/Makefile.in: Ditto.
	* include/limits.h: Change to new file header preamble.
	* include/_mingw.h: Increment minor version for 3.4 release.
	* Makefile.in: Ditto.

2004-07-12  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/math/cephes_emath.h (__etens): Remove declaration.

2004-07-11  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/unistd.h (ftruncate): Add inline definition.
	* mingwex/ftruncate.c: New file.
	* mingwex/Makefile.in: Add ftruncate.o to libmingwex.a.

2004-07-10  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/time.h: Do not include sys/types.h.

2004-07-02  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/Makefile.in (MATH_DISTFILES): Remove pow.c,
	(MATH_OBJS): Remove pow,o.
	* include/math.h (pow): Declare with _CRTIMP.
	Add comment on how to avoid excess precision problems.

2004-06-30  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/stdio.h (__mingw_fseeko64): Add prototype.
	* mingwex/mingw-fseek.c (__mingw_fseeko64): Add definition.
	(__mingw_fwrite): Handle huge files.

2004-06-30  Kees Zeelenberg  <kzlg@users.sourceforge.net>
	  Danny Smith <dannysmith@users.sourceforge.net>

	* include/stdio.h (fopen64): Add inline function.
	(fseeko64): Add prototype.
	(ftello64): Add inline function.
	* include/io.h (lseek64): Add inline function.
	* include/sys/types (off64_t): Add typedef.
	(fpos64_t): Add typedef.
	* mingwex/fopen64.c: New file.
	* mingwex/fseeko64.c: New file.
	* mingwex/ftello64.c: New file.
	* mingwex/lseek64.c: New file.
	* mingwex/Makefile.in (STDIO_DISTFILES): Add fopen64.c,
	fseeko.64.c, ftello64.c, lseek64.c.
	(STDIO_OBJS): Add fopen64.o, fseeko.64.o, ftello64.o, lseek64.o.

2004-04-24  Luke Dunstan  <infidel@users.sourceforge.net>

	* include/limits.h (_I64_MIN, _I64_MAX, _UI64_MAX): Add defines.

2004-04-22  Earnie Boyd  <earnie@users.sf.net>

	* DISCLAIMER: Add words about "free to use".
	* README: Modify "Win32 runtime" to "Microsoft C Runtime".
	* Makefile.in (SRCDIST_FILES): Add DISCLAIMER and CONTRIBUTORS.
	(inst_docdir): New variable.
	(INSTDOCS): Ditto.
	(FLAGS_TO_PASS): Include inst_docdir.
	(install-dirs): Add inst_docdir.
	(install): Add loop for INSTDOCS.
	* strncasecmp.c: Reword copyright and disclaimer. Move Contributors
	section to CONTRIBUTORS file. Remove RCS tags.

2004-04-22  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/math/lround.c: Rewrite.
	* mingwex/math/lroundf.c: Rewrite.
	* mingwex/math/lroundl.c: Rewrite.
	* mingwex/math/llround.c: Rewrite.
	* mingwex/math/llroundf.c: Rewrite.
	* mingwex/math/llroundl.c: Rewrite.

2004-04-20  Earnie Boyd  <earnie@users.sf.net>

	* CONTRIBUTORS: New file.
	* DISCLAIMER: Ditto.
	* CRT_noglob.c: Reword copyright and disclaimer. Move Contributors
	section to CONTRIBUTORS file. Remove RCS tags.
	* CRTFmode.c: Ditto.
	* CRTglob.c: Ditto.
	* CRTinit.c: Ditto.
	* crt1.c: Ditto.
	* crtdll.dev: Ditto.
	* dllcrt1.c: Ditto.
	* dllmain.c: Ditto.
	* gccmain.c: Ditto.
	* init.c: Ditto.
	* isascii.c: Ditto.
	* iscsym.c: Ditto.
	* iscsymf.c: Ditto.
	* jamfile: Ditto.
	* main.c: Ditto.
	* msvcrt.def.in: Ditto.
	* strcasecmp.c: Ditto.
	* toascii.c: Ditto.
	* wcscmpi.c: Ditto.
	* include/assert.h: Ditto.
	* include/conio.h: Ditto.
	* include/ctype.h: Ditto.
	* include/direct.h: Ditto.
	* include/dirent.h: Ditto.
	* include/dos.h: Ditto.
	* include/errno.h: Ditto.
	* include/excpt.h: Ditto.
	* include/fcntl.h: Ditto.
	* include/float.h: Ditto.
	* include/io.h: Ditto.
	* include/locale.h: Ditto.
	* include/malloc.h: Ditto.
	* include/math.h: Ditto.
	* include/process.h: Ditto.
	* include/setjmp.h: Ditto.
	* include/share.h: Ditto.
	* include/signal.h: Ditto.
	* include/stdio.h: Ditto.
	* include/stdlib.h: Ditto.
	* include/string.h: Ditto.
	* include/tchar.h: Ditto.
	* include/time.h: Ditto.
	* include/wchar.h: Ditto.
	* include/sys/locking.h: Ditto.
	* include/sys/param.h: Ditto.
	* include/sys/stat.h: Ditto.
	* include/sys/timeb.h: Ditto.
	* include/sys/types.h: Ditto.
	* include/sys/utime.h: Ditto.
	* mingwex/dirent.c: Ditto.

2004-04-19  Earnie Boyd  <earnie@users.sf.net>

	* include/_mingw.h: Revert to primary release 3 and increment minor
	release to 3.
	* Makefile.in (VERSION): Ditto.

2004-04-01  Danny Smith  <dannysmith@users.sourceforge.net>

	* crt1.c (_mingw32_init_fmode): Set *_imp___fmode_dll to
	_fmode if not __MSVCRT__.

2004-03-30  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/io.h: (_findfirst): Correct prototype.

2004-03-30  Hans Leidekker  <hans@it.vu.nl>

	* include/io.h: (_findnext, _findclose): Correct prototype.

2004-03-28  Hans Leidekker  <hans@it.vu.nl>

	* include/math.h (FP_*): Add defines.

2004-03-29  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/math/round.c: Rewrite.
	* mingwex/math/roundf.c: Rewrite.
	* mingwex/math/roundl.c: Rewrite.

2004-03-25  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/_mingw.h (__MSVCRT_VERSION__): Define default as 0x0600.
	* include/time.h (__time64_t): Add typedef.
	(_mktime64): Add prototype for __MSVCRT_VERSION__ >= 0x0601.
	(_ctime64): Likewise.
	(_wctime64): Likewise.
	(_gmtime64): Likewise.
	(_localtime64): Likewise.
	(wcsftime): Move into _WTIME_DEFINED block.
	Regroup non-ANSI prototypes.
	* include/io.h: Include <stdint.h>.
	(__finddata64_t): Add struct definition.
	(__wfinddata64_t): Likewise.
	(_findfirst64): Add prototype for __MSVCRT_VERSION__ >= 0x0601.
	(_findnext64): Likewise.
	(_wfindfirst64): Likewise.
	(_wfindnext64): Likewise.
	* include/sys/timeb.h (__timeb64): Add struct definition.
	(_ftime64): Add prototype for __MSVCRT_VERSION__ >= 0x0601.
	* include/sys/utime.h (__utimbuf64): Add struct definition.
	(_utime64): Add prototype for __MSVCRT_VERSION__ >= 0x0601.
	(_futime64): Likewise.
	(_wutime64): Likewise.
	* include/sys/stat.h (__stat64): Add struct definition.
	(_fstat64): Add prototype for __MSVCRT_VERSION__ >= 0x0601.
	(_stat64): Likewise.
	(_wstat64): Likewise.
	* include/sys/types.h (__time64_t): Add typedef.
	* include/wchar.h (__wfinddata64_t): Add structure definition.
	(__stat64): Likewise.
	(_wctime64): Add prototype for __MSVCRT_VERSION__ >= 0x0601.
	(_wfindfirst64): Likewise.
	(_wfindnext64): Likewise.
	(_wutime64): Likewise.
	(_wstat64): Likewise.
	* include/malloc.h (_aligned_free): Add prototype for
	__MSVCRT_VERSION__ >= 0x0700.
	(_aligned_malloc): Likewise.
	(_aligned_offset_malloc): Likewise.
	(_aligned_offset_realloc): Likewise.
	(_aligned_realloc): Likewise.
	* include/string.h (_wcserror): Add prototype for
	__MSVCRT_VERSION__ >= 0x0700.
	(__wcserror): Likewise.
	* include/math.h (_set_SSE2_enable): Add prototype for
	__MSVCRT_VERSION__ >= 0x0701.

2004-03-25  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/stdio.h (_fsopen): Add prototype.
	* include/tchar.h (_tfsopen): Add defines.
	Thanks to "Gerik" <gerikr at users dot sourceforge dot net>

2004-03-19  Danny Smith  <dannysmith@users.sourceforge.net>

	* msvcrt.def.in: Add stubs for msvcrt.dll (version 6.10),
	msvcr70.dll, and msvcr71.dll.
	* Makefile.in (msvcr*.def): Define preprocessor __msvcr*__ constant
	using basename of output def file.

2004-03-13  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/malloc.h: Remove __STRICT_ANSI__ guard.

2004-03-11  Brian Keener  <bkeener@thesoftwaresource.com>

	* include/process.h: Remove the #endif associated with removal of
	__STRICT_ANSI__ guard from non-ANSI header.

2004-03-10  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/conio.h: Remove __STRICT_ANSI__ guard from non-ANSI header.
	* include/direct.h: Ditto.
	* include/dirent.h: Ditto.
	* include/dos.h: Ditto.
	* include/excpt.h: Ditto.
	* inlude/fcntl,h
	* include/io.h: Ditto.
	* inlude/mem.h: Ditto.
	* include/memory.h: Ditto.
	* include/process.h: Ditto.
	* inlude/search.h: Ditto.
	* include/share.h: Ditto.
	* include/unistd.h: Ditto.
	* include/sys/fcntl.h: Ditto.
	* include/file.h: Ditto.
	* include/sys/locking.h: Ditto.
	* include/sys/param.h: Ditto.
	* include/sys/stat,h
	* include/sys/time.h: Ditto.
	* include/sys/timeb.h: Ditto.
	* include/sys/types.h: Ditto.
	* include/sys/unistd.h: Ditto.
	* include/sys/utime.h: Ditto.

2004-02-21  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/_mingw.h (__UNUSED_PARAM): Define macro.
	* include/wchar.h (fwide): Use it.
	(mbsinit): Ditto.

2004-02-05  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/getopt.c: Define IS_POSIXLY_CORRECT as per
	NetBSD getopt_long.c.

2004-02-05  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/strtold.c (__asctoe64) Reorganise. Fix setting error
	codes and handling of special chars.

2004-02-02  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/stdio.h (feof): Add inlined definition.
	(ferror): Ditto.

2004-02-01  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/math/ldexpl.c (ldexpl): Call __asm__("fscale")
	directly, rather than via scabnl.

2004-02-01  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/math/powl.c (powl): Return infinity if
	extended precision multiplication of x by log2(y)
	overflows.

2004-01-31  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/math/cephes_emath.h (__enan_64): Fix thinko.
	(__enan_NI16): Fix another one.
	(__enan_NBITS): Tidy.

2004-01-16  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/stdint.h [__STDC_CONSTANT_MACROS]: Fix for 8 and 16 bit
	types. (Thanks to John Maddock for report.)

2004-01-14  Greg Chicares  <chicares@users.sourceforge.net>

	* include/tchar.h (_puttchar): Define.

2003-12-13  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/stdio.h:(_fileno): Define macro version after both
	fileno and _fileno functions declared.

	* include/stdio.h (_rmtmp, rmtmp): Add prototypes.
	* moldnames.def.in (rmtmp) Add stub.

2003-11-27  Dimitry Sibiryakov  <aafemt@users.sourceforge.net>

	* include/signal.h (SIG_SGE, SIG_ACK): Add defines.

2003-10-27  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/math.h: Guard ISO C99 additions with __cplusplus
	not __GLIBCPP__.

2003-10-21  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/_mingw.h: Define __attribute__((x)) to nothing
	if not __GNUC__.

2003-10-21  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/complex.h: New file.
	* mingwex/complex: New directory.
	* mingwex/complex/cabs.c: New file.
	* mingwex/complex/cacos.c: New file.
	* mingwex/complex/cacosh.c: New file.
	* mingwex/complex/casin.c: New file.
	* mingwex/complex/casinh.c: New file.
	* mingwex/complex/catan.c: New file.
	* mingwex/complex/catanh.c: New file.
	* mingwex/complex/ccos.c: New file.
	* mingwex/complex/ccosh.c: New file.
	* mingwex/complex/cexp.c: New file.
	* mingwex/complex/cimag.c: New file.
	* mingwex/complex/clog.c: New file.
	* mingwex/complex/cpow.c: New file.
	* mingwex/complex/cproj.c: New file.
	* mingwex/complex/creal.c: New file.
	* mingwex/complex/csin.c: New file.
	* mingwex/complex/csinh.c: New file.
	* mingwex/complex/csqrt.c: New file.
	* mingwex/complex/ctan.c: New file.
	* mingwex/complex/ctanh.c: New file.
	* mingwex/Makefile.in (COMPLEX_DISTFILES): New list of
	files.
	(dist): Use it.
	(COMPLEX_OBJS): New list of objects.
	(LIB_OBJS): Include it in the library.

2003-10-21  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/math.h (cabs): Remove non-ISO prototype.

2003-10-21  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/math/cephes_mconf.h (NAN, NANF, NANL):
	Use GCC __builtin's if available.
	(INFINITY, INFINITYF, INFINITYL): Likewise.

2003-10-21  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/math/s_erf.c (erf): Set errno to ERANGE if
	beyond approximation limit.
	* mingwex/math/sf_erf.c (erff): Likewise.

2003-10-17  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/stdio.h (getc): Cast result to unsigned char before
	return.
	(putc): Likewise
	(getchar): Likewise.
	(putchar): Likewise.
	Thanks to M.Fujii <boochang@m4.kcn.ne.jp>

2003-10-10  Earnie Boyd  <earnie@users.sf.net>

	* include/_mingw.h: Increment version to 3.2.
	* Makefile.in: Ditto.

2003-10-10  Earnie Boyd  <earnie@users.sourceforge.net>

	* include/sys/types.h: Revert last change.

2003-10-10  Earnie Boyd  <earnie@users.sourceforge.net>

	* include/sys/types.h (ssize_t): Correct the definition.

2003-10-03  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/stdio.h (_filbuf): Add prototype.
	(_flsbuf): Add prototype.
	(getc): Add inline version.
	(putc): Likewise.
	(getchar): Likewise.
	(putchar): Likewise.

2003-10-03  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/dirent.c (_treaddir): Reset errno to 0 if end
	of directory.

2003-09-29  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/stdlib.h: Guard non-ISO functions with
	!__STRICT_ANSI__, throughout.

2003-09-24  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/io.h (_fileno): Remove prototype.
	(fileno): Likewise.
	(FILENAME_MAX): Define, if needed.
	Don't include <stdio.h>.
	* include/stdio.h (FILENAME_MAX): Protect against
	prior definition.
	(_fileno): Define macro implementation.
	(fileno): Likewise.

2003-09-24  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/inttypes.h: Include _mingw.h.

2003-09-24  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/_mingw.h (__CRT_INLINE): Define.
	* include/ctype.h: Replace 'extern inline' with __CRT_INLINE,
	throughout
	* include/inttypes.h: Likewise.
	* include/math.h: Likewise.
	* include/stdio.h: Likewise.
	* include/stdlib.h: Likewise.
	* include/string.h: Likewise.
	* include/wchar.h: Likewise.
	* include/wctype.h: Likewise.

2003-09-22  Roland Schwingel  <rolandschwingel@users.sourceforge.net>

	* mingwex/dirent.c (_topendir): Allocate enough memory for
	DIR struct in UNICODE case too.

2003-09-15  Earnie Boyd  <earnie@users.sf.net>

	* include/_mingw.h: Increment version to 3.2.
	* Makefile.in: Ditto.

2003-07-03  Earnie Boyd  <earnie@users.sf.net>

	* config.guess, config.sub: Update with versions from ftp.gnu.org.

2003-07-03  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/math/trunc.c (trunc): Provide lvalue for memory input constraint.
	* mingwex/math/truncf.c (truncf): Likewise.
	* mingwex/math/truncl.c (truncl): Likewise.
	* mingwex/math/modff.c (modff): Likewise.
	* mingwex/math/modfl.c (modfl): Likewise.

2003-07-03  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/search.h: New file.
	* include/stdlib.h: Add comment about qsort, bsearch in
	search.h.
	* test_headers.c: Include search.h.
	* moldname.def.in (lfind, lsearch): Add.

2003-07-03  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/process.h (_execv, _execvp, _spawnv, _spawnvp, _execve,
	_execvpe, _spawnve, _spawnvpe, execv, execvp, spawnv, spawnvp,
	execve, execvpe, spawnve, spawnvpe): Const-ify all the char params.

2003-07-01  Earnie Boyd  <earnie@users.sf.net>

	* include/_mingw.h (small, hyper): Change to __small and __hyper to
	avoid user space name conflicts.

2003-07-01  Earnie Boyd  <earnie@users.sf.net>

	* include/_mingw.h (__int32, __int16, __int8, small, hyper): Define.
	Note: Also added to w32api/include/basetyps.h.
	* mingwex/math/tgamma.c, tgammaf.c, tgammal.c (small):
	Rename to Small (case difference).

2003-06-18  Earnie Boyd  <earnie@users.sf.net>

	* include/dirent.h (dirent): Make d_name and array instead of a pointer.
	* mingwex/dirent.c: Modifications througout to fill d_name array.
	* Makefile.in (LIBS): Add new MSVCRT libraries libmsvcr70 and
	libmsvcr71, including debug versions.
	(msvcr70.def, msvcr70d.def, msvcr71.def, msvcr71.def): New targets.

2003-06-17  Danny Smith  <dannysmith@users.sourceforge.net>

	* msvcrt.def.in (__badioinfo, __lc_codepage, __lc_handle,
	__pioinfo, __setlc_active, _unguarded_readlc_active, _dstbias):
	Mark as DATA.
	Thanks to: Aaron W LaFramboise  <AWLaFramboise@aol.com>

2003-05-30  Sascha Sommer  <saschasommer@freenet.de>

	* include/sys/types.h (_ssize_t, ssize_t): Add typedefs.

2003-05-15  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/stdlib.h (_Exit): Move out of __STRICT_ANSI__ block,
	but still protect inline definition with __STRICT_ANSI__.

2003-05-14  Danny Smith  <dannysmith@users.sourceforge.net>

	* string_old.c: Remove, splitting into...
	* strcasecmp.c: New file.
	* strncasecmp.c: New file.
	* wscmpi.c : New file.
	* ctype_old.c: Remove, splitting into...
	* isascii.c: New file.
	* iscsym.c: New file.
	* iscsymf.c: New file.
	* toascii.c: New file.
	* Makefile.in (MOLD_OBJS): Adjust.
	(SRCDIST_FILES): Adjust.

2003-05-13  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/math.h (fabs) : Remove inline definition.
	(fabsf): Likewise.
	(fabsl): Likewise.

2003-05-06  Earnie Boyd  <earnie@users.sf.net>

	* include/_mingw.h: Change version to 3.0
	* Makefile.in: Ditto.

2003-05-06  Earnie Boyd  <earnie@users.sf.net>

	* configure.in (W32API_INCLUDE): Need the -I switch in the value.
	* mingwex/configure.in (W32API_INCLUDE): Ditto.
	* profile/configure.in (W32API_INCLUDE): Ditto.

2003-05-06  Earnie Boyd  <earnie@users.sf.net>

	* configure.in (CFLAGS): Remove -D__USE_CRTIMP=1 due to possibilites
	of multiply defined symbols if the symbols is defined locally. E.G.:
	A local definition of malloc causes this problem.
	* configure: Regenerate.
	* profile/Makefile.in (W32API_INCLUDE): New variable.
	(ALL_CFLAGS): Use W32API_INCLUDE value.
	(ALL_CXXFLAGS): Ditto.
	(gcrt0.o gcrt1.o gcrt2.o): Use ALL_CFLAGS instead of CFLAGS.
	Thanks to Jeff Bonggren <jbon@users.sf.net>.
	* profile/configure.in (W32API_INCLUDE): Set default value.
	* profile/configure: Regenerate.
	* mingwex/Makefile.in (W32API_INCLUDE): New variable.
	(ALL_CFLAGS): Use W32API-INCLUDE value.
	(ALL_CXXFLAGS): Ditto.
	* mingwex/configure.in (W32API_INCLUDE): Set default value.
	* mingwex/configure: Regenerate.

2003-05-05  Earnie Boyd  <earnie@users.sf.net>

	* Makefile.in (W32API_INCLUDE): New variable.
	(ALL_CFLAGS): Use W32API_INCLUDE value.
	(ALL_CXXFLAGS): Ditto.
	* configure.in (CFLAGS): Add -D__USE_CRTIMP=1 to default values.
	(W32API_INCLUDE): Set default value.
	* configure: Regenerate.

2003-04-11  Earnie Boyd  <earnie@users.sf.net>

	* configure.in (LIBM_A): Define for cygwin target.
	* configure (LIBM_A): Ditto.

2003-04-07  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/time.h (strftime): Remove duplicate declaration.

2003-04-01  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/_mingw.h (_CRTIMP): Make conditional on __USE_CRTIMP.

2003-03-16  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/dirent.c (_topendir): Eliminate signed/unsigned warning.
	* mingwex/strtoimax.c (strtoimax): Likewise.
	* mingwex/wcstoimax.c (wcstoimax): Likewise.
	* mingwex/wtoll.c (wtoll): Remove unnecessary ';'
	* mingwex/fesentenv.c: Include float.h.
	* mingwex/math/powl.c: Eliminate type punning/strict aliasing
	warning.
	* mingwex/math/tanhl.c: Eliminate signed/unsigned warning in
	constants.
	* mingwex/math/tgammal.c: Likewise.

2003-03-16  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/utime.h: New file, forwarding to sys/utime.h.

2003-03-16  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/sys/param.h (MAXPATHLEN): Define.

2003-03-16  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/tchar.h: Ansi-fy a comment.

2003-03-16  Danny Smith  <dannysmith@users.sourceforge.net>

	* profile/profile.h (mcount): Use __builtin_return_address
	rather than inline __asm statements.
	* profile/Makefile.in: Remove special rule for mcount.o
	Specify dependencies for mcount.o profil.o gmon.o.

2003-03-10  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/stdlib.h (qsort): Remove const from first parm.
	Thanks to: Tien-Ren Chen <trchen@sourceforge.users.net>

2003-03-03  Christopher Faylor  <cgf@redhat.com>

	* mingwex/getopt.c: Refresh from NetBSD sources.

2003-03-03  Danny Smith  <dannysmith@users.sourceforge.net>

	* mingwex/getopt.c: New file, copied from cygwin srcs.
	* include/getopt.h: New file, copied from cygwin srcs.
	* include/unistd.h: Include getopt.h.
	* mingwex/Makefile.in (DISTFILES): Add getopt.c.
	(POSIX_OBJS): Add getopt.o.

2003-03-02  Danny Smith  <dannysmith@users.sourceforge.net>

	* include/stdio.h (vscanf): Add prototype.
	(vfscanf): Ditto.
	(vsscanf): Ditto.
	(vwscanf): Ditto.
	(vfwscanf): Ditto.
	(vswscanf): Ditto.
	* include/wchar.h (vwscanf): Add prototype.
	(vfwscanf): Ditto.
	(vswscanf): Ditto.
	* mingwex/snprintf.c: Move to mingwex/stdio.
	* mingwex/vsnprintf.c: Ditto.
	* mingwex/snwprintf.c: Ditto.
	* mingwex/vsnwprintf.c: Ditto.
	* mingwex/Makefile.in (VPATH): Add $(srcdir)/stdio
	(STDIO_DISTFILES): Add.
	(DISTFILES): Adjust.
	(STDIO_STUB_OBJS): Rename to STDIO_OBJS and add v*scanf objects.
	(LIB_OBJS): Adjust.
	(dist): Adjust.

2003-03-02  Aaron W LaFramboise  <AWLaFramboise@aol.com>

	* mingwex/stdio: New directory
	* mingwex/stdio/vfscanf.c: New file.
	* mingwex/stdio/vfwscanf.c: New file.
	* mingwex/stdio/vscanf.c: New file.
	* mingwex/stdio/vsscanf.c: New file.
	* mingwex/stdio/vswscanf.c: New file.
	* mingwex/stdio/vwscanf.c: New file.

2003-02-25  Earnie Boyd  <earnie@users.sf.net>

	* Makefile.in (libmsvcrt20.a): Remove target and dependencies.
	(libmsvcrt40.a): Ditto.

2003-02-21  Earnie Boyd  <earnie@users.sf.net>

	Thanks to David Frasier <davidf@sjsoft.com> who inspired portions of
	this patch.
	* Makefile.in (libmsvcrtd.a): Add target library.
	(libmoldnamed.a): Ditto.
	(msvcrt.def, msvcrtd.def, msvcrt20.def, msvcrt40.def): Use msvcrt.def.in
	template to create.
	($(srcdir)): Remove explicit reference for depencies of object targets.
	* moldname.def, moldname-msvcrt.def, moldname-crtdll.def, msvcrt.def,
	msvcrt20.def, msvcrt40.def: Remove.
	* msvcrt.def.in: New file (Copy of previous msvcrt.def).

2003-02-20  Corinna Vinschen  <corinna@vinschen.de>

	* Makefile.in: Make sure libmingwex.a from current build tree is used.

2003-02-14  Christopher Faylor  <cgf@redhat.com>

